2012-08-20  Paolo Tosco <paolo.tosco@unito.it>

	* src/formats/mol2format.cpp: added a check for N.4 nitrogens
	(fixes PR#3557898)

2012-06-09  Paolo Tosco <paolo.tosco@unito.it>

	* src/kekulize.cpp: reverted the r4862 patch to kekulize.cpp;
	the incorrect aromaticity perception of oxonium salts concerned
	only the MOL2 format, so the fix was applied to mol2format.cpp
	instead
	* src/formats/mol2format.cpp: added a check to improve downstream
	aromaticity perception on charged molecules containing oxygen

2012-06-07  Paolo Tosco <paolo.tosco@unito.it>

	* include/openbabel/atom.h: added protos for CountFreeSulfurs() and
	IsThiocarboxylSulfur() functions which are equivalent to
	CountFreeOxygens() and IsCarboxylOxygen() and address
	(di)thiocarboxyl groups
	* src/atom.cpp: added the CountFreeSulfurs() and
	IsThiocarboxylSulfur() functions
	* src/forcefields/forcefieldmmff94.cpp: added some additional
	checks to make MMFF94 atom type assignment more robust
	* src/formats/mol2format.cpp: added some checks to improve downstream
	aromaticity perception on charged molecules containing nitrogen,
	oxygen and sulfur
	* src/kekulize.cpp: added a check to fix incorrect perception of
	aromatic oxonium and thionium cations

2010-10-29  Konstantin Tokarev <annulen@yandex.ru>

	* scripts/CMakeLists.txt: fixed behavior of build system if some of
	JNI dependencies were not found

2010-10-29  Konstantin Tokarev <annulen@yandex.ru>

	* scripts/CMakeLists.txt: added dependency 'openbabel' to target
	'_openbabel' (Python bindings)
	
	On non-Windows platfroms Python module is linked by custom script
	which is not aware of target dependencies. This change fixes parallel
	build

2010-10-24  Jean Brefort  <jean.brefort@normalesup.org>

	* data/space-groups.txt: fixed space group 104 (missing transfoms).

2010-10-14 Jiahao Chen <jiahao@mit.edu>

	* src/charges/qeq.cpp,src/charges/qtpie.cpp: Added documentation.
	* data/qeq.txt: Simplified parameter file format.
	
	There is an upper bound on the screening radius that is constrained by
	the atomic hardness parameter. (These parameters are not entirely
	independent.) If this constraint is violated, i.e. radius * hardness <
	sqrt(2/pi) a.u., then it is possible to get infinite charges for
	certain geometries. For now, the screening radius using the Gaussian
	orbitals (in this code) is taken to be the same as the screening radius
	for Slater orbitals in the original QEq specifications, except when the
	constraint is violated, in which case the radius is reduced to the
	largest possible radius satisfying the constraint. To do this properly,
	a reparameterization of the methods are required, but this should
	suffice for not producing ridiculous charge predictions.

2010-09-30 Chris Morley

	* src/alias.cpp: Use MCDL for expanding aliases in 2D mols, since
	builder seems now only to generate 3D coords. Add dummy connection to
	alias before generating 3D coords to improve geometry, but still not
	quite right for NO2. Fixes #3077897
	
	* src/mcdlutil.cpp: small doc change
	
	* src/config.h.cmake: MSVC build: enable warning on unreferenced
	formal parameters and disable warning on forcing int etc. value 
	to bool 'true' or 'false' (performance warning). Should reduce number
	of warnings.

2010-09-29 Noel O'Boyle

	* src/formats/smilesformat.cpp: Handle cis/trans stereo involving ring
	closures. Handle errors in specifying cis/trans stereo in general and
	involving ring closures.

2010-09-23 Noel O'Boyle

	* src/math/align.cpp, align.h: Add OBAlign::GetRotMatrix()

	* test/aligntest.cpp: Add basic test for GetRotMatrix()

2010-09-23 Chris Morley

	* src/fingerprints/finger2.cpp: generate detailed fragement info
	and output via new DescribeBits function, as suggested by Noel. 
	
	* include/openbabel/fingerprint.h: make Flags interface writeable.
	
	* src/fingerprint.cpp(FastsearchIndexer): set fingerprints
	FPT_NOINFO flag to save time (FP2).  
	
	* src/fingerprints/finger3.cpp,src/formats/fingerprintformat.cpp:
	minor format changes to DescribeBits output.

2010-09-19  Noel O'Boyle

	* src/formats/inchiformat.cpp: Handle atoms with tet chirality due to
	lone pairs.

2010-09-19  Chris Morley

	* src/ops/opisomorph.cpp: As requested by Douglas Houston, -s option
	allows multiple molecules in pattern file (with multiple coloring of
	matching substructures); -v (inverse of -s) now uses the same code
	and has the same capabilities.

2010-09-19  Chris Morley
	
	* src/depict/depict.cpp: correct position and direction of wedge and
	hash bonds. Deduce using TetStereoTo0D. May need further work.
	
	* include/openbabel/depict/painter.h(OBColor): add a few more named
	colors,	color input from rgb hex (like #8dcb70), and a default color,
	in case of typos.

2010-09-19  Chris Morley

	* include/openbabel/obconversion.h: expose Count (the input index)
	 
	* src/ops/addinindex.cpp, src/CMakeLists.txt: add an op to add Count
	to title: --addinindex (Yes, awful names)

	* src/obmolecformat.cpp, src/transform.cpp:
	rename --addindex to --addoutindex.
	
	src/transform.cpp: -v option does nothing if parameter empty.
	(ClassDescription)small documentation changes for -s, -v

2010-09-19  Chris Morley

	* src/stereo/perception.cpp(TetStereoTo0D):fix bug which was truncating
	the loop without examining all possible bonds.
	   
	* include/openbabel/inchiformat.h: correct formating of Description
	so will work with GUI (no \n\n inside option list).
	
	* src/formats/inchiformat.cpp: OBBond instead of OBEdgeBase, which
	was removed a million years ago.
	
2010-09-17  Noel O'Boyle

	* src/math/align.cpp, test/aligntest.cpp: Correct dumb error in
	final line of calculation of RMSD.

2010-09-15  Noel O'Boyle

	* src/builder.cpp: When correcting stereo on rings, handle the case of
	the lone pair. Thanks to Peter Lavin for reporting.

2010-09-15  Noel O'Boyle

	* src/formats/smilesformat.cpp: Handle chiral S with a lone pair in
	the SMILES writer. Fixes PR#3058701. The test cases in the previous
	commit log message should actually be C[S@](=O)Cl, etc. to be
	chemically correct.

2010-09-14  Noel O'Boyle

	* src/formats/smilesformat.cpp: Handle chiral S with a lone pair and
	in general, the situation where a chiral atom has a lone pair.
	Test cases: C[S@](Br)I, [S@](C)(Br)I, C[C@-](Br)I, C[S@](=O)(=O)Cl.

2010-09-14  Noel O'Boyle

	* CMakeLists.txt: As discussed on list, don't build all bindings when
	RUN_SWIG=ON (building some bindings may cause errors). Instead, the
	option ALL_BINDINGS=ON will build all bindings.

2010-09-10  Noel O'Boyle

	* src/formats/pdbqtformat.cpp: Remove "ent" designation as this is
	already used by the .pdb file format.

2010-09-09  Noel O'Boyle

	* scripts/python/pybel_py*.x.py: Synch with cinfony. Add support for
	MCDL 2D coordinate generation when calling 'draw()'. MCDL is the
	default. To use	OASA, specify method="oasa".

2010-09-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/base.h: Add new UNUSED() macro for unused
	parameters.

	* include/openbabel/forcefield.h: Use it.

	* src/kekulize.cpp: Decrease recursion level from 31 to
	24. Prevents some crashing / "infinite" loops on large fused-ring
	systems.

	* src/formats/pdbqtformat.cpp: Add new format from Stuart
	Armstrong, InHiBOx.

	* src/formats/CMakeLists.txt: Ditto.

2010-08-26 Noel O'Boyle

	* src/formats/mdlformat.cpp: Chris beat me to one fix (see below), but
	I also added code to handle unspecified cis/trans stereo
	* test/testsym.cpp: Correct test results and add some new ones for the
	-as option (with 0D MDL).

2010-08-26 Chris Morley

	* src/depict/depict.cpp(DrawMolecule): fix so works with empty molecules
	* src/formats/gamessukformat.cpp: fix typo
	* src/formats/mdlformat.cpp: -as needs OBConversion::INOPTIONS
	* src/obmolecformat.cpp: make -C option work again

2010-08-24  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/generic.h, src/generic.cpp: Improve on
	functionality for OBOrbitalData -- including convenience functions
	for loading lists of orbital energies.

	* src/formats/gamessformat.cpp: Use it (closed-shell
	calculations for now).

	* src/formats/gaussformat.cpp: Grab new "z-matrix orientation"
	coordinates given sometimes by Gaussian 09. Also add some
	OBOrbitalData support.

2010-08-24 Chris Morley

	* src/format/mdlformat.cpp: add -aP format to read only title
	and properties only. Speeds up filtering of sdf datasets based on
	their properties.

	* src/ops/opisomorph.cpp: "extract" parameter on -s option to
	retain only matched atoms. Useful for preparing templates for
	--gen2D

	* src/alias.cpp(FormulaParse): return false when lower case letter
	encountered. Reduce chance of misinterpretation in this backstop
	function.

	* src/depict/depict.cpp: output D and T

	* src/formats/gaussformat.cpp: fix bug with diatomics looking for
	"Rotational Constants" when ther is only one.

	* windows-vc2008/Distribution/NSISScriptToCreateInstaller.nsi:
	put shortcut to babel guide to http://baoilleach.webfactional.com
	for the time being.

2010-08-23 Noel O'Boyle

	* src/formats/mdlformat.cpp: Make the "s" option work by resurrecting
	some old code I had written and then subsequently removed. Atom
	parities will now be used for 0D structures, but only if "s" is
	specified.

2010-08-23 Noel O'Boyle

	* include/openbabel/stereo/stereo.h, perception.cpp: Add doxygen docs
	for TetStereoTo0D and change return value to bool.

2010-08-23  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/data.cpp (GetAtomicNum): Handle "Hl" hydrogen label from CIF
	PR#3048959. Add warning when an unknown element label is provided.

	* src/parsmart.cpp, include/openbabel/parsmart.h: Add thread-safe
	SMARTS matching API, PR#3949927, thanks to David Koes.

	* src/formats/mol2format.cpp: Disable tellg/seekg forwarding,
	which is very slow with gzip-compressed mol2.gz
	files. PR#3048758.

	* src/formats/outformat.cpp: Handle new GAMESS-US/WinGAMESS output
	files.

	* src/kekulize.cpp: Add deeper recursion for aromaticity/kekule
	determination. Solves a number of semi-rare molecules with 6+
	fused 6-membered rings.

	* test/files/forcefield.sdf: Fix Esomeprazole molecule -- not
	protonated. This caused an impossible aromatization issue.

	* test/files/*results.txt: Regenerate forcefield results.

2010-08-22 Noel O'Boyle

	* scripts/CMakeLists.txt: Should have been using STREQUAL
	not EQUAL when comparing strings. The Ruby bindings (among
	others) were not being installed to the correct location.

2010-08-22 Chris Morley

	It's a bit late for new features but the value of this one
	shows up when writing command-line documentation.
	* include/openbabel/obconversion.h, src/obconversion.cpp
	(FullConvert,OpenAndSetFormat):	When file name starts with -:
	it is treated as SMILES and put in a stringstream rather being
	used to open a ifstream.

	* tools/obabel.cpp: pass through files starting with "-:", e.g.
	    obabel -:CN2C(=O)N(C)C(=O)C1=C2N=CN1C -ocan
	Multiple use also possible. Not enabled in babel, but could be.

	* src/obconversion.cpp: Comment out line end buffer deletion,
	so cml conversion works but still have memory leak.

2010-08-19 Noel O'Boyle

	* scripts/CMakeLists.txt: Get rid of return() statements by
	reorganising logic. The way it was, if there was a problem
	with the Python bindings, it would never make it to the
	Java bindings, etc.

	Now each set of bindings has two 'if' statements: the first
	decides whether or not to try to compile the bindings; the second
	actually does it (running SWIG if requested beforehand).

2010-08-19 Chris Morley

	* windows-vc2008/Distribution/NSISScriptToCreateInstaller.nsi:
	add the forgotten DLLs. Seems ok on XP but uninstall leaves some
	folders in Windows 7.

2010-08-18 Chris Morley

	* src/formats/fastsearchformat.cpp: make work with deprecated -S option
	(-s is now an op and op names are case insensitive).
    
	* tools/obabel.cpp: catch error when output specification missing
	Remove messageSummary, which is really needed only when debugging.
	Still in babel.
	 
    * src/formats/svgformat.cpp: small description change

2010-08-18  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/xyzformat.cpp (OpenBabel): Add parsing of 5th column
	as partial charge -- supported by Jmol and others.

2010-08-18 Tim Vandermeersch

	* include/openbabel/isomorphism.h, src/isomorphism.cpp: Use VF2
	algortihm for finding isomorphisms and set this as default algorithm.
	The class performes good enough for general purpose now and is
	comparable in speed with the current smarts matching algortihm.

	* include/openbabel/query.h, src/query.cpp: Make sure aromaticity is
	handled correctly.

	* test/automorphismtest.cpp, test/isomorphismtest.cpp: Add some more
	tests.

2010-08-16 Chris Morley

	* include/openbabel/math/vector3.h,src/math/vector3.cpp: add new
	function, Point2Line()

	* windows-vc2008/Distribution/NSISScriptToCreateInstaller.nsi: mods
	to make help file local, add java bindings. Version 2.3.0rc

	* doc/OpenBabelGUI.html, windows-vc2008/Distribution/ToolsPrograms.txt,
      src/ops/xout.cpp,src/ops/partialcharges.cpp: documentation updates

2010-08-16 Noel O'Boyle

	* include/openbabel/math/vector3.h: The components of a vector3 were
	unaccessible from Python, so I've added GetX(), GetY() and GetZ(). The
	exisintg x() method returns a reference to _vx (i.e. a pointer) and so
	couldn't be used from Python.

2010-08-13 Chris Morley

	* tools/obabel.cpp: by its design obabel cannot use multiple
	concatenated single-character options. Ensure single ones with
	an unregistered number of parameters work correctly.

	* src/formats/fastsearchformat.cpp: extra error handling

2010-08-13 Chris Morley

	* src/formats/inchiformat.cpp(ReadMolecule):Use GetStructFromINCHI
	and not GetStructFromStdINCHI so can read both standard and
	non-standard InChIs. Make error handling more robust.

2010-08-13 Noel O'Boyle

	* src/mol.cpp: HasHydrogens() never returned True as the flag was
	being cleared in AddHydrogens(). Reported by Alex Henderson on
	openbabel-devel. Now fixed.

2010-08-13 Noel O'Boyle

	* src/forcefield.cpp: Fixed a problem with invalid pointers in
	WeightedRotorSearch that was resulting in weird geometries. I think I
	introduced this problem back in May. Also noticed that the final
	conformer returned had an off-by-one error. I think I also introduced
	this problem at the same time.

2010-08-12 Chris Morley

	* src/ops/opisomorph.cpp: make more robust to errors like a missing
	file.

	* src/descriptor.cpp: allow descripor parameters to be in quotes.

	* src/formats/mdlformat.cpp: change the new -at option to -aT
	because	FastSearchFormat already uses -at.

	* src/ops/xout.cpp, src/GUI/OBGUI.cpp: change the name of the op
	xout to 0xout so that it is executed before other ops.

	* src/GUI/optswx.cpp(SetOptions): ignore entries with both
	checkbox and editboxes unless checked.

2010-08-12 Noel O'Boyle

	* src/stereo/perception.cpp: CisTransFrom3D was not able to handle
	deviations from ideal angles. Replaced existing method with one based
	on the signed distance to the plane through the double bond at right
	angles to the stereo unit.

	* src/math/vector3.cpp, vector3.h: Move body of Point2Plane into new
	function Point2PlaneSigned. Point2Plane now just returns
	fabs(Point2PlaneSigned).

2010-08-09 Chris Morley

	* src/formats/gaussformat.cpp:Comment out inconsistent use of
	OBMol::SetEnergy(double).

	The use of this needs to be agreed.

2010-08-10 Tim Vandermeersch

	* include/openbabel/rotor.h, src/rotor.cpp: Add method to fix bonds
	and mark fix atoms as deprecated. Update documentation.

	* include/openbabel/conformersearch.h, src/conformersearch.cpp: Use
	OBAlign with symmetry and update documentation.

	* test/rotortest.cpp: Some OBRotor and OBRotorList unit tests.

2010-08-10  Noel O'Boyle

	* src/builder.cpp, include/openbabel/builder.h: Add a Set/Unset method
	for keeprings. This allows the user to keep the ring conformation from
	the input molecule (this only makes sense if it's a 3D structure to
	begin with).

2010-08-09 Chris Morley

	* src/mcdlutil.cpp: fix to bug #3041650 (2D coordinates with
	disconnected molecules), provided by Sergei Trepalin.

2010-08-09  Noel O'Boyle

	* test/aligntest.cpp: Enable all parts of the alignment test
	* src/math/align.cpp, include/openbabel/math/align.h: Use Tim's work
	on masked isomorphisms. Small speedups in caching and matrix code.

	All of the alignment tests now pass and do so quickly.

2010-08-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/CMakeLists.txt: Patch from Wayne Volkmuth to fix use of
	PYTHON_PREFIX PR#3038634.

	* scripts/openbabel-csharp.i: Fixed moduleclass error broken with
	upgrade to SWIG 2.0.0.

	* src/formats/moldenformat.cpp: Add "molf" extension found with
	some example files.

2010-08-03 Chris Morley

	* src/ops/opisomorph.cpp:-s replacement. Is used instead of
	original in transform.cpp. Takes a SMARTS string as before,
	but also a molecule file when the matching is done by Tim's
	new isomorphism code which is less restrictive, e.g. bug#3029478
	Also will color the substructure, mainly for svgformat.

	* src/CMakeLists.txt: add the above file

	* src/formats/fastsearchformat.cpp: rearraged to use the new -s
	as the main target specification.

2010-08-03  Noel O'Boyle

	* include/openbabel/generic.h: Don't clone OBRingData when copying a
	molecule. If you do, you'll end up with two RingDatas because one will
	already exist due to Kekulize() in EndModify() in operator= in OBMol.
	Having more than one RingData causes problems as one can become
	invalid.

2010-08-02 Chris Morley

	* include/openbabel/obmolecformat.h,src/obmolecformat.cpp
	(WriteChemObjectImpl) move the option implementation to a
	separate function so that it can be used externally...

	* src/formats/svgformat.cpp: ...like here.

2010-08-02 Chris Morley

	* src/descriptors/filters.cpp: add new formula descriptor

	* src/transform.cpp: remove --addformula, use --append formula
	  Make -s option do nothing if parameter is empty.

	* src/obmolecformat.cpp: add --addindex

	* src/parsmart.cpp:add onceOnly to SMARTS error

2010-08-02 Chris Morley

	* include/openbabel/obconversion.h,include/openbabel/op.h,
	include/openbabel/plugin.h,src/plugin.cpp,src/obconversion.cpp:
	added some extra documentation on the OBPlugin concept and options
	as suggested by Hans deWinter

	* doc/examples/obfingerprint_getfingerprint.cpp: added an
	example file

	I haven't got doxygen working yet on my computer (do we really need
	latex?) so the formatting of the above may need attention.

2010-08-01 Chris Morley

	* data/svgformat.script: make zoom work with Chrome

	* src/formats/svgformat.cpp: Make using internal color data the
	default.
	Use "sans-serif" as the font. Improves appearance in Opera.

2010-07-30 Chris Morley

	* tools/obabel.cpp, tools/babel.cpp: allow e.g. '-L formats cml'
	in addition to '-L cml' to handle cases where the same name is used
	for two plugins of different types.

	* src/GUI/OBGUI.cpp: now menu always returns details of plugin of
	the correct type.

2010-07-30  Noel O'Boyle

	* CMakeLists.txt, src/CMakeLists.txt: Add test for libdl. Now compiles
	under FreeBSD (and hopefully the others too). Thanks to Florian Nigsch
	for a build machine.

2010-07-30  Noel O'Boyle

	* scripts/openbabel-python.i: Revert of r3914 (presumably it was a
	mistake to include this file in the commit)

2010-07-29  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/smilesformat.cpp: Add detection for single-character
	"bracket" elements, e.g., [n] for a fall-back. Fixes one failure
	from sdfcansmi unit test.

	* include/openbabel/chargemodel.h: Improved documentation, added
	method to retrieve dipole moment (with scaling).

	* src/charges/*: Add scaling factors calculated from regression
	across NCI, Zinc, and other subsets (~1000 molecules).

2010-07-29  Noel O'Boyle

	* include/openbabel/rotor.h: Fix memory leak in AddRotor

2010-07-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* test/sdfcansmitest.cpp: Added new unit test suggested by TJ
	O'Donnell to check for canonical SMILES consistency from a
	SDFile. Currently shows 4 / 48 failures.

2010-07-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* tools/CMakeLists.txt: Only link getopt.c if needed. Removes
	warnings from Clang and GCC about strlen on non-glibc platforms
	(e.g. Mac).

	* scripts/openbabel-python.i: Add chargemodel to Python bindings.

	* src/mol.cpp (AddHydrogens): Fix crashes exposed by
	buildertest. Make sure to clear flags even if we don't
	actually add hydrogens.

	* test/buildertest.cpp: Add asserts to ensure perception flags are cleared.

2010-07-26  Noel O'Boyle

	* CMakeLists.txt, src/formats/CMakeLists.txt: Conditionally compile
	gamessukformat.cpp only if MSVC or has regex.h. (Fix for MinGW
	compilation)

2010-07-26  Noel O'Boyle

	* scripts/CMakeLists.txt, openbabel-python.i: Pass -DHAVE_EIGEN2 to swig
	and conditionally generate bindings for conformersearch.h.

2010-07-22 Chris Morley

	* src/formats/mdlformat.cpp: right align atom numbers in A line, as
	prompted by Igor Filippov.

	* include/openbabel/tokenst.h: add functor to help withr deleting
	containers of pointers.

2010-07-21  Noel O'Boyle

	* include/openbabel/math/align.h: Add Doxygen docs. Update the default
	constructor.
	* src/math/align.cpp: Update the default constructor.

2010-07-21  Noel O'Boyle

	* src/formats/povrayformat.cpp: POV-ray format has been neglected for
	a long time. Based on Steven Wathen's comments on openbabel-discuss
	(28/11/2009), I have gotten it to work. I also added options for
	checkerboard, a mirror sphere and sky.

2010-07-21  Noel O'Boyle

	* src/CMakeLists.txt: Only compile ops/conformer.cpp and
	src/conformersearch.cpp if Eigen2 is found

2010-07-19 Chris Morley

	* src/formats/inchiformat.cpp: make suitable for InChI 1.03.
	Allow InChI options and re-enable -M and -F options for non-
	standard InChI.

	* include/openbabel/inchiformat.h: improve Description()

	* windows-vc2008/libs/i386/libinchi.dll, libinchi.lib: add
	* windows-vc2008/libs/i386/libstdinchi.dll, libstdinchi.lib: remove
	
	* windows-vc2008/default_build.bat: change from libstdinchi.lib
	 to libinchi

	* src/GUI/OBGUI.cpp,src/GUI/OBGUI.h: add menu item to shrink
	window to minimum useful size.

2010-07-19 Chris Morley

	* include/openbabel/plugin.h: reverted the last change. Something
	seems to have gone wrong with the deobfuscation of the	MAKE_PLUGIN
	macro and was causing a crash in the GUI when formats were changed.
	I did not find out the precise cause, but it seemed to be around the
	default op. The difficulty of debugging	this illustrates that using a
	macro here is is not nice; we could do with a more C++ way of making
	a plugin. Tim has suggested a possible approach
	http://openbabel.org/wiki/Plugins
	
	There is already an annotated version of the contents of the macro
	at the end of the op.h, but it might not be up to date. 
	
2010-07-16 Konstantin Tokarev
	* New INSTALL file

	* include/openbabel/plugin.h: Deobfuscated MAKE_PLUGIN macro

	* src/formats/xml/cmlformat.cpp: Save and load bond labels in 
	CML format

2010-07-13 Chris Morley

	Alternative method for read-conformers which maintains
	code segregation (no chemistry in OBConversion)
	
	* src/ops/readconformers.cpp: new OBOp to combine multiple conformers
	into a single molecule.
	
	* src/obconversion.cpp,src/transform.cpp:comment out read-conformers
	code; minor doc mods
	
	* src/obmolecformat.cpp: Change option name from "write-conformers"
	to "writeconformers". The - was causing parsing problems in the GUI.
	
	* src/ops/deferred.h,src/ops/sort.cpp: put DeferredFormat in
	a new file.
	

2010-07-13 Chris Morley

	* include/openbabel/op.h(OpOptions): ignore ops with
	"not displayed in GUI" in the first line of their Descriptions()
	 
	* src/ops/conformer.cpp,src/ops/forcefield.cpp,tools/obgrep.cpp:
	Add "not displayed in GUI" to some ops which use multiple extra options
	that the GUI cannot yet display.
	
	* tools/obgrep.cpp: fix so compiles in MSVC

2010-07-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* test/buildertest.cpp, src/mol.cpp: Clear flags for SSSR and
	Aromaticity after adding hydrogens, as detected by the builder
	test. Don't clear these flags in the test anymore.

	* test/automorphismtest.cpp, test/aligntest.cpp: Find formats
	correctly on UNIX.

	* include/openbabel/mol.h: Return FindChiralCenters() to use new
	IsChiral().

	* scripts/CMakeLists.cpp: Require SWIG 2.0.0.

	* src/chiral.cpp: Remove FindChiralCenters().

2010-07-12  Tim Vandermeersch

	* Add OBConformerSearch class

	* Add OBIsomorphismMapper and OBQuery

	* Add --write-conformers option to (o)babel

	* Add OpConformer to do conformer searching with (o)babel

	* Add OpEnergy and OpMinimize

	* Many documentation updates + add examples code (see cmake BUILD_EXAMPLES)

2010-07-10 Chris Morley

	* include/openbabel/math/erf.h: local implementation of erf, because
	not present in MSVC library.

	* src/charges/qtpie.cpp, src/charges/qeq.cpp: use the above for MSVC
	builds only, instead of boost.

	* CMakeLists.txt: remove MSVC test for boost, which is not used

	* windows-vc2008/default_build.bat: Remove absolute path for cmake;
	it has to be in PATH now.
	Add option for eigen. Eigen directory has to be in a env var.

2010-07-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* test/buildertest.cpp: Test for Noel's builder/ring.cpp
	crash. Currently passes on Mac because of clearing flags. See code
	comments for details.

2010-07-08  Chris Morley

	* src/ops/sort.cpp(Do): replace stringstream by istringstream.
	A reference to stringstream is apparently not a reference to istream
	in g++, although is is in MSVC.

2010-07-07  Chris Morley

	* include/openbabel/descriptor.h, src/descriptor.cpp:
	Allow descriptors to have a parameter. External code which
	defines new descriptors will need modifying (an extra parameter
	on three functions. External code which just uses descriptors
	is compatible.

	* include/openbabel/groupcontrib.h,src/descriptors/groupcontrib.cpp,
	src/descriptors/cansmidescriptor.cpp,src/descriptors/inchidescriptor.cpp,
	src/descriptors/smartsdescriptors.cpp:	make compatible.

 	* src/ops/sort.cpp: mods so that a parameter will be recognised

	* src/descriptors/filters.cpp: make compatible and add a useless example
	(commented out) which uses a parameter.

2010-07-07  Noel O'Boyle

	* windows-vc2008/include/*, windows-vc2008/libs/i386/*: Add include
	files and compiled libraries from bsd-xdr (required for xtcformat.cpp
	under MSVC). BSD license.
	* src/formats/CMakeLists.txt: Use the xdr library when compiling with
	MSVC
	* windows-vc2008/default_build.bat: Set the location of the xdr
	library
	* CMakeLists.txt: Ensure that the cmake configure finds the xdr
	include files under MSVC
	* src/formats/xtcformat.cpp: Rename 'small' to 'small_' as small is a
	typedef for 'char' under MSVC (or something like this)

2010-07-07  Noel O'Boyle

	* CMakeLists.txt, src/formats/xtcformat.cpp,
	src/formats/CMakeLists.txt: Check for rpc/xdr.h and conditionally
	compile xtcformat.cpp. (In preparation for MSVC support...)

2010-07-06  Noel O'Boyle

	* src/formats/gamessukformat.cpp, CMakeLists.txt: Enable GAMESS-UK
	format under MSVC (uses std::tr1::regex instead of regex.h)

2010-07-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/inchi103, src/formats/inchi103: Import final InChI 1.03
	release.

2010-07-06  Noel O'Boyle

	* include/openbabel/forcefield.h: Fix memory leak identified by VLD

2010-07-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp: Revert changes and parse
	extra parameters for now.

	* doc/Doxyfile: Renamed from Doxyfile.in (not generated by
	autoconf anymore). Generate ob.tag file for projects generating
	doxygen documentation with Open Babel symbols (e.g., Avogadro).

	* src/oberror.cpp: Fix from Seth Alves to initialize stream
	buffers (from Valgrind).

2010-07-05  Konstantin Tokarev <annulen@yandex.ru>

	* THANKS, authors.txt: Added myself to contributors

2010-07-04  Noel O'Boyle

	* src/formats/*format.cpp: Added text from wiki formats [F-Z] to their
	Descriptions in the .cpp file.

2010-07-03  Chris Morley

	* src/GUI/optswx.cpp: can use "not displayed in GUI" in option
	list in Description()

	* include/openbabel/depict/painter.h add operator += for OBColor

	* include/openbabel/depict/depict.h,svgpainter.h,
	  src/depict/depict.cpp, src/depict/svgpainter.cpp: add option
	  for internalColor on atoms and bonds (by OBPairData)

	* src/formats/svgformat.cpp:add option to display internalColor
	Remove "Additional Option" in Description

	* src/formats/xml/cmlformat.cpp: read and write color on bonds

	* src/ops/substructdata.cpp:add new op --ss which is like -s but
	colors the substructure

2010-07-02  Noel O'Boyle

	* include/openbabel/base.h: Add OBAPI declaration to new global
	function OBReleaseVersion()

2010-07-01  Noel O'Boyle

	* src/formats/*format.cpp: Added text from wiki formats [A-F] to their
	Descriptions in the .cpp file. I added some markup to CML and
	Fastsearch.

2010-07-01  Konstantin Tokarev <annulen@yandex.ru>

	* src/confi.h.cmake: Added macros OB_VERSION_CHECK and OB_VERSION

2010-06-30  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp: Set fixed atom constraints on rotor rules
	during rotamer/conformer searching, from Chris Wassman.

	* include/openbabel/base.h, src/base.cpp: Add OBReleaseVersion()
	global function, as suggested by Tobias Schmidt for code detection
	of versions and features. (Most useful from scripting interfaces,
	which won't have BABEL_VERSION as a macro.)

2010-06-29 Chris Morley

	* tools/babel.cpp, tools/obabel.cpp: -H no longer lists all formats
	  (As suggested by Noel)

	* include/openbabel/plugin.h: correct small error causing warning

	* src/format.cpp, src/plugin.cpp: small formatting changes in List
	output.

2010-06-29  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/charges/qeq* src/charges/qtpie* data/qeq.txt: Move QEq and
	QTPIE parameters to the data file. Parameters are possibly suspect
	for non-standard elements.  Jiahao Chen will send revised versions later.

	* data/UFF.prm: Remove QEq parameters -- not used by UFF.

2010-06-29 Noel O'Boyle

	* CMakeLists.txt: Avoid warnings with MinGW when compiling the exes

2010-06-29 Noel O'Boyle

	* src/formats/*format.cpp, src/formats/xml/*format.cpp: Edit some
	Descriptions() to replace Input with Read and Output with Write. Also
	uppercased any "options" to "Options".

2010-06-29 Noel O'Boyle

	* src/formats/xml/cmlformat.cpp: Partial fix for chiral N problems.
	See PR#3022295.

2010-0628 Chris Morley

	* include/openbabel/depict/depict.h, src/depict/depict.cpp:
	Use a bitset for options like drawTerminalC, so that extendable
	while binary compatible. Add a few more options display options.

	* src/formats/svgformat.cpp: add a few more display options.
	Augment Description() as a possible prototype for Noel's more
	formatted documentation.

2010-0628 Chris Morley

	* src/GUI/optswx.cpp: when using Description() strings to construct
	GUI option checkboxes, ignore lines with 4 or more leading spaces
	within each option list. Allows better formatted documentation, as
	proposed by Noel.

	* src/formats/*format.cpp: remove remaining continuation characters
	in Description()s and replace by concatinated ""..." ""..."

2010-06-24 Chris Morley

	* src/formats/mdlformat.cpp:Prevent unnecessary error message with
	blank line at end of SDF file.

2010-06-23  Noel O'Boyle

	* src/kekulize.cpp, include/openbabel/mol.h: Fix compilation errors
	with MSVC (and replace some Tabs with whitespace)

2010-06-23  Tim Vandermeersch

        * src/ring.cpp: LSSR selection seems to work now. It is based on
        lemma 1 from the Vismara paper. (See source for complete reference)

        * src/obiter.cpp, src/ring.cpp: Ring sets should no longer be
        acquired using OBMol::GetData(OBGenericDataType::RingData). Ring
        sets now have the correct "SSSR"/"LSSR" attribute set.

        * src/kekulize.cpp: Use LSSR.

        * test/lssrtest.cpp: Add tests for LSSR composition. All unit tests
        pass except for smarts (was broken before) and py_kekulize. I'm not
        sure why the last test fails but the stored results might need updating?

2010-06-22  Tim Vandermeersch

        * include/openbabel/mol.h, src/mol.cpp: Add LSSR, add aromaticity
        changes from Craig.

        * src/ring.cpp: Add LSSR (FindLSSR, GetLSSR, ...)

        * src/kekulize.cpp: Changes to aromaticity from Craig James. Still
        uses SSSR.

        * test/CMakeLists.txt, test/lssrtest.cpp: Add unit test for LSSR. 
        The test reorders the atoms and checks if the same rings are found.
        Currently used aromatics.smi, attype.00.smi and nci.smi. All 1327
        test cases pass. (old ring & aromatics test still pass. py_kelule
        test fails though.)

2010-06-21  Noel O'Boyle

	* src/builder.cpp: Fix bug when correcting tet stereo where there is
	an Implicit H

2010-06-20  Noel O'Boyle

	* src/formats/pdbformat.cpp: the_res not NULL-terminated. Resulted in
	junk output after residue name in PDB files.

2010-06-20  Noel O'Boyle

	* src/formats/mol2format.cpp: Removed obsolete code that was causing
	performance problems on large files (e.g. proteins). Fixes
	bug #3018188

2010-06-19  Chris Morley

	* src/formats/mdlformat.cpp: Added warning message when reading
	misformed files with too many atoms or bonds. Bug #2971865

2010-06-18  Noel O'Boyle

	* doc/Doxyfile.in: Update to Doxygen 1.7.0 and turn SEARCHENGINE on.
	* doc/api-style.css (removed), doc/api-header.html: Old style file
	removed as out-of-date with respect to
	Doxygen 1.7.0 (instead, the automatically generated doxygen.css is used)

2010-06-17  Noel O'Boyle

	* src/stereo/perception.cpp: Fix to previous commit for Linux.

2010-06-17  Noel O'Boyle

	* src/mol.cpp(DeleteHydrogen), src/stereo/perception.cpp,
	include/openbabel/stereo/stereo.h: If a hydrogen is deleted, it is now
	converted to an ImplicitRef in any stereo objects that reference it.

2010-06-14  Chris Morley
	
	* data/atomtyp.txt: add IMPVAL for triply bonded O+ (for carbon
	monoxide). 
	
	* src/formats/xml/cmlformat.cpp(ReadMolecule): leave processing
	of hydrogenCount attributes until the structure is complete, so
	that explict H can count towards them. Also now handles 
	hydrogenCount=0. Fixes bug #3014855 (Daniel Lowe).
	
	Change specification URI. Clarify implicit H behaviour in description.
	
	* src/obconversion.cpp: temporarily reintroduce the lineend
	memory leak. It was crashing with CML input, which doesn't
	even use the line end buffer!

2010-06-14  Noel O'Boyle

	* src/graphsym.cpp: Fix my fix to memory leak (get rid of 'new')

2010-06-14  Noel O'Boyle

	* Add target "make docs" to make the Doyxgen docs: $ROOT/doc/Doxyfile.in
	is converted to $ROOT/Doxyfile by substituting the $BABEL_VERSION and
	the PATH to Dot.

2010-06-13  Noel O'Boyle

	* src/formats/pdbformat.cpp: Applying Richard Hall's patch to fix
	handling of CONECT records where bond order was split over two lines.
	This can occur, for example, with the sulfur in RS(=O)(=O)R'.

2010-06-13  Noel O'Boyle

	* src/obconversion.cpp: Applying Tim's patch to fix memory leak

2010-06-13  Jean Brefort  <jean.brefort@normalesup.org>

	* src/math/spacegroup.cpp: make import more flexible.

2010-06-11  Noel O'Boyle

	* windows-vc2008/*default_build.bat: Add quotation marks around %CD%
	to handle case where path to current directory contains a space.

2010-06-11  Noel O'Boyle

	* src/graphsym.cpp: Fix memory leak (use of 'new' without
	corresponding 'delete')

2010-06-11  Chris Morley

	* src/descriptor.cpp(ParsePredicate): Before doing a numeric comparison,
	ensure the the filter string contains a number only. Fixes #3014398
	
	* src/formats/mdlformat.cpp: Added an option to read only the title
	and change the format to produce molecules with zero atoms.
	Useful for fast selection by title from a sd file(UNIX line endings only):
	  babel all-sdf.sdf -ocopy out.sdf --filter "title=1str*" -at
	  
	* src/GUI/OBGUI.cpp: In open and save file dialogs add gz compressed
	files to filter	string. So, as well as *.sdf, *.sdf.gz files are shown. 

2010-06-07  Noel O'Boyle

	* scripts/CMakeLists.txt, scripts/openbabel-csharp.i,
	windows-vc2008/Distribution/*obdotnet*: Enable the CSharp bindings to
	be compiled (at least on windows so far).

2010-06-07  Noel O'Boyle

	* scripts/CMakeLists.txt, scripts/perl/Makefile.PL: Now perl bindings
	seem to 'make install' correctly.

2010-06-06  Noel O'Boyle

	* scripts/CMakeLists.txt, scripts/perl/Makefile.PL: Now perl bindings seem to 'make' correctly.

2010-06-06  Noel O'Boyle

	* scripts/CMakeLists.txt, scripts/openbabel-ruby.i, scripts/ruby/extconf.rb: Ruby binding support.

2010-06-06  Noel O'Boyle

	* scripts/CMakeLists.txt: Perl binding support on Linux. Needs more
	work on the Makefile.PL side.

2010-06-04  Chris Morley

	* src/obconversion.cpp(~OBConversion): corrected memory leak caused by
	line end buffer as suggested by runz. Fixes half of bug #2992369.

2010-06-03  Noel O'Boyle

	* Set svn:eol-style to native for all text files.

2010-06-02  Noel O'Boyle

	* scripts/CMakeLists.txt: Perl bindings re-enabled. Still can't get to
	work for MSVC+ActiveState Perl though.

2010-05-26  Noel O'Boyle

	* Lots of files: 'Fix' warnings with 64-bit Windows relating to size_t
	and unsigned ints. I either:
	(a) changed unsigned int to size_t where the function was GetSize() or
	Size() or something
	or...in every other case...
	(b) static_cast<unsigned int> the size_t value (for example, no-one
	expects NumResidues() to be size_t, or GetValence())

2010-05-26  Noel O'Boyle

	* src/formats/CMakeLists.txt: Require -DINCHI_LIBRARY for MSVC builds.
	This allows the x64 or i386 inchi .lib to be selected depending on the
	build platform.
	* windows-vc2008/default_build.bat, x64_default_build.bat:
	Corresponding changes to the build batch files.

2010-05-26  Chris Morley

	* src/GUI/OBGUI.cpp: minor change to remove compiler warning

2010-05-24  Noel O'Boyle

	* test/testsym.py: Change CML roundtrip test to use temporary file to
	avoid problems on Linux (bug submitted). I notice that a new problem
	has arisen, which I need to sort out.

2010-05-24  Noel O'Boyle

	* src/dlhandler_unix.cpp: Added code for MinGW. Now can find formats,
	even when run from build tree (set BABEL_LIBDIR).
	* src/dlhandler_win32.cpp: Removed code for Cygwin and MinGW, and a
	commented out section
	* src/formats/CMakeLists.txt: Removed XML formats from MINIMAL_BUILD

2010-05-23  Marcus D. Hanwell <marcus@cryos.org>

	* CMakeLists.txt, OpenBabel2Config.cmake.in, src/CMakeLists.txt,
	src/formats/inchi103/CMakeLists.txt: Make and configure a config file
	suitable for installation too.

	* include/openbabel/reaction.h: Fixed a compilation failure I
	was hitting with GCC 4.5, std::tr1::shared_ptr was not found.

	* CMakeLists.txt, include/CMakeLists.txt, src/CMakeLists.txt,
	src/formats/CMakeLists.txt, src/formats/inchi103/CMakeLists.txt,
	OpenBabel2Config.cmake.in, OpenBabel2ConfigVersion.cmake.in:
	Refactored some parts of the build system, added my first pass
	at an OpenBabel2Config file and friends. This currently supports
	building against a build treee, installation tree logic later.


2010-05-22  Noel O'Boyle

	* CMakeLists.txt, src/CMakeLists.txt: Re-enable support for Cygwin. I
	just needed to change Cygwin to use dlhandler_unix.cpp instead of
	dlhandler_win32.cpp. (Note to self: need to sort out Mingw now, and
	then remove Cygwin specific code from dlhandler_win32.cpp)

2010-05-20  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* CMakeLists.txt, src/formats/CMakeLists.txt: Fix support for
	formats using shared pointers and GCC-4.x without boost.

	* include/openbabel/mol.h, src/mol.cpp: Add revised RenumberAtoms
	method which uses integer atom indexes for use in scripting
	bindings.

2010-05-18  Konstantin Tokarev  <annulen@yandex.ru>

    * src/formats/xml/cmlformat.cpp: Add support for reading and writing
    of custom labels, colors, and radii of atoms

2010-05-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mol2format.cpp: Add support for reading charge model
	descriptors from mol2 files. Should now allow round-tripping
	between mol2 -> mol2.

2010-05-12  Noel O'Boyle

	* src/charges/qtpie.cpp, qeq.cpp: Replace isnan with IsNan for
	cross-platform (i.e. MSVC) compatability. Still won't compile on
	Windows as is missing "erf" function (there is an implementation in
	boost which can probably be used).

2010-05-12  Noel O'Boyle

	* src/forcefield.cpp: Change WeightedRotorSearch to behave more like
	SystematicRotorSearch in that it now clears existing conformers,
	and stores conformers and energies found during the search.

2010-05-11  Noel O'Boyle

	* scripts/CMakeLists.txt, openbabel-java.i, openbabel-python.i: Bring
	the Java bindings back to life. Bring the python and java SWIG
	interface files into synch.

2010-05-11  Noel O'Boyle

	* windows-vc2008/libs, x64_default_build.bat: Adding libraries and
	cmake bat for x64 build. Move i386 libraries to libs/i386 to keep
	things symmetrical.
	* src/formats/CMakeLists.txt: Update for new location of libstdinchi.

2010-05-10  Chris Morley

	* src/formats/svgformat.cpp: draw terminal C atoms explicitly by default.

	* src/formats/xml/cmlformat.cpp: hack to allow CML in molpro output to
	  be read.
	  No implict H or spinmultiplicity assignment if any bonds have zero
	  order.
	
2010-05-09  Noel O'Boyle

	* CMakeLists.txt, scripts/CMakeLists.txt: The final step in getting the
	Python bindings ready for release - separating the running of SWIG from
	the compiling of the bindings. -DRUN_SWIG and -DPYTHON_BINDINGS are the
	relevant variables. If you try to compile the bindings and they are not
	present, the warning message recommends you use -DRUN_SWIG.

2010-05-07  Chris Morley

	* src/transform.cpp: Add option suggested by Noel:
	-r Remove all but the largest contiguous fragment
	(StripSalts)
	
2010-05-07  Noel O'Boyle

	* src/builder.cpp: Treat 2D structures like 0D structures.

2010-05-07  Noel O'Boyle

	* src/mol.cpp, include/openbabel/mol.h: Change OBMol::StripSalts() to
	remove all but the largest fragment if threshold is 0. Updated the
	docs.

2010-05-06  Noel O'Boyle

	* scripts/CMakeLists.txt: Place the SWIG-generated files in the
	source directory (TODO: Require -DRUN_SWIG for developers). Correct
	EQUAL to STREQUAL. Remove unnecessary soft link.

2010-05-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/tokenst.h: Add missing <sstream> header.

2010-05-06  Chris Morley

	* include/openbabel/tokenst.h: Add utility function toString()
	
	* src/formats/xml/xml.cpp: Use new reader when the input file
	changes, rather than resuing the old one. Was not working with
	input files with <?xml?> elements.
	
	* delete windows-vc2005 and windowsOBF which did not use CMake.
	  
2010-05-04  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/data.cpp: Add check for empty isotope rows (PR#2996661).

	* data/isotope.txt: Add some default isotopes for heavy elements
	up to element 118. Will need updates after next atomic mass
	evaluation.

2010-05-04  Jean Brefort  <jean.brefort@normalesup.org>

	* data/space-groups.txt: updated after group 205 Hall name fix.
	* src/math/scpaegroup.cpp: fixed group search for duplicate Hall names (grroups 3 and 68).

2010-04-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/ops/partialcharges.cpp: Add operation to calculate partial
	charges using any charge method, e.g., --partialcharge qeq.

	* src/CMakeLists.txt: Add it.

2010-04-26  Noel O'Boyle

	* test/CMakeLists.txt, test/testbindings.py, test/test_pybel.py:
	Separate the pybel tests from the Python binding tests
	* scripts/python/examples/testpybel.py: Get the Pybel tests to pass on
	Linux
	* scripts/CMakeLists.txt: Force the Python build to output to
	scripts/pybuild. Otherwise it created a temporary folder whose name
	differed from platform to platform (e.g. lib.linux-x86_64.2.6) which
	made it difficult to handle automatically.

2010-04-25  Noel O'Boyle

	* test\CMakeLists.txt, test\testbindings.py, test\testexample.py:
	Enable the use of the Python bindings for testing. Run the Pybel
	tests. Add a simple example test as a template.
	* scripts\python\examples\testpybel.py: Get the Pybel tests to pass

2010-04-22  Noel O'Boyle

	* src/GUI/OBGUI.cpp: Fixes for Unicode build. Now have SVG depiction
	on Linux also!

2010-04-20  Jiahao Chen <jiahao@mit.edu>

        * src/charges/mmff94.cpp, src/charges/gasteiger.cpp: Fixed leftover
	references to OBPartialCharge (now OBChargeModel)

2010-04-21  Noel O'Boyle

	* scripts/CMakeLists.txt: Edit variables to correspond to Konstantin's
	recent changes (something to do with a superpackage build..?)

2010-04-20  Jiahao Chen <jiahao@mit.edu>

        * src/charges/qeq.h, src/charges/qeq.cpp:
	Added implementation of QEq charge model (Rappe and Goddard, 1991)

        * src/charges/qtpie.h, src/charges/qtpie.cpp:
	Added implementation of QTPIE charge model (Chen and Martinez, 2007;
	2008)

        * src/atom.cpp: added comments to show how these new charge models can
	be called from within current OpenBabel code

        * CMakeLists.txt: added charge models and compile flags for Eigen2
	library (variables copied from Avogadro source tree)

	* cmake/modules/FindEigen2.cmake: CMake module to configure Eigen2
	(copied from Avogadro source tree)

2010-04-20  Noel O'Boyle

	* scripts/CMakeLists.txt: Handle local and global Python installs
	in a (to me) sensible way

2010-04-20  Chris Morley

	* src/ops/loader.cpp: parse of plugindefines.txt  to allow # as
	a comment and # in a SMARTS string to coexist.
	
	* data/plugindefines.txt: add some simple SmartsDescriptors.
	
2010-04-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/generic.h: Remove dangerous loop iterator
	after calling erase(), found by cppcheck.

	* include/openbabel/depict/painter.h: Add virtual destructor to
	remove warning.

	* src/formats/xtcformat.cpp: Remove minor memory leak found by
	cppcheck.

	* src/formats/fastsearchformat.cpp: Remove minor memory leak found
	by cppcheck.

	* src/ops/sort.cpp: Remove minor compile warning by GCC.

	* data/element.h, data/atomtyp.h: Regenerate. Need to add CMake
	targets for these.

2010-04-10  Chris Morley

	* CMakeLists.txt: ensure output compression not enabled for MSVC
	(as for previous build system).

	* src/CMakeLists.txt: remove ops.cpp (which had nothing useful left
	in it) and add xout.cpp. Add plugin_charges obf project for MSVC.
	
	* windows-vc2008/Distribution/NSISScriptToCreateInstaller.nsi:
	add doc folder; delete MS distributables installer when it has been
	run; add sdf.bat; add obdepict.bat and put on context menu;
	add firefox	to path so GUI and obdepict can use it.
	
	* src/GUI/OBGUI.cpp,src/GUI/OBGUI.h: add optional display of
	chemical structures in firefox (or other external program),
	using a new op xout.

	* windows-vc2008/Distribution/NSISScriptToCreateInstallerOBF.nsi
	deleted
	
2010-04-09  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/partialcharge.h, src/partialcharges.cpp,
	src/charges/: New plugin type to assign partial charges. First
	examples are MMFF94 and Gasteiger. Nothing new, but more to come.

2010-04-07  Chris Morley

	* src/formats/fingerprintformat.cpp: add option to output
	hexadecimal fingerprints only, as requested by Francesco Napolitano. 

2010-04-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/dlhandler_unix.cpp (findFiles): Don't split on tabs or
	spaces. These are legal characters for directories. (This causes
	problems with Mac users in particular.)

2010-04-04 Chris Morley

	* src/GUI/OBGUI.cpp,src/GUI/OBGUI.h: add a scrollbar on the options
	panel, so that the GUI can be used with wide, shallow windows (an
	unfortunate current fashion).

2010-04-01 Chris Morley

	* windows-vc2008: Add new Distribution folder and copy the external
	dlls and libs. Rewrite Windows installer for CMake VC2008 build.
	Uses more wild cards and so should be less prone to omissions.
	Folders windows-vc2005 and windowsOBF will be deleted, but have not
	been yet.	

2010-03-29  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp (SetCoordinates): Fix bug in SetCoordinates -- copy
	from externally-supplied double* to _c. Renamed parameter to avoid
	this problem. Fixes PR#2975148. Thanks to Paul Mortenson.

2010-03-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/base.h: Fix "unused parameter" warnings for GCC.

2010-03-26 Chris Morley

	* src/obmolecformat.cpp: Make --separate work with multiple input
	  molecules. Fixes #2961144

2010-03-23 Chris Morley
	
	Segregate the molecules that failed inchiwrite so that there are
	no failures using Samples.txt but all fail with SamplesFail.txt.
	Similarly with SamplesTechManFail.txt. The majority of failures
	are stereochemistry.
	 
	* include/openbabel/alias.h, src/alias.cpp: reorganize the error
	messages in ExpandAlias. 

	* src/formats/mdlformat.cpp: changes in description so GUI displays
	options better.

2010-03-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/obmolecformat.h, src/ops/unique.cpp: Fix
	unordered_map compile problems on Mac. Even Apple's GCC-4.2 has
	strange errors. For now, use regular std::map with APPLE_GCC.

2010-03-18  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/gaussformat.cpp: Use ESP charges if available from
	the calculation. Fixes PR#2871242 as suggested by Tapani Kinnunen.

2010-03-18 Chris Morley

	* src/atom.cpp (GetImplicitValence): add [H] as a special case.
	Cannot use IMPVAL [H] 1 in atomtyp.txt because there is an infinite
	loop. Fixes #2972355.

	* src/ops/unique.cpp: using std::tr1::unordered_map; is needed for 
	Visual Studio build also.

2010-03-18  David Lonie  <loniedavid@gmail.com>

	* test/unitcell.cpp, test/files/unitcell.txt,
	test/files/unitcell_results.txt: Added coordinate transformations
	tests to unit cell tests.

2010-03-17  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp: Patch from Philipp Rumpf to
	fix 5-coordinate axial atom detection. Also fix PR#2971473 for
	planar SO3 molecules. Additional fixes to handle other hypervalent
	cases, including 7-coordinate pentagonal bipyramidal.

	* include/openbabel/atom.h: Explain new hybridization values
	(4 = sq. planar, 5 = trig. bipy, 6 = octahedral).

	* data/atomtype.txt: Add generic rules for hypervalent hybridizations.

	* src/atom.cpp (GetNewBondVector): Use OBBuilder as a
	replacement, to decrease duplicated code.

	* src/builder.cpp: Patch from Philipp to address hypervalent
	hybridizations. Also added code to assign random vectors for
	undefined cases -- this is better than using VZero, since at least
	atoms will have unique locations.

2010-03-15  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/ops/unique.cpp: Fix #ifdefs to compile on GCC 4.0
	(i.e. without Boost or unordered_map support).

	* src/formats/gaussformat.cpp: Patch from Louis Ricard to improve
	support of reading Gaussian coordinates from geometry
	optimizations, etc.

	* src/formats/hinformat.cpp: Patch from George Tu through SF
	tracker to ignore HIN comment lines. PR#2969340.

2010-03-13  Noel O'Boyle

	* scripts/CMakeLists.txt, scripts/python/setup.py: Compile the
	SWIG bindings manually.

2010-03-12  Noel O'Boyle

	* CMakeLists.txt: Require BOOST for compilation with GCC3.x. Don't
	check for or use BOOST otherwise.

2010-03-11  Noel O'Boyle

	* src/ops/unique.cpp: Enable compilation with the help of Boost on
	GCC 3.4. Note to self, don't compile if Boost not found.

2010-03-10  Matt Sprague  <mesprague@gmail.com>

	* src/formats/xml/xml.cpp: Add call to xmlInitParser() to support
	the use of xml formats in multithreaded environments.

2010-03-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mdlformat.cpp: Check atom symbols for isotopes like
	'D' or 'T'. Solves some inchiwrite failures.

	* src/alias.cpp: Downgrade errors over superatom.txt to warnings.

2010-03-06  Konstantin Tokarev

	* include/openbabel/obmolecformat.h: use tr1::unordered_map instead 
	of map when compiling with GCC 4.x

2010-03-06  Noel O'Boyle

	* src/formats/inchiformat.cpp, mdlformat.cpp: Moved warning about 0D
	from InChI to MDL where it should have been in the first place.

2010-03-05  Tim Vandermeersch

        * test/files/stereo/*: Add test structures from Razinger paper.

        * include/openbabel/graphsym.h, src/graphsym.cpp: Add parameter for 
        NOT taking stereochemistry into account.

        * test/graphsymtest.cpp: Use added files for unit testing (i.e. check 
        if the right number of symmetry classes are found). Also, the unit 
        test was using std::unique wrong (without sorting first), the two 
        failing test cases now pass. The is a new failing test though:
        test/files/stereo/razinger_fig7_1.mol All atoms get the same symmetry 
        class, it is a very simple structure though...

2010-03-05  Noel O'Boyle

	* CMakeLists.txt: Require GCC >=4.2 for visibility support

2010-03-04  Noel O'Boyle

	* test/files/testsym_2Dtests.sdf: Forgot to add test file

	* src/stereo/perception.cpp: In TetrahedralFrom3D, if a bond to the
	chiral center IsWedgeOrHash then make the stereo object unspecified.
	* src/builder.cpp: Fix logic when correcting cistrans stereo
	* test/testsym.py: The long-promised stereo tests that flushed out
	the two bugs above. Also, since it seems that each call to 'babel' is
	quite slow, I've bundled multiple SMILES into each call.
	* test/CMakeLists.txt: Simplified the logic surrounding the Python tests
	* test/testbabel.py: Added convenience function for finding test files

2010-03-04  Tim Vandermeersch

        * include/openbabel/stereo/stereo.h, src/stereo/facade.cpp: Add support
        for square-planar stereochemistry to OBStereoFacade.

        * src/formats/smilesformat.cpp: Add support for reading/writing 
        square-planar stereochemistry (@SP1, @SP2, @SP3).

        * test/smilestest.cpp: Add unit tests for smiles square-planar 
        reading/writing.

2010-03-03  David Lonie  <loniedavid@gmail.com>

	* src/generic.cpp, include/openbabel/generic.h:
	Changes to OBUnitCell to handle data more consistently. Note that
	this depreciates the use of GetOrthoMatrix and GetFractionalMatrix
	for conversions to/from fractional and cartesian
	coordinates. Simply multiplying by these matricies may no longer
	correctly convert coordinates since an orientation matrix has been
	introduced in order to handle cells that don't follow a standard
	alignment. Use

	vector3 OBUnitCell::FractionalToCartesian(vector3) and
	vector3 OBUnitCell::CartesianToFractional(vector3)

	instead. There are also two new convenience functions,

	vector3 OBUnitCell::WrapCartesianCoordinate(vector3) and
	vector3 OBUnitCell::WrapFractionalCoordinate(vector3)

	to move a set of coordinates into the unit cell.

2010-03-03  Noel O'Boyle

	* src/formats/mdlformat.cpp, src/stereo/perception.cpp, 
	include/openbabel/stereo/stereo.h, src/formats/inchiformat.cpp: More
	work on 2D stereo. Tests to follow.

2010-03-03  Tim Vandermeersch

        * include/openbabel/stereo/cistrans.h: Doc update.
        
        * include/openbabel/stereo/squareplanar.h: Update OBSquarePlanarStereo 
        class to work with Config struct like tetrahedral and cis/trans stereo
        objects.

        * src/stereo/squareplanar.cpp: implementation...

        * test/CMakeLists.txt: small changes to the way add_test is used to work 
        with CMake 2.6.

        * test/squareplanartest.cpp: Update the unit test for the OBSquarePlanar 
        class to use Config structs.

2010-03-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* test/CMakeLists.txt: Add back test for inchwrite and check
	failures on Python tests better.

2010-03-03  Tim Vandermeersch

        * include/openbabel/stereo/tetrahedral.h,
	src/stereo/tetrahedral.cpp: When comparing Config structs'
	stereochemistry, return true if either of the Config structs are
	unspecified (i.e. accidental). The smiles test was failing because
	it compared stereocenters that were unspecified. The documentation
	is also updated.

        * test/smilestest.cpp: Add the test case back. Now passes.

        * test/graphsymtest.cpp: There are still some cases were this test
	fails. However, it mainly has to do with N atoms becoming aromatic
	and getting an extra H atom. I'm not sure what's the best solution
	here...

2010-03-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/kekulize.cpp (expand_kekulize): Fix crashing bug -- looking
	for GetBond, not GetBondById -- the code iterates by bond indexes,
	not unique ids (which may have gaps, etc.). Fixes PR#2956135.

2010-03-01  Tim Vandermeersch

        * tests/smilestest.cpp: Remove the 2 failing test cases for now. I 
        believe they were the result from parsing +100000 molecules. I've added
        some more realistic examples. When I have time I'll try to find out why 
        the 2 cases are failing.

        * test/graphsymtest.cpp: In the process, I've added a unit test for 
        symmetry class assignment. It's very basic but there are some disabled,
        failing molecules there two. One of the failing molecules overlaps with
        the smilestest and ths might be the source of the problem, for that 
        molecule at least.

2010-03-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* CMakeLists.txt, src/CMakeLists.txt, src/formats/CMakeLists.txt:
	Updates to ensure ZLIB is not required PR#2947452.

	* test/testkekule.py: Added test for PR#1842055 with
	canonicalization and isotopes.

	* test/CMakeLists.txt: Added test smartsparse -- currently unused
	(failing) to track SMARTS parsing on valid patterns.

	* test/smartsparse.cpp, files/validsmarts.txt: Testing patterns
	from Daylight's webpages.

	* test/inchiwrite.cpp: Fixed to compile. Probably needs a python
	wrapper to call with appropriate arguments (e.g., inchi/Sample.sdf
	inchi/Sample.txt). Hint, Hint.

2010-03-02  Noel O'Boyle

	* src/formats/mdlformat.cpp: Obey MDL stereo guidelines as described
	by Greg Landrum on BO mailing list. Test cases to follow.

	* test/testsym.py: Added test for PR#2101034

	* test/CMakeLists.txt: Set required environment variables for
	"make test". Only works with CMake 2.8 though.
	* test/testbabel.py: Previous buffer fix didn't improve matters. Trying
	a second time.

	* src/formats/inchiformat.cpp: Add support for setting wedge/hash
	bonds for 2D data

	* src/perception.cpp: Unified code for the wedge and
	dash cases where there are two in-plane bonds.
	* src/formats/mdlformat.cpp: Improve support for writing of 2D.

2010-03-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/pdbformat.cpp: Fix for PR#2866659 from Fabian. Check
	for chain numbers when assigning sequence numbers.

	* src/data.cpp: Fix for PR#2889763 from Fabian -- make
	sure to check chain numbers as well -- or bond between chains!

	* src/typer.cpp: Fix for PR#2889708 -- another patch from Fabian
	to improve performance of SelectRootAtoms.

	* CMakeLists.txt: Don't use -fvisibility=hidden for
	Mac/gcc-4.2. This feature appears buggy.

2010-03-01  Tim Vandermeersch

        * src/stereo/perception.cpp: Add some more safety logic. (Fixes #2897750)

2010-03-01  Noel O'Boyle

	* src/perception.cpp: Fixed error for perception of stereo from 2D for
	3 in-plane bond + one wedge/dash. Also unified code for the wedge and
	dash cases.
	* src/formats/mdlformat.cpp: Add support for writing of 2D
	stereochemistry. The wedges/dashes read from input (or otherwise
	calculated) will be used unless the 'w' option is given, in which case
	the tetstereo objects will be used to work out the wedges/dashes. This
	is required because the wedges/dashes often contain information beyond
	the stereochemistry and it would be unwise to just forget it.

2010-02-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/gaussformat.cpp: Fix crash with reading Gaussian
	files with only one geometry.

	* src/formats/CMakeLists.txt: Fix to allow compile of InChI with
	ops/unique.cpp correctly.

2010-02-28  Noel O'Boyle

	* test/testunique.py: Implement Chris' tests for --unique
	* test/files/dupset.smi: Remove file as these test cases are included
	in the Python script

2010-02-28  Chris Morley

	* src/ops/unique.cpp: Make header file for unordered_map
	conditional: <unordered_map> for MSVC; <tr1/unordered map>
	otherwise. 
	Simplify mesaage reporting duplicates.
	
	* test/files/dupset.smi; datafile for a test (but no test yet).
	 
2010-02-27  Noel O'Boyle

	* test/CMakelists.txt, test/testfastsearch.py, test/testbabel.py:
	Added a new test for fastsearch functionality plus some convenience
	methods.

2010-02-27  Chris Morley
	
	* include/openbabel/base.h: Make GetTitle() and SetTitle() virtual
	  but do nothing in base class. Avoids the need for dynamic_casts
	  when OBBase* pointers are used in ops, etc.

	* src/formats/inchiformat.cpp, include/openbabel/inchiformat.h:
	  remove (unused) testformat and move declarations to a header
	  file which can be used by...
	  
	* src/descriptors/filters.cpp,src/descriptors/inchidescriptor.cpp:
	  move inchi descriptor
	  
	* src/descriptors/cansmidescriptor.cpp: add new descriptor
	
	* include/openbabel/obmolecformat.h,src/obmolecformat.cpp: remove old
	  implementation of --sort to a more natural home in an op...
	
	* src/ops/sort.cpp: with added features (see wiki page)

	* include/openbabel/descriptor.h, src/descriptor.cpp: change the
	  comparison functions

	* src/ops/unique.cpp: new op for removing duplicate molecules
	
	* src/CMakeLists.txt, src/formats/CMakeLists.txt: for new files.
	  unique.cpp is in format_common rather than plugin_ops because linking
	  is easier.
	  
	* src/formats/fastsearchformat.cpp: line in message
	
	* src/formats/mol2format.cpp: Provide a SkipObjects function

2010-02-26  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/chains.cpp: Apply patch from Juergen Wieferink: PR#2948548.

	* CMakeLists.txt: Add option for disabling boost detection -- can
	cause problems compiling.

2010-02-26  Noel O'Boyle

	* src/formats/xml/cmlformat.cpp: Add support for 0D cistrans symmetry
	* test/testsym.py: Add tests for 0D cistrans symmetry across SMI,
	InChI, SDF and CML


	* src/obconversion.cpp:
	Set MAKE_ALL_READS_BINARY by default in the code. (CMake build had
	omitted to do that.) If not set on MSVC, seekg() returns incorrect
	values with UNIX files.
	
	* src/fingerprint.cpp:
	Do the binary read and write of each header variable separately
	rather than as a struct, to reduce possiblity of problems on other
	platforms which may lay out struct differently.	 

2010-02-26  Noel O'Boyle

	* src/stereo/cistrans.cpp, include/openbabel/stereo/cistrans.h: Fix
	bug in GetCisRef, and unify implementations of GetCisRef and
	GetTransRef

2010-02-26  Noel O'Boyle

	* test/testsym.py: Add a test for 0D tetrahedral symmetry across SMI,
	InChI, SDF and XML

2010-02-25  Noel O'Boyle

	* src/xml/cmlformat.cpp: Add support for 0D tetrahedral stereochem

2010-02-23  Noel O'Boyle

	* src/builder.cpp: Fix bug where a sp2-hybridised atom could be added
	at 180 deg instead of 120 if a particular corner case arose. The test
	case was "c1c2c(=O)[nH]c(=O)c2c(c2c1c(=O)[nH]c2=O)C#CC=C" where the
	final C=C was added in line with the C#C.

2010-02-23  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/gaussformat.cpp: Add support for reading multiple
	conformers (e.g., geometry optimization) including energy for each step.

2010-02-22  Noel O'Boyle

	Enable testing of OpenBabel executables from Python
	* test/testbabel.py: Initial checkin of tests for the Babel executable
	* test/CMakeLists.txt: Add testbabel.py
	* cmake/modules/UsePythonTest.cmake: Add a CMake module for adding
	Python tests (BSD License) from Mathieu Malaterre

2010-02-21  Tim Vandermeersch

        * src/stereo/perception.cpp: Allow S, P and bridgehead N atoms to be 
        chiral. These "filters" may still need some work though.

        * test/files/nci.smi: Make N atom non-chiral in 2 smiles. The 
        smilesmatch unittest now passes.

2010-02-21  Noel O'Boyle

	* src/formats/gausscubeformat.cpp: Revert of change made in r3534. It
	just changed the warning to a different warning.

2010-02-21  Noel O'Boyle

	* src/CMakeLists.txt: Add LIBXML2 as a dependency of the XML formats

2010-02-20  Noel O'Boyle

	* src/CMakeLists.txt: Remove LIBXML2 as a dependency of the openbabel
	DLL

2010-02-20  Noel O'Boyle

	* include/openbabel/obmolecformat.h: Error compiling on some platforms
	due to extra qualification on member name

2010-02-19  Chris Morley

	* Changed the parameters of Do() in OBOp to include an OBConversion
	object and so allow a wider range of operations. A change in the
	order of parameters means that it is not code compatible. But all
	except the first have defaults and most, if not all, public ops use
	only the first and it is unlikely that any have been written external
	to OB.
	* include/openbabel/op.h, include/openbabel/optransform.h,
	src/ops/addpolarh.cpp,src/ops/fillUC.cpp,src/ops/gen2D.cpp,
	src/ops/gen3d.cpp,src/ops/optransform.cpp: Do() changed.
	
	* include/openbabel/base.h,include/openbabel/mol.h,
	src/formats/chemkinformat.cpp,src/formats/rsmiformat.cpp,
	src/formats/rxnformat.cpp,src/formats/xml/cmlreactformat.cpp,
	src/obmolecformat.cpp,src/formats/smilesformat.cpp,
	src/formats/textformat.cpp,: DoTransformations() also has 
	OBConversion* added.
	
	* src/formats/rxnformat.cpp, src/formats/rsmiformat.cpp:
	Ensure deletion of reaction if ReadMolecule returns false.

2010-02-19  Chris Morley

	* CMakeLists.txt: define HAVE_SHARED_POINTER
	* src/formats/CMakeLists.txt: narrow MSVC to MSVC90 for shard_ptr
	  support. (Still not narrow enough.) 

2010-02-19  Noel O'Boyle

	* src/formats/gausscubeformat.cpp: Add cast to a long to enable size_t
	value to be printed out (gets rid of warning on Mac + Intel Compiler)
	* src/descriptor.cpp: Using string::npos instead of -1 to get rid of
	warning

2010-02-19  Noel O'Boyle

	* src/CMakeLists.txt: Create plugin OBFs on Windows
	* tests/CMakeLists.txt: Rename test targets to test_*, to make them
	cluster together alphabetically in an IDE (e.g. MSVC)

2010-02-19  Noel O'Boyle

	* tests/conversion.cpp: Remove former test 8 as it was failing on
	Windows because of the open file handle.
	* src/formats/CMakeLists.txt: Build shared_ptr dependent formats on
	Windows. Really, the IF statements need to be changed to test for
	shared_ptr rather than BOOST per se.

2010-02-17  Noel O'Boyle

	* tools/obabel.cpp: Include cstdlib header to enable compilation
	on Linux (due to missing exit())

2010-02-16  Chris Morley

	* tools/CMakeLists.txt: build obabel
	* src/formats/CMakeLists.txt: rename the format obf files to formats_...
	so they appear together in Visual Studio.
	* src/formats/nulformat.cpp: exciting new format
	* windows-vc2008/default_build.bat, windowsOBF/OpenBabelOBF.sln:
	compile GUI but not tests.

2010-02-15  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/tinkerformat.cpp (OpenBabel): Add support for MMFF94
	atom typing with "-xm" flag. Fix warning from previous revision.

2010-02-15  Noel O'Boyle

	* scripts/openbabel-python.i: Get rid of warnings. Allow access to
	rotors. Tidy up the interface a bit (prevent people calling C++
	iterators, for instance)

2010-02-14  Noel O'Boyle

	* src/formats/CMakeLists.txt: Tidy up, and ensure that formats that
	formats with dependencies are included in the Windows build too.

	* src/formats/CMakeLists.txt: Group formats into four different OBF
	files
	
	* test/*: Avoid SafeOpen warnings by including obutil.h
	* src/stereo/perception.cpp: Added default to switch statement to
	avoid compiler warning about "not all paths return a value"
	* src/formats/gausscubeformat.cpp, cifformat.cpp: Added some static
	casts to avoid warnings
	* src/formats/gaussformat.cpp: Added explicit comparison against NULL
	to avoid warning
	* src/formats/cifformat.cpp: Disabled warning 4503 about very long
	decorated name being truncated. 

2010-02-13  Noel O'Boyle
	
	* src/forcefieldgaff.cpp: Fix warnings.

2010-02-13  Noel O'Boyle
	
	* test/*: Avoid SafeOpen warnings by including obutil.h
	* formats/gulpformat.cpp, inchiformat.cpp: Add some dynamic casts to
	avoid warnings

2010-02-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* test/CMakeLists.txt: Add FORMATDIR to point tests at appropriate
	format location.

	* test/*: Use it.

2010-02-12  Noel O'Boyle
	
	* src/formats/CMakeLists.txt: On Windows, make sure that the XML
	formats compile to the correct location. Also no need to have
	XML_INCLUDE on Windows.

2010-02-11  Noel O'Boyle
	
	* test/CMakeLists.txt: On Windows, put the test executables along with
	the compiled DLLs.

2010-02-10  Chris Morley

	* src/formats/mdlformat.cpp: allow numbers to be other than right
	justified. (As provided by Craig.)

2010-02-08  Noel O'Boyle

	* src/formats/inchiformat.cpp, smilesformat.cpp, xml/cmlformat.cpp:
	Removal of references to strstream (legacy from GCC 2.x).

2010-02-07  Noel O'Boyle

	* src/builder.h, cpp: Make things easier by referring to unsigned long
	instead of OBStereo::Ref. Fixes problem compiling Python bindings.

2010-02-06  Noel O'Boyle

	* src/builder.cpp: IsSpiroAtom assumed that Ids were preserved on
	copying a molecule. Not true.

2010-01-26  Chris Morley

	* src/formats/MNAformat.cpp: added new format from Jeremy Murphy
	* src/formats/CMakeLists.txt,
	  windowsOBF/OBUtilFormats/OBUtilFormats.vcproj: build files

2009-12-15  Noel O'Boyle

	* src/formats/smilesformat.cpp: Create OBPairData of "SMILES Atom
	Order" whenever creating a SMILES string (not just for canonical
	SMILES). Set to "local" so that it won't be written out to an SDF
	file.

2009-12-15  Chris Morley

	* include/openbabel/parsmart.h, src/parsmart.cpp: add support for
	$ as quadruple bond to SMARTS. (Already in SMILES.)
	
	* src/bond.cpp: reset OB_KTRIPLE_BOND, etc when changing bond order.
	Fixes corruption of isonitriles in #2913204

	* src/formats/fastsearchformat.cpp: adjust application of 
	ConvertDativeBonds() to fix #2913204

2009-12-14  Noel O'Boyle

	* src/GUI/OBGUI.cpp: Fix compilation on Linux.

2009-12-11  Chris Morley

	* include/openbabel/plugin.h, src/plugin.cpp: Make TypeID() virtual in
	base class. Move definitions of	BaseFindType and GetPlugin() to cpp file
	and make GetPlugin search all plugin types for an ID.
	 
	* tools/babel.cpp, tools/obabel.cpp: now get verbose description of any
	plugin with e.g. -L gen3D
	
	* src/GUI/OBGUI.cpp: above facility from the menu.	

2009-12-04  Chris Morley

	* src/formats/gaussformat.cpp: Rotational constants were sometimes
	being missed because of a warning message.

	* src/depict/depict.cpp, src/formats/svgformat.cpp: avaoid errors with
	molcules with one atom.


2009-11-28  Chris Morley

	* include/openbabel/depict/painter.h: add default #define of OBDEPICT
	
	* src/formats/fastsearchformat.cpp: correct declaration of AddPattern

2009-11-28  Chris Morley

	Avoid the OBPairData "OpenBabel Symmetry Classes" appearing
	as a property in sdf and cml output.  
	* include/openbabel/base.h(OBGenericData):add 'local' to enum DataOrigin
	* src/graphsym.cpp: SetOrigin "OpenBabel Symmetry Classes" to 'local'
	* src/formats/mdlformat.cpp, src/formats/xml/cmlformat.cpp:
	  Do not output 'local' OBPairData

2009-11-27  Chris Morley

	* src/formats/fastsearchformat.cpp: Give an estimate of the expected
	indexing time.
	When searching, can use [#6] etc. in -s option target to find both
	aromatic and non-aromatic atoms in second SMARTS stage. Also use ~ bond
	to match both aromatic and non-aromatic bonds in fastsearch stage.
	Moves some way towards allowing behaviour expected in #2828279.
	
	* src/formats/xml/cmlformat.cpp: Accept T for triple bond. Fixes
	#2903926
 
	
2009-11-27  Chris Morley

	* src/formats/smilesformat.cpp: add sread and write support for $
	quadruple bond.

2009-11-26  Chris Morley

	* src/transform.cpp:Avoid leading separators with --append

	* data/plugindefines.txt: comment out less useful examples


2009-11-23  Chris Morley

	* tools/nbabel: Renamed as obabel. This is an alternative commandline
	interface, e.g.   obabel in.smi -O out.sdf

	* tools/svgdepict.cpp: demo program producing a file for each molecule.
	
	Tidied WindowsOBF Tools project files.
	CMakefiles not updated.

2009-11-22  Chris Morley

	* data/element.txt, data/svgformat.script, include/openbabel/depict,
	include/openbabel/depict/depict.h, include/openbabel/depict/painter.h,
	include/openbabel/depict/svgpainter.h, src/depict/depict.cpp,
	src/depict/svgpainter.cpp, src/formats/svgformat.cpp: new files
	Add tweaked versions of Tim's OBDepiction and OBPainter classes with
	a new SVGPainter class using no external libraries. SVGFormat displays
	multiple molecules in a table, designed to be viewed in Firefox.

2009-11-21  Chris Morley

	* include/openbabel/alias.h, src/alias.cpp: extensively revised.
	Expanded aliases on 2D or 3D molecules have coordinates generated
	by builder. (Nitro group not quite right.) Can revert to alias form for
	output and display. Can also generate an alias form from normal molecule;
	not sure how useful this is. 
	 
	* data/superatom.txt: changed format; now also stores a right-connected
	form and color.
	
	* src/formats/mdlformat.cpp: add option for output in alias form.	
	Output extra zeros in atom and bond blocks, as pointed out by Ernst-Georg
	Schmidt bug #2897107, and CharlieZhu.
	
	* src/format/gulpformat.cpp: replaced the 'uint' by 'unsigned'.
	'uint' doesn't compile on Visual C++.

2009-11-20  Chris Morley
	
	* include/openbabel/obmolecformat.h, src/obmolecformat.cpp:
	When sent an OBReaction object, outputs the molecules, as requested
	by Charlie Zhu

2009-11-20  Chris Morley

    * include/openbabel/reaction.h: includes for std::tr1::shared_ptr modified.
      In <memory> for VC2008 SP11 and GCC 4.3 but in <tr1/memory> for earlier GCC    
	
	* src/dlhandler_win32.cpp: add another way of getting Module Handle for
	  CMake build.
	  
	* include/openbabel/alias.h: replace OBAPI by OBCOMMON.
      Goes in a different DLL in OBF build.
    
    * Added project files for VC9 with the original OBF Windows build.
      (windows-vc2008 is for the CMake build.) 
      
2009-11-20  Chris Morley
	
	* src/mol.cpp(operator+=):no underscore if added title empty.
	(Has3D) removed test which prevented the function being used before
	EndModify()
	
	* src/obconversion.cpp(SetOutFormat):test for NULL param
	(OpenInAndOutFiles):test for empty name
	
	* src/ops/loader.cpp: delete all instances when global instance
	deleted at end to avoid (pseudo) memory leaks warning.
	
	* include/openbabel/phmodel.h: added missing OBAPI so is exported.
	* include/openbabel/text.h: Extra parameter on GetText()
	* include/openbabel/xml.h: Simplify namespaces map.
	* src/descriptor.cpp: remove commented out code.
	* src/forcefields/forcefielduff.cpp: comment out unused variable
	* src/formats/chemdrawcdx.cpp: comment out unnecessary switch statements
	* src/formats/copyformat.cpp: increase buffer size by 1
	* src/GUI/optswx.cpp: make all editboxes same size
	
2009-11-18  Noel O'Boyle  <baoilleach@gmail.com>

	* include/openbabel/alias.h: Add OBAPI

2009-11-17  Noel O'Boyle  <baoilleach@gmail.com>

	* include/openbabel/src/alias.cpp: Correct error

2009-11-13  Noel O'Boyle  <baoilleach@gmail.com>

	* src/formats/inchiformat.cpp (WriteMolecule): Don't create
	stereo objects to pass to the InChI code if the stereo is unspecified.
	This avoids an InChI warning reported by Chris.

2009-10-29  Michael Banck  <mbanck@gmx.net>

	* src/formats/molproformat.cpp (ReadMolecule): Applied patch #2893477
	by Konstantin Tokarev to support numbered atoms.

2009-11-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/xml/xml.cpp (OpenBabel): Defensive programming for
	issue reported by Matt Sprague -- access violation when
	reading/writing xml formats.

2009-10-29  Michael Banck  <mbanck@gmx.net>

	* src/formats/outformat.cpp: Applied patch #2888693 to add support for
	PC-GAMESS/Firefly.  Addresses PR#2884618.

2009-10-25  Noel O'Boyle  <baoilleach@gmail.com>

	* builder.h, .cpp: Add code to fix ring stereochemistry if possible 
	by inverting the coordinates of a ring system.

2009-10-25  Chris Morley

	* include/openbabel/src/alias.cpp: Add warning that the current implementation
	does not add atom coordinates when it expands a superatom.
		
2009-10-24  Chris Morley

	* include/openbabel/alias.h, src/alias.cpp: To convert an alias name
	(like Ph) to real chemistry, look up in a table, convert the SMILES
	of the fragment and add it in. No coordinate generation yet.
	
	* data/superatom.txt: the datafile from http://cactus.nci.nih.gov/osra/
	It could do with more entries, which are easy to add.
	
	* src/formats/mdlformat.cpp: Reinstate the code reading  aliases which
	seems to have got mangled during a merge. Example in test/files/alias.mol

2009-10-24  Noel O'Boyle  <baoilleach@gmail.com>

	* src/parsmart.cpp, include/openbabel/parsmart.h: Make
	bond_parse_order an instance variable rather than a class variable.
	Fixes bug where multiple SMARTS patterns are parsed before being used
	to Match.

2009-10-08  Noel O'Boyle  <baoilleach@gmail.com>

	* src/builder.cpp: Don't attempt to fix stereochemistry if unspecified.
2009-10-19  Chris Morley

	* src/alias.cpp: Correct small memory leak as suggested by dcb #2881605

2009-10-06  Noel O'Boyle  <baoilleach@gmail.com>

	* src/forcefield.cpp: Correctly handle SteepestDescent and Conjugate
	Gradients where nsteps is 0 or 1

2009-10-05  Noel O'Boyle  <baoilleach@gmail.com>

	* src/forcefield.cpp: In ff.GetConformers(mol) if only a single
	conformer was generated it was not being copied.

2009-10-04  Noel O'Boyle  <baoilleach@gmail.com>

	* For Windows build, enable tests to be run in either Debug or Release
	build. Make the default solution file include the tests. Add a target
	for a minimal build.

2009-10-03  Noel O'Boyle  <baoilleach@gmail.com>

	* Update Windows build to use the InChI dll, and to build everything
	to the same folder (e.g. Release or Debug). Tests can be run in Debug
	build.

2009-10-03  Noel O'Boyle  <baoilleach@gmail.com>

	* src/builder.cpp: Update handling of stereochemistry to use new
	stereochemistry objects. For tetrahedral centres, stereochemistry is
	currently not corrected if there are three ring bonds on the centre.
	* src/forcefield.cpp: Fixed bug where the SystematicRotorSearch was
	missing the angle 0.

2009-07-31  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* NEWS: Bump for 2.2.3 release.

2009-07-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mmcifformat.cpp: Fix PR2824247 and 2824502,
	Contributed by Raik Brinkmann.

2009-08-16  Chris Morley

	* src/dlhandler_win32.cpp(getConvDirectory):changes which should affect
	only MSVC build. Get handle of this module, not the exe file. As found by
	Noel and by Mingyue Zheng this broke the Python bindings. 
	Correct the module name (different when debugging).
	OpenBabel2.2.3b_Windows_Installer.exe has this mod.
	
	* include/openbabel/dlhandler.h: minor doc change

2009-09-30  Noel O'Boyle  <baoilleach@gmail.com>

	* src/builder.cpp: Reapplied Geoff's fix from r3028 (undone in r3251)
	to enable 0D molecules to be handled

2009-09-27  Noel O'Boyle  <baoilleach@gmail.com>

	* src/GUI/OBGUI.cpp: GUI now compiles and runs successfully on MacOSX.

2009-09-27  Noel O'Boyle  <baoilleach@gmail.com>

	* include/openbabel/graphsym.h, src/graphsym.cpp: Changed how static
	const unsigned int was defined to conform with C++ standard as it
	caused a compile error on MacOSX (see
	http://forums.macosxhints.com/showthread.php?t=91497 for details)

2009-09-25  Noel O'Boyle  <baoilleach@gmail.com>

	Fixed some errors when compiling the GUI on Mac.

2009-09-25  Noel O'Boyle  <baoilleach@gmail.com>

	Fixed some warnings when compiling with Intel Compiler. 

2009-09-22  Noel O'Boyle  <baoilleach@gmail.com>

	* include/openbabel/format.h: Added include <typeinfo>. Now OB compiles
	using Intel Compiler.

2009-09-22  Noel O'Boyle  <baoilleach@gmail.com>

	* src/GUI/babel.xpm: Applied patch from Riccardo Vianello (r_vianello
	at SF) to avoid warnings when building on Linux

2009-09-21  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/*: Copied + pasted the scripts directory from 22x as a number
	of commits were never merged.

2009-09-20  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/CMakeLists.txt: Support for pybel. Revert regression that
	prevented linked against Python libraries.
	* include/openbabel/text.h: Add newline at end to avoid warning

2009-09-19  Noel O'Boyle  <baoilleach@gmail.com>

	Miscellaneous static_casts added and unused variables removed to get rid
	of warnings under MSVC

2009-09-18  Noel O'Boyle  <baoilleach@gmail.com>

	* include/openbabel/generic.h: Remove unused declarations that caused
	warnings under MSVC
	* test/obtest.h: Make compatible with MSVC
	* test/CMakeLists.txt: Build tests in the same location as the OB DLL
	(Windows only)
	* src/formats/CMakeLists.txt: Build obf files in same location as the
	OB DLL (Windows only)
	* CMakeLists.txt, CTestConfig.cmake: Option to submit tests to dashboard
	* windows-vc2008, *.bat: Tidy up batch files for building OB

2009-09-17  Noel O'Boyle  <baoilleach@gmail.com>

	* CMakeLists.txt, data/CMakeLists.txt: Tidy up the Windows build. The
	goal is to have CMake make something as close as possible to a
	distribution.

2009-09-17  Noel O'Boyle  <baoilleach@gmail.com>

	* include/stereo/stereo.h: Remove obsolete stereo functions and
	associated documentation
	* scripts/CMakeLists.txt: Add option PYTHON_PREFIX to allow the user
	to specify where the Python library will be installed. Note that it
	creates an _openbabel.dll on Windows in error (it should be
	_openbabel.pyd).

2009-09-17  Noel O'Boyle  <baoilleach@gmail.com>

	* src/parsmart.cpp: Handle ring-closure bonds involved in

2009-09-17  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* CMakeLists.txt: Don't attempt to use GCC visibility support on WIN32. 
        Doesn't work with MinGW and produces lots of warnings.

        * src/mcdlutil.cpp: include cmath for MinGW builds.

        * src/config.h.cmake: Don't use dllimport/dllexport for MinGW build. GCC's
        auto-import feature will handle this automatically.

2009-09-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/stereo/perception.cpp: Implement para-stereocenter detection.
	 (see J. Chem. Inf. Comput. Sci., Vol. 33, No. 6, 1993 or code for details)

2009-09-16  Noel O'Boyle  <baoilleach@gmail.com>

	* src/GUI/CMakeLists.txt: Add icon. Add comctl32.lib for Windows
	build.
	* windows-vc2008, windows-vc2006/cmake.bat: Create new folder for
	MSVC++ Express 2008. Add batch file to run cmake.

2009-09-16  Noel O'Boyle  <baoilleach@gmail.com>

	* src/GUI/optswx.cpp: Minor mods to compile on Linux.

2009-09-13  Chris Morley

	* src/GUI/OBGUI.h,OBGUI.cpp:
	Replace deprecated file drag-and-drop with newer version using 
	wxFileDropTarget. Works in Windows; might even work in Linux.

	* src/GUI/optswx.cpp: options can now have a checkbox and an
	edit box allowing options to have parameters. These changes conflicted
	with the mods for Linux compatibility. The resolved version needs to be
	checked with Linux in case mistakes were made..

2009-09-11  Noel O'Boyle  <baoilleach@gmail.com>

	* src/GUI/CMakeLists.txt: Added Win32 to ensure that on Windows
	a command-line application was not created.

2009-09-11  Noel O'Boyle  <baoilleach@gmail.com>

	* src/GUI/*.h, *.cpp: Large number of minor mods for compatibility with unicode build of wxWidgets
	* CMakeLists.txt, src/GUI/CMakeLists.txt, tools/CMakeLists.txt: (1) Cmakeify the GUI build, (2) Add an option to
	enable a minimal build, consisting of just two file formats and one tool.

2009-09-06  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Fix Random & Systematic Rotor Search crashes. 
        (Fixes crashes in Avogadro here on 64bit)

2009-09-01  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/parsmarts.cpp: Some bug fixes to SMARTS with stereochemical atoms.

2009-08-31  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/parsmarts.cpp: First attempt to make smarts work again. Should be
        working for tetrahedral stereochemistry. Cis/Trans may still need some
        more code.


2009-08-26  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/fingerprint.cpp, include/openbabel/fingerprint.h,
	src/formats/fastsearchformat.cpp: Patches from Izhar Wallach for a
	similarity search within a range (e.g. Tanimoto from 0.6-0.8).

2009-08-21  Craig James <cjames@emolecules.com>

	* src/kekulize.cpp, include/openbabel/mol.h: Rewrote
	expand_kekule() in kekulize.cpp, making it much simpler to
	understand.  Original algorithm had bugs and was very hard to
	follow.

	* src/formats/mdlformat.cpp: Replaced atoi(), which would
	incorrectly accept some invalid numbers, with a custom function
	that catches most invalid numbers.  Fixed several bugs that caused
	core dumps for unusual or incorrectly-formatted SD files.
	Improved a couple of error messages.  Commented out one section
	that was supposed to read R-group definitions; the code was
	plainly wrong and caused core dumps, but the MDL spec is complex
	and it will take some work to get this right (it's a deprecated
	part of the CTAB spec anyway).
	
	* src/formats/smilesformat.cpp: Fixed two bugs: the pseudo atom '*'
	was always printed with brackets '[*]', and boron atoms were
	sometimes printed with brackets '[B] when they shouldn't be.
	
	* src/obiter.cpp: Added a number of tests for NULL pointers.  New
	stereo code was causing core dumps when atoms had zero bonds.

	* src/mol.cpp: Added a test to catch a NULL pointer that was
	causing a core dump for molecules with one atom.

	* src/stereo/percepton.cpp: Removed a warning that was issued for
	almost every SMILES.

	* Added "svn:ignore" properties for the cmake(1) files
	so they're ignored by Subversion.

2009-08-03  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/math/transform3d.h: add missing const to operator*.
	* src/math/transform3d.cpp:

2009-08-02  Jean Brefort  <jean.brefort@normalesup.org>

	* data/space-groups.txt: updated after group 229 fix.

2009-08-01  Daniel Leidert  <daniel.leidert@wgdd.de>

	* doc/babel.1, doc/obchiral.1: Fixed "mdoc warning: Extraneous .Re".

2009-07-13  Chris Morley

	* src/formats/smilesformat.cpp: make the description of -xh more
	informative: it retains explicit hydrogen.
	
	* src/formats/fastsearchformat.cpp: in the second phase the SMARTS
	from both the -s option and (optionally) with -S from a file now
	retains its explicit hydrogen, to allow lack of substitution to be
	specified.
	
	* src/formats/xml/cmlformat.cpp: can now read vibrational
	frequencies and rotational constants as well as writing them.

2009-07-15  Daniel Leidert

	* doc/babel.1: Fixed hyphen used as minus sign.

2009-07-13  Chris Morley

	* src/formats/fingerprintformat.cpp: set initial nbits=0 (default)
	and remove the setting of FP4 as the default fingerprint. 
	(FastsearchFormat remained at FP2.) OBPlugin derived classes have
	a built-in mechanism for setting defaults.
	
2009-07-08  Chris Morley

	* src/transform.cpp(OBMol::ClassDescription) Change description of -p so that GUI 
	takes pH parameter.
	 
2009-07-08  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-java.i: Added support for foreach loops using the
	Iterators.

2009-07-08  Chris Morley

	* windows-vc2005/OBCommonFormats/OBCommonFormats.vcproj,
	OBMoreFormats.vcproj: add outformat, molproformat, vaspformat
	(still not gamessukformat because of need for regex)
	
	* windows-vc2005/babelconfig.h: update version to 2.2.2
	
2009-07-08  Chris Morley
	
	* src/formats/gaussformat.cpp: small change to parsing to prevent
	crash on some files.

2009-07-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/Makefile.am, data/Makefile.in: Only build data headers if
	Perl is present.

	* Change __CYGWIN__ ifdef to also include MINGW.

2009-07-06  Chris Morley

	* src/dlhandler_win32.cpp: omit call to GetModuleHandle and just 
	obtain exe path by calling GetModuleFileName with a zero handle.
	MSVC build works again but a better solution is needed. 

2009-07-05  Tim Vandermeersch

	Make sure there is only one PluginMap for each plugin type. (Fixes
	cygwin builds, all formats  are now shown when running babel
	-H). Also added some cygwin specific code to dlhandler_win32.cpp
	to find the plugin path (..\lib\openbabel\BABEL_VERSION).

2009-07-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/generic.cpp (OBRingData): Fix bug in ring iterators,
	reported by Fredrik. PR#2815025.
	
	* test/iterators.cpp: Unit test for it.

2009-07-01  Noel O'Boyle  <baoilleach@gmail.com>

	* AUTHORS: Added my name

2009-06-27  Chris Morley <c.morley@gaseq.co.uk>

	* src/formats/xml/cmlformat.cpp: in reading <property> check that
	dictRef not found before reading title.
	Prevent crash if <symmetry> not read correctly.
	
	When writing <property> use dictRef rather than title if attr
	is namespaced.
	
	* src/math/vector3.cpp: sometimes needs #include <float.h>
	
2009-06-27  Chris Morley <c.morley@gaseq.co.uk>

	Make parsing of SMILES files stricter, following discussion on
	mailing list.
	* src/formats/smilesformat.cpp(Read Molecule):
	lines starting with # are ignored; lines starting with whitespace
	terminate (except with -e option); illegal chars reported;
	when using OBConversion::Convert(), the components of a SMILES reaction
	are output if it is a valid reaction with non-null reactant and product.
	
	(OBSmilesParser::SmiToMol): the string parameter is made const. This
	simplifies its use, e.g. can use substr. Similar changes would be useful
	elsewhere in OB. 
	 
	* src/formats/rsmiformat.cpp: re-written because of smilesformat changes.
	Now handles multiple reactants and products.

2009-06-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/zipstream*: Add support for tellg() / seekg(). Improves
	support for compressed mol2 files (although still bugs
	there). Positions from tellg() & seekg() mirror uncompressed data.

	* test/zipstream.cpp: New test to check if tellg/seekg support
	works.

2009-06-25  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/kekulize.cpp: Use SMARTS pattern "[aR3]" to determine if
	*any* atoms dictate a fused ring analysis. Fixes problem with
	perylene.

	* test/files/*.smi: Add perylene as a test example.

	* src/builder.cpp (GetNewBondVector): Fix part of PR#2811932 from
	Avogadro. Make sure adding hydrogens to carboxylic acid always
	occurs trans to the other oxygen atom.

	* src/data.cpp: Don't consider all sp3 hydrogens as O-, instead
	leave this for phmodel protonation. Fixes PR#2785237.

2009-06-24  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mopacformat.cpp: Read and write translation vectors,
	if available.

	* src/formats/gaussformat.cpp: Ditto

	* src/generic.cpp (OBUnitCell): Make sure to set the space group
	to P1 by default and after FillUnitCell.

2009-06-22  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/generic.cpp: Fix unit cell when setting possibly zero
	translation vectors ( e.g. PR#1961604).

2009-06-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/chains.cpp: Fix for PR#2691618. When writing
	hydrogen atoms without chain names, make sure there are never
	spaces.

	* src/mol.cpp, src/atom.cpp: Test for assigning atoms and
	molecules to themselves. PR#2698096. Thanks to Pierre-Louis.

	* src/bondtyper.cpp: Add oxime functional group assignment:
	PR#2793910.

	* src/kekulize.cpp: Additional cleanups. Should be more accurate
	across a wide range of ring systems. Fixes PR# 2705497 and
	PR#1814248. For fused rings (e.g., C60) uses old algorithm.

	* test/files/nci.smi: Add test cases for PR above.

	* src/phmodel.cpp: Fix PR#2802980. Allow single-atom charge
	transformations.

2009-06-20  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/kekulize.cpp (expandcycle): Rewritten as cleaner recursive
	function. Look for largest possible aromatic cycle, including
	handling fused "figure 8" ring systems.

2009-06-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/kekulize.cpp (expandcycle): Fix PR#2705497. Kekulize has
	problems with fused aromatic rings joined by a non-aromatic
	ring. Make sure when expanding aromatic cycles that we only accept
	atoms which are in the *same* ring from OBMol::GetSSSR().

	* test/*: Update with recent changes.

2009-06-18  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/Python/README, scripts/csharp/README: Minor updates

2009-06-16  Noel O'Boyle  <baoilleach@gmail.com>

	* windows-vc2005/OBCSharp and CSharp files in scripts: Separate .NET
	and Mono SWIG files. Move .NET files to windows-vc2005. Update
	relevant files.

2009-06-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/obconversion.cpp (Read): If we used ReadFile, close the file
	after an error.

2009-06-14  Chris Morley <c.morley@gaseq.co.uk>

	* src/formats/inchiformat.cpp: InChI adds an implicit H to H and 
	represents H2 with one implicit H. Since H does not have implict H
	in OB, need to treat as special	cases.
	Fixes #2794908, where H was written wrongly to InChI and H2 read
	wrongly.
	
	* windows-vc2005/libinchi.dll,libinchi.lib: replaced by libstdinchi.dll
	and libstdinchi.lib
	* windows-vc2005/OBInchi/OBInchi.vcproj: updated for new inchi version.

2009-06-14  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/pybel_pyN.x.py: Use OBBuilder instead of the
	gen3d operation. 

2009-06-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/inchiformat.cpp, src/formats/inchi102: Backport the
	InChI 1.02 standard code.

2009-06-14  Noel O'Boyle  <baoilleach@gmail.com>

	* src/kekulize.cpp: In an aromatic ring with two nitrogens, one a
	pyrrole-type, the other a pyridine-type, ensure that the pyrrole-type
	N donates 2 PI electrons. Fixes PR#2711501

2009-06-14  Chris Morley <c.morley@gaseq.co.uk>

	* src/ops/fillUC.cpp: Tidy up the Description so that it is more
	suitable for the GUI.
	
	* windows-vc2005/gen3D/gen3D.vcproj: add fillUC.cpp to build.

2009-06-13  Chris Morley <c.morley@gaseq.co.uk>
	
	* src/formats/mdlformat.cpp: Read V property line.
	Put contents into a OBPairData with attribute "AtomValue"
	attached to the OBAtom, and, if the -av option is NOT set, 
	also interpret as a partial charge.
	Fix for #2805389

2009-06-08  Michael Banck  <mbanck@gmx.net>

	* src/formats/gamessformat.cpp (ReadMolecule): Tighten match for
	frequencies.

	*  src/formats/gamessformat.cpp (ReadMolecule): Support imaginary
	frequencies.

2009-06-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* test/Makefile.am: Remove kekule.cpp used as an internal test.

2009-06-05  Noel O'Boyle  <baoilleach@gmail.com>

	* src/math/vector3.cpp: Reenable defensive checks in calculation of
	angle between two vectors. Prevents bug where dp is slightly greater
	than 1.0 under certain conditions.

2009-06-05  Noel O'Boyle  <baoilleach@gmail.com>

	* src/builder.cpp: Prevent partial matching. The code currently
	doesn't handle this.

2009-06-05  Noel O'Boyle  <baoilleach@gmail.com>

	* src/builder.cpp: Skip SMARTS patterns that are too big to match.
	Smaller performance boost.
	
2009-06-02  Noel O'Boyle  <baoilleach@gmail.com>

	* src/builder.cpp: Only iterate over the unique SMARTS matches and
	stop once all ring atoms have been assigned. Performance win.
	
2009-05-29  Michael Banck  <mbanck@gmx.net>

	* src/formats/gausszmatformat.cpp (ReadMolecule): Account for negative
	variable reference in dihedral angles, patch by Hugh Chaffey-Millar.
	Fixes PR#2798297.
	
2009-05-28  Michael Banck  <mbanck@gmx.net>

	* src/formats/gausszmatformat.cpp (ReadMolecule): Fix reading of
	dihedral angles, patch by Donnie Berkholz <dberkholz@gentoo.org>.

2009-05-27  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-python.i: Allow access to OBBuilder and matrix3x3

2009-05-19  Michael Banck  <mbanck@gmx.net>

	* src/formats/gaussformat.cpp (ReadMolecule): Add parsing of NMR
	isotropic shifts.  Patch by David C. Lonie.  Fixes PR#2787088.

2009-05-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/generic.cpp (OBUnitCell::FillUnitCell): Update with code
	from Avogadro. Now should handle duplicate atoms.

2009-05-04  Michael Banck  <mbanck@gmx.net>

	* src/formats/moldenformat.cpp (ReadMolecule): Read in atom
	coordinates via [FR-COORD] block if no atoms have been read
	previously.  Fixes PR#2786716.

	* src/formats/gamessformat.cpp (ReadMolecule): Fix parsing of
	intensities.  Keep on reading displacements even if there is only a
	single one.  Rewritten normal coordinates parsing.  Fixes PR#2782132.

2009-05-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/element.txt, data/element.h: Update atomic radii with
	consistent sets from recent publications.

2009-04-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/molchrg.h, include/openbabel/internalcoord.h,
	include/openbabel/typer.h, include/openbabel/chains.h,
	include/openbabel/descriptor.h, include/openbabel/atomclass.h,
	include/openbabel/parsmart.h, include/openbabel/grid.h: 
	Improved forward declarations, thanks to Noel's python script.

2009-04-26  Michael Banck  <mbanck@gmx.net>

	* src/formats/moldenformat.cpp (WriteMolecule): New method,
	implementing atom coordinates and vibrations.  Set flags() to
	WRITEONEONLY for now.

	* src/formats/moldenformat.cpp (ReadMolecule): Do not care about case
	of vibration header tag for the displacements.  MOLPRO writes
	upper-case "Vibration", Molden writes lower-case "vibration".
	
	* src/formats/moldenformat.cpp (BOHR_TO_ANGSTROM, ANGSTROM_TO_BOHR):
	New definitions.  
	(ReadMolecule): Use them.
	(WriteMolecule): Likewise.

	* src/formats/moldenformat.cpp (ReadMolecule): Do not continue to next
	line when a block is finished as the current lineBuffer already
	consists of the next [KEYWORD].

	* src/generic.cpp (GetNumberOfFrequencies): Fix return value.
	* src/formats/moldenformat.cpp (WriteMolecule): Adjusted.

	* src/formats/moldenformat.cpp (Description): Updated.

	* src/formats/moldenformat.cpp (WriteMolecule): Do not set intensities
	to zero if none are present.

2009-04-23  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/obiter.h (OpenBabel): Add forward declaration
	of OBRing and OBRingData suggested by Anton Simakov.

2009-04-22  Noel O'Boyle  <baoilleach@gmail.com>

	* include/openbabel/rotor.h: #ifndef SWIG added due to problems
	compiling the CSharp bindings

2009-04-22  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/Makefile.am: Fix some conditional compiles. Should
	help fix compile problem reported with 2.2.1 on Cygwin by Igor
	Filippov.

2009-04-21  Noel O'Boyle  <baoilleach@gmail.com>

	* src/obiter.cpp: Bugfix for off-by-one error in OBMolAtomBFSIter.

2009-04-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/bond.cpp (SetLength): Fix bug uncovered by Marshall
	Levesque. When two atoms are at the same position, move slightly
	to prevent invalid (NaN) coordinates.

2009-04-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/qchemformat.cpp (ReadMolecule): Fix tokenize mistake
	when reading Q-Chem vibrational intensities.

2009-04-11  Michael Banck  <mbanck@gmx.net>

	* src/formats/outformat.cpp (ReadMolecule): Added MOLPRO output
	file detection.

2009-04-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/rotamer.cpp, src/math/spacegroup.cpp, src/mol.cpp,
	src/formats/smilesformat.cpp, src/formats/pdbformat.cpp,
	src/formats/MCDLformat.cpp, src/formats/xml/cmlformat.cpp: 
	Compiler warnings and cppcheck complaint fixes.

2009-04-08  Michael Banck  <mbanck@gmx.net>

	* src/formats/gaussformat.cpp (ReadMolecule): Adjust normal modes
	parsing when Raman intensities are present.  Fixes PR#2728543.

2009-04-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/smilesformat.cpp: Fix compile error. Make sure to
	cast NULL in a vector constructor.

	* src/formats/CMakeLists.txt: Add Michael's Molpro format.

	* src/forcefield/forcefieldmmff94.cpp: Fix errors in PR#2741658
	and PR#2741669, reported by  Tushar Jain.

2009-04-07  Michael Banck  <mbanck@gmx.net>

	* src/formats/molproformat.cpp (ReadMolecule): Added dipole 
	moments.

2009-04-07  Michael Banck  <mbanck@gmx.net>

	* src/formats/nwchemformat.cpp (ReadMolecule): Added frequencies
	and IR intensities support.  Fixes PR#2728437.

	* src/formats/moldenformat.cpp (ReadMolecule): Added frequencies
	and IR intensities support.  Closes PR#2737715.

	* src/formats/molproformat.cpp: New file.  Closes PR#2731625.
	* src/formats/Makefile.am: Updated.
	* src/formats/Makefile.in: Regenerated.

2009-04-06  Noel O'Boyle  <baoilleach@gmail.com>

	* src/formats/smilesformat.cpp,
	windows-vc2005/OBCommonFormats/OBCommonFormats.vcproj
	windows-vc2005/OBUtilFormats/OBUtilFormats.vcproj:
	remove contamination from experimental version so that compiles again.

2009-06-27  Chris Morley <c.morley@gaseq.co.uk>

	Make parsing of SMILES files stricter, following discussion on
	mailing list.
	* src/formats/smilesformat.cpp(Read Molecule):
	lines starting with # are ignored; lines starting with whitespace
	terminate (except with -e option); illegal chars reported;
	when using OBConversion::Convert(), the components of a SMILES reaction
	are output if it is a valid reaction with non-null reactant and product.
	
	(OBSmilesParser::SmiToMol): the string parameter is made const. This
	simplifies its use, e.g. can use substr. Similar changes would be useful
	elsewhere in OB. 
	 
	* src/formats/rsmiformat.cpp: re-written because of smilesformat changes.
	Now handles multiple reactants and products.

2009-04-21  Chris Morley <c.morley@gaseq.co.uk>
	* data/atomtyp.txt: removed alkalis, alkaline earths,
	In,Tl,Sn,Pb,Sb,Bi from IMPVAL list. (Elements with IMPVAL entries
	are given implicit hydrogens.) Corrects problem Fredrik Wallner
	had with Na.
	Also some others, incl S- to fix #2782327
	
2009-04-21  Chris Morley <c.morley@gaseq.co.uk>

	* src/alias.cpp: Added code to handle isotopic atoms to fix 2777494

2009-04-16  Chris Morley <c.morley@gaseq.co.uk>

	* include/openbabel/reaction.h, src/formats/rsmiformat.cpp,
	src/formats/rxnformat.cpp: add Clear() function for OBReaction and
	apply it via CastAndClear<OBReaction>() in the formats before reading.

2009-03-07  Daniel Leidert <daniel.leidert@wgdd.de>

	* include/iconv.h, src/formats/xml/iconv.h, src/strncasecmp.c: Fixed
	FSF address.

2009-03-02  Daniel Leidert <daniel.leidert@wgdd.de>

	* doc/babel.1, doc/obchiral.1, doc/obconformer.1, doc/obenergy.1,
	doc/obfit.1, doc/obgen.1, doc/obgrep.1, doc/obminimize.1,
	doc/obprobe.1, doc/obprop.1, doc/obrotamer.1, doc/obrotate.1,
	doc/roundtrip.1: Prevent hyphenation of URLs. Fixed an mdoc issue.

2009-03-02  Daniel Leidert <daniel.leidert@wgdd.de>

	* src/formats/smilesformat.cpp: Correct use of sprintf().
	http://lists.debian.org/debian-devel/2008/12/msg01079.html

2009-03-02  Chris Morley

	Added xtcformat,pqrformat,opendxformat to Visual Studio build.
	Could not add gamessukformat because it uses <regex.h>
	and did not have time to find a workaround (Boost probably).
	 
2009-03-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/residue.cpp, src/fingerprint.cpp, src/zipstreamimpl.h,
	src/obconversion.cpp, src/dlhandler_unix.cpp,
	src/formats/rxnformat.cpp, src/formats/fchkformat.cpp,
	tools/babel.cpp, include/openbabel/xml.h,
	include/openbabel/obconversion.h,
	include/openbabel/obmolecformat.h, include/openbabel/data.h:
	Fix #includes to handle GCC-4.3 and 4.4. Thanks to Rathann
	Mierzejewski.

	* src/pointgroup.cpp, src/formats/xtcformat.cpp: Remove calls to
	exit() uncovered by Rathann.

2009-02-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp (Separate): Fix crash with Separate
	(PR#2553217). Currently uses defensive programming. This
	particular test file seems to have problems. 

2009-02-24  Marcus D. Hanwell  <marcus@cryos.org>

	* src/grid.cpp: Fixed some off by one errors in the way the max vector
	and spacing were calculated. More work is needed to make this work
	with grids aligned along arbitrary axes.

2009-02-27  Kevin Shepherd <kshepherd1@users.sourceforge.net>
	
	* src/formats/acrformat.cpp, src/formats/carformat.cpp
	src/formats/gamessformat.cpp, src/formats/mmcifformat.cpp: Compile
	warnings and minor additions to format information.

2009-02-22  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/examples/testpybel.py, openbabel-python.i: Just
	discovered a regression in latest SWIG. It didn't rename the bool()
	method, with the result that all Python iterators were failing. It
	turns out that this isn't necessary in the first place, so we can
	workaround. I've added a test to testpybel.py to check for any
	problems in future.

2009-02-20  Chris Morley
	
	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi:
	env var BABEL_DATDIR wasn't being overwritten, so now deleted first
	
	* windows-vc2005/OBCommonFormats/OBCommonFormats.vcproj:
	removed atomrecord.cpp

2009-02-20  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/qchemformat.cpp: Fix painful crash with Q-Chem 3.2
	output files when trying to parse vibrations.

2009-02-19  Noel O'Boyle  <baoilleach@gmail.com>

	* Windows Installer: Some changes to how environment variables are set
	to play nicer with the Python extensions. Bumped up version number.
	* babelconfig.h: Bumped up version number reported by (Windows) babel
	* scripts/python/examples/testpybel.py: Minor correction

2009-02-19  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/pybel_py3.x.py: Docstring correction
	* scripts/python/pybelapi.html: Update
	* scripts/python/examples/testpybel.py: Improve coverage

2009-02-18  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/pybel_py2.x.py, pybel_py3.x.py: Synch with cinfony.
	Long overdue.

2009-02-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/Makefile.am, scripts/Makefile.in: Fix: don't attempt to
	build Java or C# unless appropriate configure flags were set.

2009-02-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/gamessformat.cpp, src/formats/mopacformat.cpp,
	src/formats/gaussianformat.cpp, src/formats/qchemformat.cpp:
	Import vibrational data from several QM formats.

	* src/formats/cifformat.cpp: Fix problems reading CIF files with
	empty tags. Can lead to a crash.

2009-02-10  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp: Fix crash with OOP
	calculations (e.g., C(O)(=O)C.

	* src/formats/fchkformat.cpp: Use 16-character fields for
	coordinates to handle Q-Chem fchk files.

	* src/formats/smilesformat.cpp: Fix problem with bracketing every
	atom. Logic was wrong.

	* src/formats/qchemformat.cpp: Change formatting of NMR strings.

2009-02-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/bond.h: Add "friend OBMol" to allow OBMol to
	unset flags on bonds.

	* src/mol.cpp (EndModify): Unset ring bond membership. Fixes bug
	#2568349.

	* src/formats/pdbformat.cpp: Add more warnings for strange ATOM
	records, contributed by Pierre-Louis.

2009-01-29  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/element.txt, data/element.h: Change maxbonds for P to 6
	(e.g. PF6-).

	* src/formats/smilesformat.cpp: Mark coordinated water molecules
	as [OH2] to address PR#2505562.

	* src/formats/cifformat.cpp: Assign formal charges to halides and
	alkali when coordinated to a water molecule.

	* src/formats/pdbformat.cpp: Add -ac option to ignore CONECT
	records, contributed by Izhar.
	
2009-01-23  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp: Ensure H-O-H, H-S-H, and
	similar bond angles are done correctly. Fixes PR#2527588.

	* src/formats/pdbformat.cpp: Further refinements to parsing ATOM
	records, contributed by Pierre-Louis Bonicoli for PR#2 27225.

	* configure.in, acinclude.m4, configure: Properly check for gzip
	support. Fixes PR#2527272.

	* src/formats/smilesformat.cpp: Add a check for atoms with unusual
	valence (e.g., B with >3 bonds, C with 5, etc.). As requested for
	CIF translation.

	* src/formats/cifformat.cpp: Turn off automatic formal
	charges. Add a pass to look for typical ions and correct their
	formal charges.

	* data/atomtyp.txt: Add implicit valence and hybridization rules
	for most main-group elements.

	* src/ops/gen3d: Add a cleanup step with MMFF94 or UFF, including
	quick conformer searching. Should provide better results for most
	people.

	* src/builder.cpp: Add new function GetCorrectedBondVector() which
	scales new bonds based on elements provided and bond order (e.g.,
	similar to OBBond::GetEquibLength).

2009-01-22  Noel O'Boyle  <baoilleach@gmail.com>

	* windows-vc2005/Distribution/CheckInstallerScript.py,
	NSISScriptToCreateInstallerOBF.nsi: Update Python script to check for
	.prm files, and update installer to include MACCS.txt and missing .prm
	file.

2009-01-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/builder.cpp (Build): Make sure all bonds are copied into the
	newly-built molecule.

2009-01-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/cifformat.cpp: Fix for PR#2100215. Difficult bug -- file is
	missing a ';' on line 189. Other CIF programs had difficulty,
	including CIFTOOLS. Handle such non-standard files by issuing
	warnings when a ; line is not properly terminated and we find a
	new tag.

	* data/atomtyp.txt: Add an external type for O-H hydrogens for
	Tinker/MM2. Solves PR#1839274.

2009-01-18  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/fragments.txt: Expanded ring template database -- 2500 of
	the most frequent rings (including three-membered rings like
	cyclopropane or epoxides). Fixes PR#2043319.

2009-01-16  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/dlhandler_unix.cpp (openLib): Handle error reporting here --
	which will allow more informative messages to users, rather than
	just "did not load properly."

	* src/obconversion.cpp: Disable error messages, as per above.

	* src/parsmart.cpp: Remove some unused code, and add comments
	towards support of fragment SMARTS, e.g. (*).(*).

2009-01-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/pdbformat.cpp, src/formats/pqrformat.cpp: Patch
	contributed by Pierre-Louis Bonicoli PR#2503113. Take elements
	from the PDB 'element column' in preference to guessing based on
	atom type names (which are unreliable).

2009-01-14  Noel O'Boyle  <baoilleach@gmail.com>

	* windows-vc2005/OBPythonOBF/OBPythonOBF.vcproj: Minor fix to
	outdir (had trouble with paths with spaces)
	* windows-vc2005/OBCSharp/OBCSharp.vcproj: Moving to Swig 1.3.37
	* scripts/csharp/example.py: Partial revert of r2833 to bring back my
	IronPython example script

2009-01-14  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/pybel.py split into pybel_py2.x.py, pybel_py3.x.py:
	Adding support for Python 3.
	* scripts/openbabel-python.i, scripts/python/examples/testpybel.py,
	scripts/python/setup.py, windows-vc2005/OBPythonOBF/setup.py: Adding
	support for Python 3.
	* windows-vc2005/OBPythonOBF/OBPythonOBF.vcproj: Moving to SWIG
	1.3.37 (need to specify -outdir).

2009-01-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/gzmatformat.cpp: Address PR#2056697 for Gaussian
	z-matrix with embedded numbers (no variables) or no "Variables:"
	line.

2009-01-10  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/smilesformat.cpp: Address crash in SMILES import
	with chiral ring closures. ChiralSearch vectors were too
	small. Should address PR#2498047.

	* configure.in, scripts/Makefile.am: Check for javac and jar at
	configure time. Do not run them unless present. Solves PR#2426622.

2009-01-09  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp,
	src/forcefields/forcefielduff.h: Add support for 5-coordinate
	and other unusual coordination environments (including lone pairs
	for hypervalent species). Not perfect, but much better than
	before.

	* src/formats/outformat.cpp: Add comments about single bonds and
	bond orders (which are followed by all QM output formats).

	* src/formats/gamessformat.cpp: Add patch from Albert DeFusco for
	GAMESS EFP fragments. PR#2484103.

2008-12-31  Noel O'Boyle  <baoilleach@gmail.com>

	* include/inchi102, src/fomats/inchi102: Fix compile/link for
	Linux/Mac of InChI 1.02. Make sure in the future to import the
	InChI DLL code. (I'm not sure what the other code is, honestly).

2009-03-08  Chris Morley

        Standard InChI (1.02final)
	* src/formats/inchiformat.cpp, include/inchi_api.h:
	Several function names changed, removed most of the options code
	Works with the precompiled Windows files windows-vc2005/libstdinchi.dll,
	windows-vc2005/libstdinchi.lib, windows-vc2005/OBInchi/OBInchi.vcproj
	
	* The inchi API files have been uploaded to
	  include/inchi102, and  src/formats/inchi102	
	** but the building of inchi files needs to be sorted out for linux **

2009-03-07  Daniel Leidert <daniel.leidert@wgdd.de>

	* include/iconv.h, src/formats/xml/iconv.h, src/strncasecmp.c: Fixed
	FSF address.

2009-03-02  Daniel Leidert <daniel.leidert@wgdd.de>

	* doc/babel.1, doc/obchiral.1, doc/obconformer.1, doc/obenergy.1,
	doc/obfit.1, doc/obgen.1, doc/obgrep.1, doc/obminimize.1,
	doc/obprobe.1, doc/obprop.1, doc/obrotamer.1, doc/obrotate.1,
	doc/roundtrip.1: Prevent hyphenation of URLs. Fixed an mdoc issue.

2009-03-02  Daniel Leidert <daniel.leidert@wgdd.de>

	* src/formats/smilesformat.cpp: Correct use of sprintf().
	http://lists.debian.org/debian-devel/2008/12/msg01079.html

2009-02-05  Chris Morley
		
	* include/openbabel/bond.h: Added parameter to SetInRing to allow
	it to be unset. (No other public way to do this.)
	
	* src/mol.cpp:(EndModify): Clear all OBBond (OB_RING_BOND)flags to
	fix bug #2568349 	
	(operator=): Copied flags OB_TCHARGE_MOL, OB_TSPIN_MOL and
	OB_PATTERN_STRUCTURE manually because all flags are cleared.
	
2009-01-30  Chris Morley

	* src/formats/chemkinformat.cpp: Move initialization into a
	separate function Init()
	
	Change option -al to -aL (Reactions have labels) to avoid conflict
	with other formats
	
	* src/formats/xml/cmlformat.cpp: Correct floatg error in CML1 output.
	Added generic WriteScalarProperties()
	Output molecular spinMultiplicity as a property, not an attribute.
	On outputing a property, if the title has a namespace use dictRef
	rather than title.
	Output (non-zero) energy from OBMOl::GetEnergy as a property in kJ/mol
	Output a negative vibrational frequency as imaginaryFrequency
		 
	* src/formats/xml/cmlreactformat.cpp: Ensure OBText strings go to
	the original output stream. (Stream may change to output moleculeList
	first.)
	Add reversible attribute on reactions.

2009-01-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/format.h (OpenBabel): Fix PR#2070342. Make
	sure format modules properly inherit GetMIMEType(). Breaks library
	ABI, which is fine for v2.3.

2008-12-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/outformat.cpp: New format to read files with
	extensions .dat, .log, .out and try to guess the format based on
	contents. Currently works with many GAMESS, Gaussian, MOPAC,
	Q-Chem, Jaguar, and MPQC files.

2008-12-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/typer.cpp: Fix for PR#2017902 -- bug introduced by r2578 in
	detecting guanidinium C atoms.

 	* data/element.txt, data/atomtyp.txt: Minor changes. Allow boron
	to have 4 bonds and adjust implicit valence for several elements.

2008-12-02  Chris Morley

	* src/tokenst.cpp, include/openbabel/tokenst.h: Add function
	to ignore istream up to a specified string.
	
	* src/formats/mdlformat.cppReadMolecule): give no warning if
	there are blank lines at the end of the file.
	(SkipObjects): rewrite to prevent confusion by $ chars in
	properties. Should hve been done long ago.

	* src/mcdlutil.cpp, include/openbabel/mcdlutil.h:  more bug
	fixes from Sergey Trepalin. Performs better, but still some
	memory leaks.
	
2008-12-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/pdbformat.cpp: Add support for reading CRYST1
	records, contributed by Francois-Xavier Coudert. PR#2343128.

2008-11-24  Craig James <cjames@emolecules.com>

	* src/canon.cpp: Trivial change: updated a couple of incomplete
	comments.

	* src/formats/mdlformat.cpp: Added informative error messages for
	several errors, such as not enough atoms in atom block, not enough
	bonds in bond block, invalid bond spec, etc.  These errors were
	detected before, but failed silently.

	* src/formats/smilesformat.cpp: Added several features.  New "x"
	option causes the X/Y coordinates to be appended to a canonical
	SMILES output, in canonical order.  Added the ability to create a
	canonical SMILES of a fragment (this was in the original
	cansmilesformat.cpp, but didn't make it into smilesformat.cpp).
	Added the "h" option that prints explicit hydrogens as [H] even if
	they aren't normally part of a canonical SMILES.  Made the "i"
	option (print chirality/isotopes in canonical SMILES) work
	correctly; it was being ignored.  Took out a few obsolete
	statements here and there that were useless (computed values that
	were never used).  Fixed a bug that could cause a crash if a
	molecule consisted entirely of hydrogen atoms.

2008-11-22  Chris Morley

	* src/mcdlutil.cpp: Small bug fixes from Sergei Trepalin
	
	* windows-vc2005/babelconfig.h, windows-vc2005/OBDLL/OBDLL.vcproj,
	windows-vc2005/OBMCDL/MCDL.vcproj, 
	windows-vc2005/OBUtilFormats/OBUtilFormats.vcproj: Windows
	build updated to make groupRedraw() callable.

2008-11-22  Chris Morley

	* src/ops/loader.cpp: do not remove comments after 4th line of
	an entry in plugindefines.tx. SMARTS uses '#'!
	
	* src/ops/optransform.cpp: revamp parsing.
	
	* src/phmodel.cpp(OBChemTsfm::Init): correct bug in which some
	kinds of transform were not taken into account when checking
	whether there was anything to do.

2008-11-22  Chris Morley

	* include/openbabel/text.h: NEW boring and trivial class OBText,
	derived from OBBase. This was proposed last year for formats
	which contained mixed content, like cdx, but has other uses. 

	* src/formats/xml/textformat.cpp: NEW input format for the above
	
	* src/formats/xml/cmlreactformat.cpp: makes use of OBText class
	to insert its output into boilerplate text provided in a file.
	
	* include/openbabel/mol.h, src/mol.cpp(Has2D): add an extra
	parameter to change from "has 2D or 3D" to "has 2D". Correct bug
	which gave the wrong answer for some linear molecules.	
	
	* include/openbabel/obconversion.h, src/obconversion.cpp
	(NumInputObjects): now adjusts for values of -f and -l options

	* src/formats/xml/xml.cpp(GetDerived):correct bug which did not
	update the XMLConversion object even when the base OBConversion
	had changed (bug#2283422).	

	* src/formats/smilesformat.cpp*(SkipObjects): make work properly
	for files without a new line at the end.
	 
	* src/ops/gen2D.cpp, src/ops/gen3d.cpp: set the molecule dimension.

2008-11-21  Geoff Hutchison  <ghutchis@Iridium.chem.pitt.edu>

	* src/data.cpp (GetAtomicNum): Fix bug with patch supplied by
	Wayne Volkmuth (PR#2289021). Crashes with 3-character element.

	* include/openbabel/atom.h: Patch from Wayne Volkmuth to ensure
	atomic numbers are unsigned (i.e., values above 127 are
	OK). PR#2289628.

	* src/formats/pdbformat.cpp: Patch from Francois-Xavier Coudert to
	write CRYST1 records when unit cell data is present. PR#2023510.

	* src/generic.cpp (OBUnitCell::GetLatticeType): Fix bug reported
	(and patched) by Jonathan Coome. PR#2100535.

	* configure.in, config.* ac*.m4, Makefile.am, Makefile.in: Remove
	autotools build files. Use Cmake instead.

2008-11-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/Makefile.am, src/ops/Makefile.am: Build mcdlutil.cpp and
	gen2D.cpp plugin.

	* configure.in: Update to indicate that trunk is not 2.2.0
	build. (May go into a 2.3 or 3.0 build.)

2008-11-12  Chris Morley

	* src/mscdlutil.cpp, data/templates.sdf: revert to previous
	version	with templates internal, since external templates
	did not seem to be always applied.
	#define nRotBondsMax 20 (from 24) which should improve performance.

2008-11-05  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/pqrformat.cpp: Apply patch from Mikael Lund to read in
	partial charges and radii. The radii are added to the atoms as
	OBPairData with attribute "Radius".

2008-10-31  Chris Morley

	* src/formats/getinchi.cpp: prevent failure when input contains
	"InChI>InChI=...", which actually occurred in an SDF file.

2008-10-27  Chris Morley

	* mcdlutil.cpp: Replace all calls to fabs with abs. 
	Remove internal templates and template molecule sorting; all
	template molecules are now in templates.sdf which has to be sorted,
	largest first.
	
	* data/templates.sdf: 147 molecules, sorted
	
	* obconversion.cpp(Convert): make OutputAtEnd option work with
	multiple input files.

2008-10-23  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/chains.cpp: Remove debug output.

	* src/forcefields/forcefielduff.cpp: Check if parameters are found and
	don't try to use a NULL pointer when there isn't a parameter. (Fixes:
	#2187870)

2008-10-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefield*.h: Fix MakeNewInstance().

2008-10-20  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/CMakeLists.txt: Add gen2D.cpp and mcdlutil.cpp
	
	* src/mcdlutil.cpp: Replace all calls to abs(double) with fabs(double)

	* src/formats/MCDLformat.cpp: Replace string.npos with string::npos

2008-10-20  Chris Morley
	
	* include/openbabel/mcdlutil.h, src/mcdlutil.cpp: New files
	which use MCDL library to generate 2D coordinates
	
	* src/formats/MCDLformat.cpp: some code moved to the above files.
	
	* src/ops/gen2D.cpp: wrapper op for --gen2d 
	
	* data/templates.sdf: New file with example template
	
	* src/transform.cpp: help on --sort and --revsort

2008-10-20  Chris Morley
	 
	* include/openbabel/obmolecformat.h, src/obmolecformat.cpp:
	New functions to sort molecules, Sort(), OutputSortedMols()
	and LessThan()
	
	* include/openbabel/descriptor.h, src/descriptor.cpp: New
	virtual function LessThan() and default implementation.
	Make several error messages once only.
	
	* src/descriptors/filters.cpp: Add LessThan functions for TitleFilter
	and more complex one + GetCachedValue() + Init() for InChIFilter.
	 
	* include/openbabel/plugin.h: Add virtual funtion Init() 


	* include/openbabel/mol.h, src/mol.cpp: extra flag to indicate
	is a pattern, not a complete molecule. SetIsPatternStructure()
	Previously described, but somehow not committed.


2008-10-17  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: in OBForceField::GetGrid(), calculate grid size 
	before adding probe atom. 

2008-10-17  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/chains.h, src/chains.cpp: some changes from
	experimental branch, mainly documentation and some bug fixes.

	* src/formats/atomrecord.cpp: Interpret HG11, HE11, ... as hydrogen
	atoms at position gamma and epsilon. Previously these atom ids were
	interpreted as Hg and He atoms. (Fixes: #2002557 & #2026265)

2008-10-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.cpp: Remove _logbuf[100] (Fixes
	#2022120)

2008-10-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/builder.cpp: fix bugs with linear molecules. (Fixes #2119034 & #2013814)

2008-10-15  Chris Morley

	* src/fingerprint.cpp: correct yesterdays commit which used
	the wrong size to reserve for the fingerprint vector.	
	
2008-10-15  Chris Morley

	* include/openbabel/obconversion.h, src/obconversion.cpp:
	New function for counting the number of molecules in an input file.
	Make option to force output at end more general (for sort).
	
	* include/openbabel/fingerprint.h, src/fingerprint.cpp:
	Add extra parameter to FastSearchIndexer constructor to
	allow vectors to be pre-sized.
	
	* src/formats/fastsearchformat.cpp(ReadChemObject): change the way
	the last result molecule is flagged (for sort).
	(WriteChemObject) Make index updating work with GUI by detecting
	a ofstream object rather than cout.
	Count number of molecules in input file, report it and use it
	to pre-size the fingerprint and seekposition vectors.
	
	* src/formats/smilesformat.cpp(SkipObjects): make compatible with
	previous interpretation changes. (Lines which start with non-SMILES
	character are ignored.)


2008-10-15  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.cpp: Accept both forms for sulfon
	and nitro groups: N(=O)O, N(=O)=O, S(O)O, S(=O)(=O) are now all valid
	and typed correctly.

2008-10-11  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefielduff.cpp: Fix minor output bug reported by
	Tapani Kinnunen (Fixes: #2144142)

2008-10-11  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, src/forcefields/forcefieldmmff94.cpp: Remove
	redefinition of _logbuf[BUFF_SIZE+1] (This and Chris' previous commit 
	fixes: #2150390)

	* src/forcefield.cpp: Fix OBForceField::GetAtomTypes() and
	OBForceField::GetPartialCharges()

	* src/forcefield.cpp: Check OBForceField::_validSetup flas before
	doing anything that may cause a segfault. (Fixes: #2059299)

	* src/forcefields/forcefield*.h: Set _validSetup to false in
	constructor.

	* CMakeLists.txt, src/config.h.cmake: apply patch from Christian
	Ehrlicher to fix cmake MSVC compilation.

2008-10-10  Chris Morley

	* src/fingerprints/finger3.cpp: rearrange
	a) so that div and div-- do not appear in same statement, which
	is illegal (Andrew Dalke).
	b) replace ternary conditional, which did not compile in gcc
	It's a pity the Microsoft compiler did not warn about either of these.
	
	The preferred file format no longer needs a comment as first line.

	* src/formats/chemkinformat.cpp(ReadReactionQualifierLines):
	correct error similar to b) above flagged in bug #2150390	 

2008-10-16  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-python.i: Added casting methods for all of the
	different types of OBGenericData

2008-10-10  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-perl.i: Replaced the C++ iterators by Perl classes
	which can be used for iteration natively in Perl.

2008-10-04  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Fix OBForceField::GetAtomTypes() and
	OBForceField::GetPartialCharges()

2008-09-26  Chris Morley

	* src/formats/fastsearchformat.cpp: Improved error message when
	 target is SMARTS rather than SMILES. Bug #2129841
	 
	* src/formats/getinchi.cpp: small mod to avoid occasionally seeing
	 a "quoted" InChI when there isn't one. (There ARE none in the wild.)
	
2008-09-23  Chris Morley
	
	* src/fingerprints/finger3.cpp: enhanced PatternFP which can take
	extra parameters and file format.
	
	* data/MACCS.txt; data for new MACCS fingerprint (from RDKit)
	
	* data/plugindefines.txt; definition of MACCS fingerprint.

2008-09-20  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Check OBForceField::_validSetup flas before
	doing anything that may cause a segfault. (Fixes: #2059299)

	* src/forcefields/forcefield*.h: Set _validSetup to false in
	constructor.

2008-07-19  Michael Banck  <mbanck@gmx.net>

	* src/formats/opendxformat.cpp: Rename theGaussianCubeFormat global
	variable to theOpenDXCubeFormat.

	* src/formats/CMakeLists.txt: Added opendxformat to formats.

2008-07-11  Chris Morley

	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi
	Set Env Var BABEL_DATADIR to installation directory. Safer than 
	relying on finding the data files in the current directory.
	
	* include/openbabel/builder.h, src/builder.cpp: check whether
	fragments.txt is loaded successfully and if not return false
	from Build().

2008-07-09  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/pybel.py: Bug fix for make3D for linear molecules.
	Fixes bug 2014055. Minor doc fixes. Remember to close output files
	in Molecule.write().

2008-07-03  Noel O'Boyle  <baoilleach@gmail.com>

	* windows-vc2005/OBPythonOBF/setup.py: Update setup.py to include
	forcefield files when installing

2008-07-03  Michael Banck  <mbanck@gmx.net>

	* scripts/Makefile.am (dist-hook): Do not fail if make distclean does
	not succeed in the perl and ruby directories.
	* scripts/Makefile.in: Regenerated.

	* data/Makefile.am (table_DATA): Added plugindefines.txt.
	* data/Makefile.in: Regenerated.
	* data/CMakelists.txt: Removed space-groups.xsl from to_install.

	* test/cmlreadfile.cpp: Read files from TESTDATADIR, not relative to
	current directory.
	* test/wrapper.sh: Use ${srcdir}, not ${top_srcdir} to set
	$BABEL_DATADIR.
	* test/wrapper.sh: Run inchi tests from source directory if ${srcdir}
	is non-empty.  Set and export TESTDATADIR.

2008-07-03  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/ruby/README: Updated build instructions

2008-07-03  Michael Banck  <mbanck@gmx.net>

	* src/CMakelists.txt (LIBRARY_VERSION): New variable.
	* src/CMakelists.txt (BABEL_LIBRARY): Set VERSION property to
	${LIBRARY_VERSION}.
	
2008-07-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/Makefile.am, src/CMakeLists.txt: Update SONAME to 3 for
	version 2.2.0 release.

2008-07-03  Marcus D. Hanwell  <marcus@cryos.org>

	* CMakeLists.txt: Relaxed the CMake requirement to 2.4.7.

	* include/openbabel/griddata.h, src/griddata.cpp: Added three new
	getter functions to get the x, y and z axes.

	* src/CMakeLists.txt: Updated to use SONAME 3.

	* include/openbabel/mol.h, src/mol.cpp: Added extra arguments to
	GetMolWt, GetExactMass and GetSpacedFormula to optionally disable
	implicit hydrogens. Defaults to preserve existing behaviour.

	* src/grid.cpp: Fixed the Init function to apply padding correctly.

2008-07-02  Marcus D. Hanwell  <marcus@cryos.org>

	* include/openbabel/grid.h, src/grid.cpp: Updated the documentation
	and a few fixes to the function prototypes.

        * include/openbabel/griddata.h, src/griddata.cpp: Updates to the
	documentation, added a GetMaxVector function and made SetLimits const
	fixes for the vector3 form.

	* CMakeLists.txt, src/CMakeLists.txt, src/formats/CMakeLists.txt:
	Reduce the number of version variables floating around to only those
	that are used...

	* CMakeLists.txt, src/formats/CMakeLists.txt: Use a versioned plugin
	directory as autotools does.

2008-07-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/locale.cpp: Add string.h header, from patch by Marcus
	Hufgard. Allows compilation with GCC 4.3.1 on Linux:
	PR#2008642.

	* src/formats/gausszmatformat.cpp: Add definition of
	strcasestr if not defined. Solves compile problems on Cygwin.

	* configure.in, src/config.h.in, configure: Check for
	rpc/xdr.h needed for xtcformat.

	* src/formats/xtcformat.cpp: Use new HAVE_RPC_XDR_H #define.

	* src/formats/smilesformat.cpp: Bring back FIX format, killed
	during merger of canonical and standard smiles.

	* src/rotamer.cpp, src/locale.cpp, src/base.cpp,
	include/openbabel/atom.h, include/openbabel/locale.h,
	include/openbabel/forcefield.h,
	include/openbabel/pointgroup.h,
	include/openbabel/fingerprint.h: Doxygen updates for 2.2.0.

2008-07-02  Chris Morley

	* src/descriptor.cpp(PredictandSave): don't duplicate an existing
	OBPairData. Was crashing when adding a property that was already
	present. 
	 
	* src/formats/smilesformat.cpp(StandardLabels): A couple of vectors now
	have 2147483647 pushed when the atom is H, to match the situation with
	canonical ordering, rather than ending up with a size smaller than the
	number of atoms. I assume 2147483647 = 2^31-1 is just a big number?
	Fixes bug 1999348.

2008-07-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/kekulize.cpp (expandcycle): Add more flexible API for
	expandcycle.

	* scripts/perl/Makefile.PL: Update from Noel for PR#2007797.

	* Makefile.*, configure.*: Update for 2.2.0 release.

2008-07-01  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/atomrecord.cpp: Fix bug where arginine hydrogen atoms
	where read as dummy Xx atoms. (#2002557)

	* src/formats/pdbformat.cpp: 1) Write the chain number. 2) Don't
	rearrange atom ids when writing. (see chains item 2)

	* src/chains.cpp: 1) Serine OG is now given the correct atom id.
	2) produce correctly ordered atom ids (see pdbformat item 2)
	3) fix for cyclic peptides (have no NTer)
	4) water, ions and ligands are all placed in the ' ' chain now and get
	unique residue numbers.
	5) partially identified residues are merged with the atoms not used to
	identify them and the resids is set to UNK (hetflags is also set to
	true) (e.g. CSD in 1LWF = CYS with two O's on S )

2008-07-01  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/pybel.py: Make pybel use CloneData instead of SetData
	
2008-07-01  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-python.i: Make the BFS Iterator return two values,
	the Atom and the depth
	
2008-07-01  Chris Morley

	* data/atomtyp.txt: remove IMPVAL entry for silicon to fix
	bug #1911590. (I thought I had already done this.)
	
	* windows-vc2005/babelconfig.h: add macro which apparently
	disables native tr1 in recent VC++ 2008, so that boost version
	will be used. Step towards getting tit to compile on this
	platform but probably not there yet. Not critical for v2.2.0
	release, since Windows compilation should be done from SVN.

2008-06-30  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* Makefile.am: Move cmake to EXTRA_DIST (4 Makefiles for one
	file?)
	* Makefile.in: Regenerated.

	* include/openbabel/base.h, src/base.cpp: New CloneData()
	method to solve PR#2004495 for scripting interfaces.

	* src/Makefile.am, src/Makefile.in: Bump library version for
	2.2 release.

	* src/formats/smilesformat.cpp: Minor fix relating to
	PR#1999348.

	* src/patty.cpp, src/forcefield.cpp, src/oberror.cpp, 
	src/generic.cpp, src/canon.cpp, src/dlhandler_unix.cpp, 
	src/data.cpp, src/grid.cpp, src/mol.cpp: Minor fixes from
	static code analysis. Test for empty() instead of size().


2008-06-30  Michael Banck  <mbanck@gmx.net>
	
	* src/Makefile.am (EXTRA_DIST): Added config.h.cmake.
	* src/Makefile.in: Regenerated.

	* Makefile.am (SUBDIRS): Added cmake.
	* Makefile.in: Regenerated.
	* cmake/Makefile.am: New file.
	* cmake/Makefile.in: New file.
	* cmake/modules/Makefile.am: Likewise.	
	* cmake/modules/Makefile.in: Likewise.	
	* configure.in (AC_OUTPUT): Added cmake/Makefile and
	cmake/modules/Makefile.
	* configure: Regenerated.
	* acinclude (AM_PATH_XML2): New macro, copied from aclocal.m4.

2008-06-29  Marcus D. Hanwell  <marcus@cryos.org>

	* include/openbabel/math/vector3.h,
	include/openbabel/math/matrix3x3.h: Made the destructors non-virtual,
	fixes Avogadro bug 2005984.

2008-06-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/obiter.h, src/obiter.cpp: Fix
	PR#1901348. Add support for BFS iteration from arbitrary
	atoms.

	* include/openbabel/math/*.h, src/math/*.cpp: Updates to fix
	some GCC warnings.

	* include/openbabel/bond.h, src/bond.cpp: Patch from Steven
	Constable, PR#2004391. Adds SetLength() to move both atoms.

	* include/openbabel/mol.h: Fix for ReserveAtoms() suggested by
	Andrew Dalke.

	* src/formats/mdlformat.cpp: Fix for SKP records, suggested by
	Andrew.

	* src/formats/pdbformat.cpp: Fix for CONECT records for atoms
	with > 4 records (PR#1711154).

2008-06-26  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/parsmart.cpp: Add support for Isotopes in SMARTS. Fixes
	PR#1987729.

	* test/files/nci.smi: Add tests for matching isotopic
	SMILES/SMARTS.

2008-06-23  Chris Morley

	* test/inchiwrite.cpp: add -xn option so that the tests are done without
	the 'recommended' InChI options. wInChI.exe is not yet available
	for InChI 1.02. Needs revisting when it is.

	* src/fingerprint.cpp(FastSearchIndexer): ensure fpid is terminated
	when copied to guard against theoretical problem pointed out
	by Andrew Dalke.

2008-06-21  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/chains.cpp: Assign HOH and ligands to separate residues.
	(#1774776)

2008-06-21  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/atomrecord.cpp: Keep original chain ID (#1760959).

2008-06-21  Carsten Niehaus  <cniehaus@kde.org>

	* src/obutil.cpp: Typo fixes.

	* src/forcefields/[forcefielduff.cpp,forcefieldmmff94.cpp]: Typo fixes

	* src/formats/[mpdformat.cpp,xtcformat.cpp]: Typo fixes
	
	* src/forcefields/*.h: Make ctor explicit.
	
2008-06-20  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/obutil.cpp (CartesianToInternal): Fix PR#1923896 for
	Fenske-Hall z-matrix format. When looking for non-linear
	atoms, don't pick non-bonded >10.0 Angstroms, which cause
	problems with FH (and other) fixed format z-matrices.

	* src/mol.cpp (ConnectTheDots): Fix for PR#1813502 for
	existing bonds getting deleted by ConnectTheDots. Make sure to
	preserve all original connections from PDB.

	* src/formats/pdbformat.cpp (ReadMolecule): Fix for PR#1985681
	with virtual bonds still built into a PDB file.

2008-06-20  Chris Morley

	* include/openbabel/locale.h, src/locale.cpp: extra #includes
	
	* windows-vc2005/babelconfig.h: define strdup. Version to 2.2.0
	
	* include/openbabel/obiter.h: trivial change to avoid compiler warning
	
	* src/fingerprints/finger3.cpp: do singel SMARTS match, as suggested by
	Ernst-Georg Schmid

	* windows-vc2005/OBError/OBError.vcproj: add locale.cpp

2008-06-20  Noel O'Boyle  <baoilleach@gmail.com>

	* Revert of r2347: I had set eol:native instead of eol-style native.

2008-06-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/fingerprint.cpp: Contribution from Andrew Dalke for
	improved speed using GCC.

2008-06-18  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/locale.h, src/locale.cpp: New OBLocale class
	to centralize calls to setlocale/uselocale. Should solve strange
	segfault on Linux with freelocale.

	* include/openbabel/obiter.h, src/obiter.cpp: Add depth tracking
	for DFS and BFS iterators. Addresses PR#1901348.

2008-06-18  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/*.cpp: Checked all files for their use of tokenize().
	All added lines are like:
	
	if (vs.size() < 1) return false; // timvdm 18/06/2008 

	* include/openbabel/obiter.h, src/obiter.cpp: Reimplement
	FOR_PAIRS_OF_MOL. Do not build a list of all pairs in the constructor,
	but find the pairs while iterating. This is faster and requires less
	memory.

	* include/openbabel/forcefield.cpp: Add SetParameterFile().

	* src/forcefields/forcefieldmmff94.*: Use the new SetParameterFile().
	Add a global definition for MMFF94s.

	* data/*: Add MMFF94s parameters.

	MMFF94s: Same functional form, only torsion and oop parameters are
	different. To see the difference, you can try to minimize alanine with
	both force fields, MMFF94s will give a planar nitrogen while MMFF94
	will not.

2008-06-17  Noel O'Boyle  <baoilleach@gmail.com>

	* Reverted r2535 except for changes to scripts/perl/Makefile.PL
	* scripts/openbabel-python.i: Updated SWIG interface file to ignore 21
	methods of each std::vector created. This should substantially reduce
	the size of the wrapper code.

2008-06-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/xtcformat.cpp: make confs a std::vector too. Was double
	*confs = new double[natoms * 3].

2008-06-16  Chris Morley

	* include/openbabel/oberror.h, src/oberror.cpp:
	add a parameter to ThrowError to allow error messages to be 
	output only once (although they are all logged.). The default
	behaviour is as at present.
	
	* src/formats/inchiformat.cpp: default output uses the "recommended"
	set of InChi options. -xn option uses no options as at present.
	
	Add -xl option to output the InChI log - only once for multiple
	molecules.
	
	* include/openbabel/fingerprint.h, src/formats/fingerprintformat.cpp:
	Make DescribeBits error message appear only once.
	
	* src/mol.cpp(GetTitle): make variable title static to avoid returning
	a pointer to a temporary variable. But this might cause problems with
	multiple molecules unless the title is captured in the calling code 
	before getting the next. Until this is done properly, add a
	test so that the problem can only occur with multi-line titles.

	* src/formats/smilesformat.cpp: add option to output explicit hydrogen
	form like [CH3][CH3].
	**** The SMILES output currently crashes with  Nc1nc(O)c2nc[nH]c2n1
	but I haven't tracked this down.****
	
	* src/ops/addpolarh.cpp: add simple op for Feature Request #1995162 
	
	* windows-vc2005/gen3D/gen3D.vcproj,
	windows-vc2005/OBMoreFormats/OBMoreFormats.vcproj: update

2008-06-15  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/cssrformat.cpp, src/formats/MCDLformat.cpp,
	src/formats/mmcifformat.cpp, src/formats/balstformat.cpp,
	src/formats/chemdrawcdx.cpp, src/formats/boxformat.cpp,
	src/formats/unichemformat.cpp, src/formats/yasaraformat.cpp,
	src/formats/zindoformat.cpp, src/formats/gromos96format.cpp,
	src/formats/xedformat.cpp: sprintf --> snprintf

	* src/chains.cpp, src/pointgroup.cpp, src/rotor.cpp: Some more sprintf
	-> snprintf (I don't expect any problems here, but just in case...)

	* include/openbabel/forcefield.cpp, src/forcefield.cpp,
	src/forcefields/*: Replace sprintf(_logbuf, ...) with
	snprintf(_logbuf, BUFF_SIZE). 

2008-06-14  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/chain.h, src/chain.cpp: Replace:
	1) malloc/free with new/delete
	2) new T[n] with std::vector (where possible)
	Original code still there as comments, can be removed once reviewed.

	* src/parsmarts.cpp: Replace malloc/free with new/delete.
	Replace realloc(array, size) with:
	  T *tmp = new T[size];
	  copy(array, array + old_size, tmp);
	  delete [] array;
	  array = tmp;


2005-06-14  Marcus D. Hanwell  <marcus@cryos.org>

	* src/formats/xtcformat.cpp: Some modifications to the xtc format to
	use C++ structures.

	* CMakeLists.txt, src/formats/CMakeLists.txt: Some build system
	updates to build format plugins as modules.

	* src/ops/loader.cpp: GCC 4.3 fix - cstdlib needed for free calls.

2008-06-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/atom.h, src/atom.cpp: Add OBAtom::Duplcate()
	which will copy everything except the internal index.

	* include/openbabel/generic.h, src/generic.cpp: Add
	OBUnitCell::FillUnitCell() method to create space-group-defined
	atoms. Uses OBAtom::Duplicate.

2008-06-13  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.cpp: Change GetGradient(..., int terms
	= ...) to GetGradient(..., int /*terms*/ = ...). (comiler warning:
	unused parameter).

	* src/forcefields/*.cpp: Change i->Compute<gradients>() to i->template
	Compute<gradients>().

	* include/openbabel/builder.h, src/builder.cpp: Make most functions 
	static.

	* src/mol.cpp: Use OBBuilder::GetNewBondVector() in AddHydrogens(). 

2005-06-13  Marcus D. Hanwell  <marcus@cryos.org>

	* src/formats/mdlformat.cpp: Use static_cast in the min function.

2008-06-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/typer.cpp: Add a special case for guanidinium carbon
	atoms. (We may need additional special cases.)

	* data/atomtyp.txt, data/atomtyp.h: Change pattern for N3+ to
	match any 4-valent N, regardless of whether the formal charge has
	been set.
	
	* src/kekulize.cpp (NewPerceiveKekulizeBonds): Give up on
	kekulization when we find "cycles" with < 3 atoms. Sybyl mol2
	labels some atoms as aromatic that aren't in rings. Fixes
	PR#1965566 and PR#1784204.

	* include/openbabel/mol.h, src/mol.cpp (GetTitle): Add a parameter
	to replace newlines with spaces. Fixes PR#1984742.

	* configure.in: Check for xlocale.h, locale.h, and uselocale functions.

	* src/data.cpp, src/ops/loader.cpp, src/ops/optransform.cpp,
	src/descriptors/groupcontrib.cpp, src/builder.cpp,
	src/forcefields/forcefieldmm2.cpp,
	src/forcefields/forcefielduff.cpp,
	src/forcefields/forcefieldmmff94.cpp,
	src/forcefields/forcefieldghemical.cpp, src/obconversion.cpp:
	Change locale using uselocale if available and reset it to the
	afterwards. Update of previous change, suggested by Benoit.

	* include/openbabel/bond.h, include/openbabel/atom.h,
	src/bond.cpp: Fixes for "const" correctness. It's now possible to
	get the bond length of a const OBBond.
	
2008-06-10  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/data.cpp, src/ops/loader.cpp, src/ops/optransform.cpp,
	src/descriptors/groupcontrib.cpp, src/builder.cpp,
	src/forcefields/forcefieldmm2.cpp,
	src/forcefields/forcefielduff.cpp,
	src/forcefields/forcefieldmmff94.cpp,
	src/forcefields/forcefieldghemical.cpp, src/obconversion.cpp:
	Change locale before parsing files to use "C" numeric locale and
	reset it to the original state afterwards. Should solve PR#1785463.

	* src/obiter.cpp: Fixes from Izhar for DFS and BFS iterators.

	* src/mol.cpp, include/openbabel/mol.h: Added iterative
	GetFragment method to augment Separate(), contributed by Izhar.

2008-06-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/phmodel.cpp (OBPhModel::CorrectForPH): Fix PR#1835204. Allow
	SMILES to have pH-correction. (i.e., only check for automatic
	formal charges for molecules with dimension > 0).

	* src/formats/mdlformat.cpp: Add a check for EOF before reading,
	as suggested by Izhar.

	* src/formats/smilesformat.cpp: Add initial pass at "standard"
	SMILES labels.

	* Doxygen, include/*.h, src/*.cpp: Update doxygen documentation.

2008-06-07  Chris Morley

	* src/formats/fingerprintformat.cpp: correct folding error message
	and prevent description of bits when fingerprint is folded.
	
	* src/formats/smilesformat.cpp: change -xc to -xa (for atomclass)
	
	* windows-vc2005/OBFS/OBFS.vcproj,windows-vc2005/OpenBabelOBF.sln
	add dependency of OBCommon to Fastsearch project

2008-06-06  Chris Morley

	* src/formats/smilesformat.cpp: SMIFormat was being hidden because
	its constructor was being called again when its derived class
	CANSMIFormat was made. Now both derived from a base class with most
	of the functionality. 
	Modified Description() and made same for both.
	Removed DEFAULTFORMAT flag (MolFormat already is).
	
	* include/openbabel/mol.h: add back #include <float.h> which was
	somehow removed in the last commit and is need for Windows build.
	
	* windows-vc2005/OBCommonFormats/OBCommonFormats.vcproj: remove
	cansmilesformat.cpp
	
2008-06-06  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/phmodel.h, src/phmodel.cpp: Changes to OBPhModel, 
	use the	Henderson-Hasselbalch formula to determine protonation states.
	Updated doxygen documentation to give some info about the method.

	* include/openbabel/mol.h, src/mol.cpp: Use it.
	OBMol::AddHydrogens(bool polar=false, bool correctForPH=true, double
	pH=7.4)

	* data/phmodel.txt: Add extra column with pKa values.

	* test/phmodel.cpp: Unit test for the new phmodel. The two errors are
	Glutamate (4.0 used, should be 4.3) and Lysine (10.0 used, should be
	10.1). I'll probably have to add a visited list so we can only
	transform an atom once, transformations would then have to be ordered
	by decreasing complexity. But the errors are very small and this is a
	major improvement compared to what we had.

2008-06-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/openbabel-python*, scripts/python/*: Split the python
	bindings into three pieces for improved compilation. Should solve
	PR#1905826.

	* src/obconversion.cpp: Add stdlib.h to hopefully solve
	PR#1985717.

	* configure.in, configure: Update to build libinchi by default.

	* src/formats/smilesformat.cpp: Incorporate cansmilesformat
	code. Now all SMILES export goes through Craig's cleaner,
	less-buggy code. Currently all SMILES are canonically
	ordered. Need to add code to provide non-canonical ordering for "regular."
	
	* src/formats/Makefile.* src/formats/CMakeLists.txt: Update for above.

2008-06-05 Chris Morley

	* src/obconversion.cpp(Convert): test for Cntl Z to terminate
	commandline input rather than \n (a blank line).
	Fixes bug 1984660: piping with titleless mol files.
	Commandline data input always was clunky and is even clunkier now.
	Being able to pipe is more important. 
	
	* src/forcefield.cpp:In line 2535 replace 'dafault:' by 'default:' 
	This may have a real effect and needs to be checked.
	
	* include/openbabel/bitvec.h, src/canon.cpp,src/dlhandler_win32.cpp,
	src/forcefield.cpp, src/formats/cansmilesformat.cpp,
	src/formats/gamessformat.cpp, src/formats/gaussformat.cpp,
	src/formats/KFReader.c,src/formats/mol2format.cpp,
	src/formats/msmsformat.cpp, src/pointgroup.cpp,
	src/tokenst.cpp:
	Tidy to reduce compiler warnings: remove or comment out unreferenced
	variables; size_t decalation replaces some int or unsigned;
	!=NULL added to avoid implict const char* to bool conversion 
	
	* windows-vc2005/OBMoreFormats/OBMoreFormats.vcproj: change to
	project build order as pointed out by peterennis bug #1985163


2008-06-04  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mopacformat.cpp: Fix for PR#1978982 with reading
	Mopac 2007 force calculations.

	* src/formats/atomrecord.cpp: Fix SetAtomID as reported in
	PR#1838095. Thanks to Marc Lasson for bug report and fix.

	* src/formats/adfformat.cpp, src/formats/Makefile.am: Add KFReader
	and ArrayList code contributed under LGPL by SCM, Inc. for
	improved ADF binary support.

2008-06-04 Chris Morley

	* include/openbabel/mol.h: include float.h so that isinfinite
	is handled properly in Windows
	
	Deficiencies raised by Andrew Dalke
	
	* src/fingerprint.cpp: Error message if attempting to fold to 
	less than size of unsigned int.
	
	* src/formats/fingerprintformat.cpp(WriteMolecule) Error message 
	when parameter of -xN option (fold) is negative.
	
	* src/formats/fastsearchformat.cpp(WriteChem Object):
	Error message if more than one input file.
	
	Delete the outputstream after deleting the index, which is when
	it is written. Sometimes a fs file made without a specified name 
	was empty.
	
	* tools/babel.cpp: change indentation on help text
	
	* windows-vc2005/OpenBabelOBF.sln: another go at getting debug and
	release configurations right. The scripting interfaces need to be
	explicitly enabled before building if they are required. (I get
	tired of waiting for them.)

2008-06-04  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/residue.cpp (GetResidueNumber): Fix bug reported by Izhar
	Wallach.

	* src/forcefields/forcefielduff.cpp: Fix error reported by Chris
	Morley with Microsoft compiler -- don't duplicate loop variable names.

2008-06-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/atomtyp.txt, data/atomtyp.h: Add hybridization rules for
	Si, Al, Ge, As, Se, and Te. (Atom typing and valence rules need to
	be generalized.) Fixes problems with adding hydrogens to Si
	uncovered in Avogadro.

2005-06-02  Marcus D. Hanwell  <marcus@cryos.org>

	* src/atom.cpp, src/mol.cpp: Added extra checks in AddHydrogens for
	finite hydrogen coordinates. Also added some extra checks in the
	GetNewBondVector function to check for sane numbers.

2008-06-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* Makefile.am, Makefile.in: Correct small automake typo with
	"autoconf" libtool macro directory.

	* configure: Regenerated using autogen.sh.

	* include/openbabel/grid.h: Fix compiler warning -- make sure to
	return values in all methods.

	* src/forcefield.cpp: Fix compiler warning "default" not "dafault"
	in switch statements.

	* src/formats/qchemformat.cpp, src/formats/gamessformat.cpp,
	src/formats/gaussformat.cpp, src/formats/fchkformat.cpp: Add
	support for reading dipole moments using OBVectorData.

2008-06-01  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/atomrecord.cpp: Call OBAtom::ForceImplH() for all atoms.
	Loading a pdb file and calling OBMol::AddHydrogens() added only on
	hydrogen.

2005-05-31  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-csharp.i: Fixed two of the three remaining
	std::vectors based on examples found in Krugle code search

2005-05-30  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-csharp.i: Fixed most of the std::vectors by using
	weird macro described in std_vector.i in the SWIG distribution

2005-05-30  Marcus D. Hanwell  <marcus@cryos.org>

	* configure, configure.in: Stop the wx-config test being called when
	the wx-gui is not enabled - bug 1979603.

2005-05-30  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-csharp.i: Added header file to SWIG wrapper. Also
	removed several of the vector templates. These don't seem to be
	handled correctly by SWIG (should report bug to them).

2008-05-30  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: OBFFConstraints::Clear(), clear all the bitvecs.
	ConjugateGradientsTakeNSteps(), set _grad1[] to (0,0,0) when atom is
	fixed and not _gradientPtr (_grad1 is used for linesearch).
	Setup() & SetConstraints, check if SetupCalculations needs to be
	called. This is the case when the ignored bitvecs of both
	OBFFConstraints are different.

	* include/openbabel/forcefield.h: OBFFConstraints::GetIgnoredBitVec().
	Used in Setup() & SetConstraints().

2008-05-28 Chris Morley

	* windows-vc2005/OBCSharp/OBCSharp.vcproj,
	* windows-vc2005/OBJava/OBJava.vcproj,
	* windows-vc2005/OpenBabelOBF.sln
	Build release versions even in Debug mode.
	Use env var JAVABASE, e.g."C:\Program Files\Java\jdk1.6.0_03"
	so that there is no dependence in the code on the installed
	Java version. (Is there a standard variable for this?)
	
	* windows-vc2005/OBMoreFormats/OBMoreFormats.vcproj:add adfformat

2008-05-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/openbabel-perl.i, scripts/perl/Makefile.PL: 
	Fix up Perl scripting. Now works on Mac OS X and appears to have
	clean converisons via "make test." Fixes PR#1795155 and 1881688.

	* src/formats/adfformat.cpp (OBT41Format::ReadMolecule): Convert
	from zyx format in ADF files to xyz in Open Babel for cubes. Only
	keep cubes which have actual data.

2005-05-28  Marcus D. Hanwell  <marcus@cryos.org>

	* src/formats/xml/cmlformat.cpp: Fixed PR 1975137 - atoi, strtol
	require null terminated strings.

2008-05-27  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/obiter.cpp: (same as Chris' commit, but let's do the same for angles)
	Make sure to always set _i, even when _vtorsion is empty.
	Otherwise OBMolTorsionIter::bool() will compare _i to _vtorsion.end() which
	caused a segfault on windows. Fixes Avogadro windows bug #1972244.

2008-05-27 Chris Morley

	* src/obiter.cpp(OBMolTorsionIter::OBMolTorsionIter):
	prevent crash when _vtorsion is empty. Was affecting builder
	with small molecules.

2008-05-26  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/Makefile.* src/formats/Makefile.*: Add versioned install
	directories for formats. Fixes PR#1905093.

	* src/formats/hinformat.cpp: Fix PR#1947913 with hang during HIN
	reading.

2005-05-26  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-csharp.i: Creating SWIG wrapper for C#
	* windows-vc2005/OpenBabelOBF.sln, OBJava, OBCSharp: Creating projects
	for OBJava and OBCSharp

2008-05-24  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/builder.cpp: Fix bug. CorrectStereoAtoms was not checking the 
	size of refs, before doing refs[0]...refs[3] (thanks Noel)

2008-05-25 Chris Morley
	
	windows-vc2005/examples: new folder with an example project
	for OBF build. Will replace /template.

2008-05-24  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Setup(), delete TorsionData before using 
	FOR_TORSION_OF_MOL. (fixed #1954233)

	* windows-vc2005/OBCommonFormats/OBCommonFormats.vcproj: Correct
	location for obmolecformat.cpp

2005-05-24  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/java/README: Updated instructions for using Java bindings on
	Linux

2008-05-23  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* windows-vc2005/openbabel.sln: remove non-existing OBPython and test, 
	add template.

	* windows-vc2005/OpenBabelDLL/OpenBabelDLL.vcproj: move obmolecformats 
	from formats to sources.

	* windows-vc2005/template/*.*: Example of a C++ program using openbabel.

2005-05-23  Marcus D. Hanwell  <marcus@cryos.org>

	* include/openbabel/obconversion.h: Removed extra qualification on
	OpenInAndOutFiles which broke compilation here.

2008-05-23 Chris Morley

	* include/openbabel/obconversion.h, src/obconversion.cpp:
	Add OBConversion::OpenInAndOutFiles to aid scripting

2008-05-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp: SetTorsion(), move j=*i out of this for loop:
	for (i = atom.begin(), j = *i; ... ; i++, j = *i)
	This was causing weird results in windows (MSVC2005). Thanks 
	to Noel for reporting the bug, this also fixes #1954233 I believe.

2008-05-23 Chris Morley

	* src/formats/xml/cmlformat.cpp: Applied Jean Brefort's patch to fix
	leading spaces on atom refs bug #1965086
	

2005-05-23  Noel O'Boyle  <baoilleach@gmail.com>

	* Pybel: minor fix to test suite for running outside cinfony

2005-05-23  Noel O'Boyle  <baoilleach@gmail.com>

	* Pybel: Synching with cinfony, and getting ready for release as 1.3

2008-05-22 Chris Morley

	* data/atomtyp.txt: remove
	  IMPVAL  [N^2-,N^3-]		2
	and add
	  IMPVAL	[N-]			2
	so that O1S(=O)(=O)[N-]C(=O)C=C1C.[K+] is interpreted correctly.
 
	* src/formats/pngformat.cpp: minor documentation change

2005-05-22  Marcus D. Hanwell  <marcus@cryos.org>

	* CMakeLists.txt: Fixed version string in CMake. Also added policy
	stuff for CMake 2.6 and the option to set the library directory.

2008-05-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp: copy OBChiralData for all atoms in operator=.

	* include/openbabel/builder.h, src/builder.cpp: Added
	Swap(...) : swap the position of two substituents (can be used to
	invert chiral centers)
	CorrectAtomChirality(...) : use the (atomreftype) input references to
	make sure the molecule has the right chirality as specified by
	IsClockwise() / IsAntiClockwise().
	CorrectBondChirality(...) : use the IsUp() / IsDown() values to rotate
	the bonds if needed.

2008-05-20  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	Changes from avogadro win32 build:

	* include/openbabel/obutil.h: Change std::min(a,b) into std::min<const
	double>(a,b).

	* src/mol.cpp: OBMol::FindChildren was iterating over an atom's bonds
	in a wrong way.

2008-05-19  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: rename _T to
	_temp. (_T is more likely to be defined elsewhere compared to _temp).

2008-05-17  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/grid.h, src/grid.cpp,
	include/openbabel/griddata.h, src/griddata.cpp: Some 'const'
	updates.

	* src/formats/adfformat.cpp: Update to use OBGridData rather than
	custom T41Data class.

2008-05-16  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/java/OBTest.java: Bring back test program.

	* scripts/openbabel-java.i, scripts/openbabel-perl.i,
	scripts/openbabel-ruby.i: Fix script bindings. Now compile
	cleanly. Perl still needs work to pass tests.

	* include/openbabel/math/spacegroup.h, include/openbabel/plugin.h:
	Minor updates for SWIG compatibility.

	* src/formats/Makefile.*: Add xtcformat.cpp.

	* src/formats/xtcformat.cpp: Add rpc/types.h for Mac
	compatibility.

2008-05-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Added functions
	to temporarily ignore or fix an atom. This allows interactive programs
	to use this while drawing (no repulsion between your new atom and the
	fragment you want to connect to. 

	* src/forcefields/forcefield*.cpp: Same

2008-05-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/CMakeList.txt: Add xtc format for non-WIN32 platforms.

2008-05-13  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/obconversion.cpp: save the filename in ReadFile (needed for xtc
	format).

2008-05-13  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/xtcformat.cpp: Portable compressed trajectory file
	format. Used by gromacs. Since there is no real API to handle
	trajectories at the moment, ReadMolecule is used. Instead of
	CastAndClear, the OBBase object is only cast to an OBMol object to
	which conformers are added for each frame. Box, step and time are
	currently ignored. Currently read only. (Avogadro implementation)

	* Makefiles: NOT updated yet, from looking at the gromacs source, it
	seems that the XDR stuff needs special handling on windows and I don't
	want to break OB now.

2008-05-13  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/atom.cpp: Replace implementation for 
	bool IsHbondDonor() { return MatchesSMARTS("[$([#8,#7H,#9;!H0])]"); }
	with C++ code for better performance.

2008-05-10  Noel O'Boyle <baoilleach@gmail.com>

	* windows-vc2005/OBPythonOBF/setup.py: Adding missing oberror.dll.

2008-05-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/opendxformat.cpp: Bug fixing. Now roundtrips OpenDX
	data from APBS. The format will create an empty OBMol with
	attached OBGridData.

2008-05-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* Regenerate autotools build system based on Daniel's updated autogen.

	* include/openbabel/mol.h, src/mol.cpp (DeleteAtom, DeleteBond,
	DeleteResidue): Update to allow the user to free an atom, bond or
	residue (i.e., just remove the atom or bond or residue from the molecule).

2008-05-07  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/python/pybel.py: Synch with cinfony.

2008-05-06  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: initialize static _constraints to a
	OBFFConstraints object.

2008-05-06  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/parsmarts.cpp: Add if(_pat) before _pat->...(). This was causing
	Avogadro to crash here sometimes.

2008-05-05  Daniel Leidert <daniel.leidert@wgdd.de>

	* autogen.sh: Force aclocal and autoheader to regenerate files to
	avoid timestamp issues (probably not necessary for automake and
	autoconf).

	* include/openbabel/Makefile.am: babelconfig.h is not removed
	automatically. Added it to DISTCLEANFILES.

2008-05-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp: Ensure energy is always 0.0.

	* src/formats/gaussformat.cpp: Prevent crash with incorrect partial charges.

	* include/openbabel/base.h, include/openbabel/generic.h: New class
	for 3x3 matrix data (e.g., quadrupole moments).

	* src/formats/adfformat.cpp, src/formats/t41data.h: Initial import
	of Molekel Tape41 support for ADF.

2005-05-04  Marcus D. Hanwell  <marcus@cryos.org>

	* configure.in, src/config.h.in, include/openbabel/forcefield.h: Fixed
	the babelconfig.h file - typo spotted...

2008-05-04  Noel O'Boyle <baoilleach@gmail.com>

	* windows-vc2005/OBPythonOBF/setup.py: Minor changes to install the
	correct OBFs in the Python Windows install.

2008-05-04  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Make
	OBForceField::_constraints static.

	* include/openbabel/forcefield.h: Add virtual destructors to
	OBFFCalculation2-4.

2005-05-03  Marcus D. Hanwell  <marcus@cryos.org>

	* src/config.h.cmake: Fixed so that TIME_WITH_SYS_TIME is defined.

2008-05-03  Tim Vandermeersch <tim.vandermeersch@gmail.com>
	
	* src/forcefields/forcefieldmmff94.*: Do the same for logging.

	* include/openbabel/forcefield.h, src/forcefields/forcefieldghemical.*,
	src/forcefields/forcefielduff.*,src/forcefields/forcefieldmmff94.*:
	OBFFCalculation has been replaced by OBFFCalculation2,
	OBFFCalculation3 and OBFFCalculation4. This makes the sizeof() smaller
	and improves performance.
	The OBFFCalculation::Compute(bool gradients) is now a template <bool
	gradients> Compute() function. The compiler will generate a Compute
	function with gradients and one without gradients. The E_Bond, ...
	functions are also template functions now. The old functions are still
	available as a wrapper for backwards compatibility. The template
	function is initialized in OBForceField::Energy(bool gradients) by
	calling E_Bond<true>() or E_Bond<false>().

2008-05-01  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* scripts/openbabel-python.i: Add OBBitVec.

2008-05-02  Marcus D. Hanwell  <marcus@cryos.org>

	* CMakeLists.txt: Fixed include directory order.

2008-05-01  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* data/atomtyp.*: Added amidine/guanidine IMPVAL rule (thanks to Steve
	Constable for reporting & fixing the bug).

2008-04-29  Marcus D. Hanwell  <marcus@cryos.org>

	* src/CMakeLists.txt, src/formats/CMakeLists.txt: Updates in order to
	build after obmolecformat.cpp was moved.

2008-04-30  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* autogen.sh, autoconf/: Add macros to work with new libtool 2.2.2.

	* configure.in, configure, aclocal.m4:  */Makefile.in: Use above.

	* src/obmolecformat.cpp: Move from src/formats to facilitate
	external programs creating OBMolecFormat subclasses.

	* src/formats/opendxformat.cpp: New format for OpenDX grids from
	APBS.

2008-04-30  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/mol.h: Add units to documentation for
	GetTorsion/SetTorsion.

	* tools/obrotate.cpp: Total review of the code. Thanks to Josep Maria
	and Noel for pointing out the problems.

	* src/mol.cpp: Added UnsetSSSRPerceived to all OBMol::Delete*()
	functions. (not DeleteConformer(int i), doesn't change rings... )

	* scripts/python/examples/*.py: Added some force field examples. More
	will follow.

	* include/openbabel/bond.h: Add some defensive checks to
	OBBond::GetBeginAtomIdx, OBBond::GetEndAtomIdx and
	OBBond::GetNbrAtomIdx. (closes #1953657)

	* scripts/openbabel-python.i: Added OBForceField::SetLogToStdOut() and
	OBForceField::SetLogToStdErr() to replace SetLogFile(std::ostream
	*pos) in python.

2008-04-29  Marcus D. Hanwell  <marcus@cryos.org>

	* src/CMakeLists.txt, src/formats/CMakeLists.txt: Moved the
	obmolecformat.cpp linkage back to where it was - this works on both
	Windows and Linux and so seems the better solution.

2008-04-29  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Torsion constraints are working now.

2008-04-28  Marcus D. Hanwell  <marcus@cryos.org>

	* libavogadro/src/extensions/gaussianinputdialog.cpp: Removed trailing
	white space.

2008-04-28  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefielduff.cpp: Added groups and Ignore.

	* src/forcefields/forcefieldghemical.cpp: Added groups and Ignore.

	* src/forcefields/forcefieldmmff94.cpp: OpenMP version of MMFF94. Does
	not affect normal compilation. Only used with GCC options "-lgomp
	-fopenmp".

	* include/openbabel/forcefield.h: Changed _ncoords from int to
	unsigned int. (Fixes some compiler warnings)

2008-04-27 Chris Morley

	* include/openbabel/mol.h, src/mol.cpp(AssignSpinMultiplicity):
	added a parameter which forces no implicit hydrogen. The default
	is false and backward compatible.
	
	* src/mol.cpp(PerceiveBondOrders): added a call to
	AssignSpinMultiplicity which should prevent molecules from
	computational chemistry formats being given implicit hydrogen.

2008-04-25  Noel O'Boyle <baoilleach@gmail.com>

	* data/mr.txt: Based on a comparison with RDKit's Crippen parameter
	text file, identified a single error in the MR value for Me1 (see
	JCICS, 1999, 39, 868) 

2008-04-21 Chris Morley

	* src/descriptors/groupcontrib.cpp(Predict): Make a copy of
	the molecule and add hydrogens before calculating property.
	As recommended by Noel in his blog.

2008-04-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/xml/cmlformat.cpp: change line 1810 from 
	s = pUnitCell.GetSpaceGroupName();    to
	s = pUnitCell->GetSpaceGroupName(); 

2008-04-22  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/xml/cmlformat.cpp: import/export crystal symmetry.
	* src/math/spacegroup.cpp: fixes a bug related to transform creation.

2008-04-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h: Documentation update.
	
	* src/forcefield.cpp: Fixed (X, Y, Z, XYZ) atoms are now checked in
	SteepestDescent and ConjugateGradients and works.
	Enable constraints again. Distance and angles work, torsion still
	needs some attention.

2008-04-21  Marcus D. Hanwell  <marcus@cryos.org>

	* include/openbabel/obconversion.h: Moved the Formatpos typedef
	outside of the class in order to preserve old API call.

2008-04-21 Chris Morley

	* include/openbabel/obconversion.h, src/obconversion.cpp:
	Reinstate a version of OBConversion::GetNextFormat() to prevent
	breaking xchemdraw. Formatpos is defined differently but would
	not be accessed in an application program.

	NEWS, windows-vc2005/OBPythonOBF/Readme.txt:
	Minor documentation changes

2008-04-19  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Added
	SetupPointer. Added Framework for specifying groups using OBBitVec for
	now until we have OBGroup/OBFragment. Documentation example using
	groups. 
	The *RotorSearch functions should call SetupPointers when they change
	conformer. This will update the pointers to the atom positions in the
	OBFFCalculation(s). This solves some weird results when the rotor
	search functions were used with MMFF94 or ghemical. UFF doesn't have
	this problem because it still uses the vector3 class.

	* src/forcefields/forcefieldmmff94.*: Added SetupPointer.
	SetupCalculations() now checks the intra and inter groups.

	* src/forcefields/forcefieldghemical.*: Added SetupPointer.

2008-04-19  Marcus D. Hanwell  <marcus@cryos.org>

	* include/openbabel/grid.h, src/grid.cpp,
	include/openbabel/griddata.h, src/griddata.cpp: Now using std::vector
	to store data internally. Made safer where possible.

	* src/formats/gausscubeformat.cpp: Cleaned up support for reading in
	multiple cubes - large cube files can now be read in.

	* src/formats/gausscubeformat.cpp: Worked on improvements to the cube
	writing function. It now staggers cubes in the z correctly and I think
	I got the rest of it lining up correctly now. Enabled.

	* configure.in, src/config.h.in: Updates to the auto* build tools,
	added HAVE_GCC_VISIBILITY logic and the defines to use it.

2008-04-15  Noel O'Boyle <baoilleach@gmail.com>

	* windows-vc2005/OBPython: removed
	* windows-vc2005/OBPythonOBF: added setup.py,
	openbabel_postinstall.py, Readme.txt and logo.bmp

2008-04-15 Chris Morley

	* tools/obchiral.cpp, tools/obenergy.cpp, tools/obfit.cpp,
	tools/obminimize.cpp, tools/obmm.cpp, tools/obprobe.cpp,
	tools/obprop.cpp, tools/obsym.cpp:
	don't #include <#include <unistd.h> in Windows build
	
	* windows-vc2005/OBTools.sln, windows-vc2005/OBTools,
	windows-vc2005/OBTools/*.proj: New build files for tools exes

	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi
	Add tools exe files to installer

2008-04-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/atomrecord.cpp: Fix from Louis Ricard to handle PDB
	files from platon. An example has been added to the test
	repository.

	* src/formats/gamessukformat.cpp: New format contributed by Jens
	Thomas to support the GAMESS-UK variant.

	* src/formats/moldenformat.cpp, src/formats/msmsformat.cpp: Ensure
	namespace is properly included.

	* tools/babel.cpp: Eliminate some GCC warnings.

	* ltmain.sh, configure.in, configure, */Makefile.*: Upgrade to
	libtool 2.2.x, which offers improved build speed and bug fixes.

2008-04-13  Marcus D. Hanwell  <marcus@cryos.org>

	* CMakeLists.txt, cmake/modules/MacroEnsureVersion.cmake,
	src/config.h.cmake: Added visibility support when using a recent GCC
	compiler.

	* src/CMakeLists.txt, src/formats/CMakeLists.txt,
	src/formats/inchi/CMakeLists.txt: Various fixes to ensure things are
	linked correctly.

	* include/openbabel/obmolecformat.h: Ensured this header includes the
	babelconfig.h header and exports its symbols.

	* src/formats/APIInterface.cpp: Export symbols.

	* src/formats/xml/cmlreactformat.cpp: Removed extra qualifier.

2008-04-10 Chris Morley
	
	* data/atomtyp.txt: revise IMPVAL entries for S. 
	Fixes bug #1938652. Patches a dilapidated program structure...
	
	* test/files/FormulaTest.smi: add S containing species to test above
	
	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi:
	add help file and remove SetOutPath "$DESKTOP" which prevented
	shortcuts starting with the current directory being that of the
	exe file. Data files were not being found.

2008-04-09  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp: Fix issue with C atoms not
	being set for OOP terms. Thanks to Bob Hanson for spotting this.

2008-04-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp: Remove inline declaration on constraints --
	prevents Python script bindings from compiling.

	* src/formats/hinformat.cpp: Read in partial charges. Fixes
	PR#1931260.

2008-04-01 Chris Morley

	* windows-vc2005/OBPythonOBF/OBPythonOBF.vcproj,
	* windows-vc2005/OpenBabelDLL/OpenBabelDLL.vcproj
	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi
	Updated in minor ways
	
	* windows-vc2005/Projects in this workspace.txt: add OBF build

2008-04-01  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/setup.py: Error in my previous commit

2008-03-31  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Fix conjugate
	gradients. (my previous commit had a bug..)

2008-03-31  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/python/setup.py: Fix for MacOSX to allow compiling against
	the contents of the build tree rather than /usr/local

2008-03-31 Chris Morley

	* src/GUI/OBGUI.cpp, src/GUI/OBGUI.h: Click on menu item copies
	plugin id to clipboard
	
2008-03-29  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldghemical.cpp,
	src/forcefields/forcefielduff.cpp,
	src/forcefields/forcefieldmmff94.cpp: Don't use Cut-off when disabled.

2008-03-29  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Implement
	methods to handle cut-offs. Added SetLineSearchType().

	* src/forcefields/forcefieldghemical.*, src/forcefields/forcefielduff.*,
	src/forcefields/forcefieldmmff94.*: Use it.
	
	* tools/obminimize.cpp: Add new options to specify cut-off and linesearch.

2008-03-29 Chris Morley

	* src/formats/inchiformat.cpp: Add output options 
	"include fixed hydrogen layer" and "include bonds to metal"
	as shortcuts to NIST's InChI functionality.
	
	* include/openbabel/obconversion.h: Make default to OUTOPTIONS,
	as IsOptions does. Makes setting most options less cumbersome.


2008-03-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/UFF.prm: Improved N sp, sp2 atom typing, suggested by Bob Hanson.

	* src/forcefields/forcefielduff.*: Many bug fixes for angle and
	torsion terms, suggested by Bob Hanson (via Jmol implementation).

	* test/files/uffresults.txt: Updated for above changes.

	* configure, configure.in, */Makefile.in: Bump to 2.2.0b5 and
	update build files.

2008-03-27  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* test/files/uffresults.txt: Update UFF results for recent bug fixes.

2008-03-27  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Always call SetCoordinates in Setup.

2008-03-27  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Working
	Newton2NumLineSearch. Used only for SteepestDescent at the moment.

2008-03-26 Chris Morley

	* include/openbabel/parsmart.h, src/parsmart.cpp:
	Fix bug #1906462. If SMARTS pattern contains [H], the matching
	now is done on n explicit hydrogen copy of the molecules. Extra bool
	in struct Pattern and mods to AllocPattern, SMARTSParser, Match.
	Have to be careful with the mods: Match is called more than
	420 times in doing a smi to smi conversion with a SMARTS filter!

2008-03-25  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefielduff.cpp: changed anglecalc.zi = ..[0] to
	... [5]. This bug was reported by Bob Hanson in mail.

2008-03-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Fix LineSearch(*,*) to respect fixed atoms.
	Don't calculate gradient in NumericalDerivative.

2008-03-24 Chris Morley

	* src/formats/gaussformat.cpp: Fix bug #1924342 by looking for
	"Multiplicity" as suggested by Richard West

2008-03-24  Noel O'Boyle  <baoilleach@gmail.com>
	
	* windows-vc2005/OBPython/openbabel.py: Removed from SVN (it is
	created with SWIG as part of the build process)

2008-03-24  Noel O'Boyle  <baoilleach@gmail.com>
	
	* scripts/openbabel-python.i: Added griddata.h

2008-03-23  Noel O'Boyle  <baoilleach@gmail.com>
	
	* scripts/python/pybel.py: First attempts at incorporating the recent
	work by Tim, Geoff and others on geometry optimisation and 3D
	coordinate generation.

2008-03-23  Noel O'Boyle  <baoilleach@gmail.com>

	* scripts/openbabel-python.i: Fix for bug reported by Florian Nigsch.
	The Python iterators didn't correctly handle the case where there was
	nothing to iterate over.

2008-03-22 Chris Morley

	* src/builder.cpp: Slightly cleaner version of yesterdays's change.
	Load data when _fragments is empty.

	* src/formats/gausscubeformat.cpp, src/formats/gausszmatformat.cpp,
	src/formats/mmcifformat.cpp, src/formats/moldenformat.cpp,
	src/formats/msmsformat.cpp:
	Add some flags for Read or Write only, remove duplicate registration
	statements(IDs are not case sensitive), edit Description so options
	appear properly in GUI.
	
	* src/formats/acrformat.cpp, src/formats/chemdrawcdx.cpp,
	src/formats/qchemformat.cpp, src/formats/xml/cdxmlformat.cpp,
	src/formats/mopacformat.cpp, src/formats/msiformat.cpp: 
	Reduce compiler warnings by commenting out unused variables.
	
	* src/obutil.cpp: Remove OBAPI from definitions; only needed in 
	declarations

	* src/ops/gen3d.cpp: Remove error wrap statements (no cerr calls in
	OBBuilder now)
	
	* src/plugin.cpp(Display): remove tab character which was giving error
	messages in wxWidgets menus.
	* windows-vc2005/OBPythonOBF: New project to build Python for OBF
	(multi-DLL) build.
	
	Update Windows OBF build files.

2008-03-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Move GetGrid to
	OBForceField to implement it for all force fields at once.

	* src/forcefields/forcefieldmmff94.*: Remove GetGrid.

	* tools/obprobe.cpp: Implement the obprobe program.

2008-03-22  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp,
	src/forcefields/forcefieldmmff94.*: Add GetGrid probe method.

	* tools/Makefile.*, tools/obprobe.cpp: Add obprobe tool, still needs
	to be implemented. (copied from obenergy)

	* tools/obminimize.cpp: Don't call ValidateGradients before
	minimizing, takes long for proteins.
	
	* data/UFF.prm: Fix SMARTS patterns for phosphorus (Bob Hanson)

	* src/forcefields/forcefielduff.cpp,
	src/forcefields/forcefieldghemical.cpp: Move loop for better
	performance.

	* src/forcefields/forcefieldmmff94.*: Make Compute() functions inline,
	some optimization to VDW Compute().

	* src/formats/atomrecord.cpp: Added using namespace std.

2008-03-22  Noel O'Boyle  <baoilleach@gmail.com>
	
	* src/formats/xml/Makefile.am: CML format can now be built without
	shared_ptr, so I removed this dependency (c.f. CM 2008-03-14)

2008-03-21  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/gausscubeformat.cpp: Applied patch from Louis Ricard and
	make it work. Read function is done, write still needs to be done.

2008-03-21 Chris Morley

	* include/openbabel/builder.h, src/builder.cpp:
	Delay parsing of fragments.txt until first use, and then
	do only once, saving in a static variable. This matters for
	gen3D where operation on multiple molecules is common.
	I know OBBuilder is still under development and is not 'my'code;
	please revert if not suitable.

2008-03-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/atomrecord.cpp: New file to handle PDB-style atom
	records -- shared between PDB and PQR formats.

	* src/formats/pdbformat.cpp: Use it.

	* src/formats/pqrformat.cpp: Initial support for reading PQR style
	files (i.e., partial charge and VDW radius supplied with
	coordinates).

	* src/formats/Makefile.am, src/formats/Makefile.in,
	src/formats/CMakeLists.txt: Updates for above.

	* src/formats/cansmilesformat.cpp: Fix for bug exposed by Avogadro
	-- sometimes we only have one atom (and no canonical order data).

	* tools/obfragment.cpp: Update to generate new OBBuilder database.

2008-03-20  Carsten Niehaus  <cniehaus@kde.org>

	* src/*.cpp: Typo fixes

	* CMakeLists.txt: Require CMake 2.4.5.
	
2008-03-16  Noel O'Boyle  <baoilleach@gmail.com>
	
	* All .cpp and .h files: Set SVN property svn:eol to native

2008-03-15  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/CMakeLists.txt: Add ops and descriptors subdirectories.

	* src/ops.cpp, src/forcefield.cpp, src/ops/loader.cpp,
	src/ops/optransform.cpp, src/descriptors/cmpdfilter.cpp,
	src/descriptors/smartsdescriptors.cpp,
	src/descriptors/groupcontrib.cpp, src/format.cpp, src/alias.cpp,
	src/forcefields/forcefieldmmff94.cpp, src/formats/MCDLformat.cpp, 
	Change to UNIX line-endings for consistency. (Some files also had
	multiple line formats.)

	* include/openbabel/math/matrix3x3.h,
	include/openbabel/forcefield.h: Move to loop form. Compiler
	loop unrolling is effective, and loops can be vectorized for
	greater speed. 

2008-03-15  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/builder.h, src/builder.cpp: Added Swap function.

2008-03-15  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/builder.h, src/builder.cpp: More robust way to
	determine OBBitVec fragment masks. This is now handled internally and 
	actually checks if a and b (in Connect) don't belong to the same
	fragment. This also fixes the previously not working commit for: 
	c1cc(CC)ccc1

	* src/CMakeLists.txt: Remove groupcontrib.cpp, added some new files.
	Not sure if the ops/ dir is included.

	* data/CMakeLists.txt: Update data files to install.

	* CMakeLists.txt: Change version to 2.2.0b4.

	* include/openbabel/builder.h, src/builder.cpp: Moved some
	functionality from Build to Connect(). OBBuilder now constructs
	molecules with a single pass trough the database.

	* src/forcefield.cpp: Remove debug output.

2008-03-14  Chris Morley

	* src/formats/gausszmatformat.cpp: add replacement function for
	strcasestr, which is not in Visual Studio's library.

	* windows-vc2005/babelconfig.h: #define strcasestr _strcasestr

	* src/formats/mdlformat.cpp, src/formats/xml/cmlformat.cpp:
	Don't output property with attribute "PartialCharges", which isn't
	relevant in these formats. 
	
	* src/formats/xml/cmlformat.cpp: Make compilation of the code that dependends
	on OBReaction(and hence shared_ptr) conditional on HAVE_SHARED_POINTER.
	Means that most of cmlformat.cpp can be used even when HAVE_SHARED_POINTER
	is not defined, and that Noel's change on 2008-03-04 can be reversed
	(although I have not done it).
	
	* src/obconversion.cpp: prevent crash and add error message when multiple
	output files are used with no input file.
	
	* include/openbabel/obutil.h: actually do the reversion, see below
	
	* src/formats/crkformat.cpp, src/formats/inchiformat.cpp: small 
	changes in descriptions (to make GI look better).
	
	* windows-vc2005/Distribution/NSISScriptToCreateInstaller.nsi:
	Add several data files
	
	Update Windows single DLL build files

2008-03-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp (Separate): Make sure to throw out any bogus
	OBChiralData. This is much preferable to crashing.

	* src/builder.cpp: Support new fragment.txt format with comments,
	etc.

	* data/*.txt: Update comments and fix minor formatting changes.

	* tools/obgen.cpp: Update to add hydrogens, cleanup geometry,
	perform weighted rotor search, etc. Should produce decent 3D
	structures with MMFF94.

2008-03-11  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/msmsformat.cpp: New format to write input files for
	MSMS (Michael Sanner Molecular Surface) calculation program,
	contributed by Ugo Varetto and the Molekel project.

	* src/formats/moldenformat.cpp: Read input from Molden files,
	contributed by Ugo.

	* src/formats/Makefile.*: Add above.

2008-03-13  Chris Morley

	* include/openbabel/obutil.h: Revert the previous change.
	In Windows there is a min function in the default namespace
	(::min compiles ok). So it is essential that std::min is used.
	It's also better not to have using std; in header files. If
	there is a problem in Avagadro it would be better to find a
	solution there. Maybe a cause for its Windows version to crash?
	 
2008-03-10  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/obutil.h: replaced std::min() with min() and put
	using namespace std at the top of the file. The compiler only gave an
	error for this when compiling avogadro, not openbabel itself.
	(windows)

	* include/openbabel/builder.h: Added OBAPI.

2008-03-10  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/cifformat.cpp: export space group if known.
	* src/formats/xml/cdxmlformat.cpp: removed a printf debug instruction.

2008-03-10  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/smilesformat.cpp: Fixes from Craig James. Allow ring closure
	bonds in SMILES to be aromatic. Also check for ring closures in
	ParseComplex.

	* test/files/aromatics.smi: Add test for ring closure bug above.

2008-03-10  Noel O'Boyle <baoilleach@gmail.com>
	
	* test/cmlreadfile.cpp: Commented out the failing test. This is a
	minor bug on Linux.

2008-03-09  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/gausscubeformat.cpp: Read/write multiple cubes. Always
	write in bohr. More error checking in write might be needed.

2008-03-06  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/mol.h, src/mol.cpp: GetEnergy(int) and GetEnergies 
	now use OBConformerData to hold the energies.

	* include/openbabel/forcefield.h, src/forcefield.cpp: GetConformers
	and GetCoordinates attatches OBConformerData to the molecule. Energies
	and Forces are set.

	* src/forcefields/forcefieldmmff94.*: minimize the number of calls to
	atoi(GetType, ...) in Setup functions. Use OBBitVec class to replace
	vector<int> where possible.

2008-03-05  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp: The recent patch from Liu Zhiguo had a bug in
	OBMol::ConnectTheDots(). Inside a loop, NextBond was called without
	checking the return value directly. The return value was being checked
	outside the loop.
	
	while (valCount < bondCount[atom->GetIdx() - 1]) {
	  maxbond = atom->NextBond(l);
	  ...
	  if (!maxbond) // Added
	    break;      // Added
	  valCount++;
	}
	if (!maxbond)
	  break;

2008-03-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/parsmart.cpp: Add protection against double-free
	bugs. Assign pointers to NULL. Addresses bug reported from 
	Avogaro PR#1897745.

	* src/forcefields/forcefieldghemical.cpp: Fix problem with VDW
	gradients -- typo of "kb" instead of "ka."

	* src/forcefields/*.cpp: Remove many (but not all) compile
	warnings from GCC. 

	* src/kekulize.cpp, src/chains.cpp: Ditto.

	* src/ring.cpp: Before running FindSSSR(), delete old data. This
	improves potential race conditions in multi-threaded client code
	(e.g., Avogadro).

2008-03-05  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/gausscubeformat.cpp: Added write function.

2008-03-04  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/chains.cpp (DeleteByteCode): Add protection against double-free
	bugs in chains.cpp. Assign pointers to NULL.

2008-03-04  Daniel Leidert <daniel.leidert@wgdd.de>

	* doc/babel.1: Fixed unkown RE macro.

2008-03-04  Noel O'Boyle <baoilleach@gmail.com>
	
	* src/formats/xml/Makefile.am: Only compile cmlformat.cpp if
	HAVE_SHARED_POINTER is true

2008-03-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/math/vector3.h, include/openbabel/base.h,
	include/openbabel/residue.h: Fixes for compiling with GCC
	-pedantic flag, thanks to Daniel Leidert.

	* tests/* : New tests for UFF, Ghemical and MMFF94 unit
	tests. Compares energies and validates gradients. Still appear to
	be some small gradient errors (although these may be due to
	numerical instability.)

	* src/forcefields/forcefield*.cpp (ValidateGradients): Return
	false when gradient errors are > 5.0% anywhere along the line.

2008-03-03  Noel O'Boyle <baoilleach@gmail.com>
	
	* tests/Makefile.am, files/3d.head.2.cml, tests/cmlreadfile.cpp,
	test/wrapper.sh: Add tests for CML scripting support

2008-03-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/dlhandler_unix.cpp: Ensure files match .so exactly. Prevents
	errors when looking for .so.dSYM files.

	* src/formats/MCDLformat.cpp: Fix GCC compile error.

	* src/formats/Makefile.am, src/formats/Makefile.in: Build rsmi and
	MCDL formats.

	* src/config.h.in: Regenerate for HAVE_BOOST symbol.

	* src/forcefields/forcefielduff.*: Fix angular
	gradients. Previous implementation mis-read paper for force
	constant.

	* tools/obminimize.cpp: Validate gradients before starting
	minimize. Useful for debugging force fields.

2008-03-02  Noel O'Boyle <baoilleach@gmail.com>
	
	* configure.in: Only use BOOST for shared_pointer if the GCC4.x
	implementation is not available.

2008-03-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/perl: Add dependency checking for libopenbabel. This
	prevents people trying to run automated CPAN tests without the
	library.

2008-03-01  Noel O'Boyle <baoilleach@gmail.com>
	
	* acinclude.m4: Set "have_boost" to "yes" so I can test it in
	configure.in
	* configure.in: Set Automake variable HAVE_SHARED_POINTER if the user
	has either of Boost or tr1/memory (gcc4.x)
	If "have_boost" is "yes" then set both the Automake variable
	USE_BOOST_FLAGS and the C++ #define USE_BOOST
	* src/formats/Makefile.am: Set the compile flags for BOOST if necessary
	Only compile chemkinformat, rxnformat and chemdrawcdxformat if
	HAVE_SHARED_POINTER is true

2008-02-29  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/generic.h (OBVectorData): New class for storing vector3
	(e.g., dipole moment, transition dipole, etc.)

2008-02-29  Chris Morley

	* src/obconversion.cpp:mods to OBConversion destructor to prevent
	input or output stream being deleted twice when there is an
	associated XMLConversion object - with CML. Possibly closer to
	fixing bugs #1815533 and #1900480.
	
	Add OBMCDL for Windows OBF build.

2008-02-29  Noel O'Boyle <baoilleach@gmail.com>

	* acinclude.m4: Just say 'not found' if BOOST not found.
	
	* configure.in: Look for BOOST and look for tr1/memory.

2008-02-29  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/openbabel-python.i: Bugfix for "[ 1904345 ] Angle, Pair,
	Torsion iterators dones not have deref() method". Turns out that I
	could have been using the __ref__() method all along. This doesn't
	seem to be in the SWIG documentation though.

2008-02-28  Marcus D. Hanwell  <marcus@cryos.org>

	* include/openbabel/grid.h, src/grid.cpp,
	include/openbabel/griddata.h, src/griddata.cpp: Fixed the
	interpolateDerivative function (hopefully). Added new functions to set
	and retrieve values from the grid using just grid indices. This should
	become the preferred way to access the grid values.

	* include/openbabel/grid.h, src/grid.cpp, src/griddata.cpp: Updated
	the grid classes to use an x, y, z index and added several new
	convenience functions using vector3 variables. Some more work is
	needed and a few extra functions to access/set grid values.

	* src/formats/gausscubeformat.cpp: Stop translating from x, y, z index
	to z, y, x as the grid classes now use the more common x, y, z index.

2008-02-28  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h, src/forcefield.cpp: Some
	improvements on the way gradients are handled. E_Bond, E_Angle, ...
	iterate over the calculations and Add the gradients to the correct
	atoms pointed to by the _gradientPtr. This pointer can then be used
	directly by line search.

	* src/forcefields/forcefieldghemical.*: Use it. GetGradient() function
	removed.
	
	* src/forcefields/forcefieldmmff94.*: Same.
	
	* src/forcefields/forcefielduff.*: Same, but UFF still uses old
	derivatives dunctions with all the vector3 objects.

2008-02-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.*: Remove redundant calls to
	Compute when calculating gradients. Remove un-needed angle/oop
	code. Problem lies elsewhere.

	* doc/Makefile.am, doc/Makefile.in: Add missing man pages and html
	documentation.

	* doc/roundtrip.1: Add missing man page. (More needed for new
	tools.)

	* test/roundtrip.cpp: Fix incorrect usage statement. Thanks to
	Daniel Leidert.

	* acinclude.m4: Add Boost detection code. Still needs addition to
	configure script.

2008-02-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/base.h, src/base.cpp: Add new GetAllData()
	function to return a vector of all OBGenericData of a given
	type. This has been long requested and is sorely
	needed. (For example, it's useful when you have multiple orbitals
	in a molecule.)

	* src/formats/gausscubeformat.cpp: Add the title of the cube as an
	attribute of the GridData.

	* tools/obprop.cpp: Update to new name of PSA descriptor.

	* configure.in, configure: Update with patch from Daniel Leidert
	for PR#1902640 and wx-config.

2008-02-25  Chris Morley

	* src/forcefield.cpp: added (double)cast to sqrt to prevent
	compiler error.
	
	* src/formats/xml/xml.cpp(XMLConversion::WriteStream): do not
	write when buffer empty. Workaround to prevent crash in CMLFormat
	which occurs when freeing libxml2 writer. I don't understand exactly
	what is happening here. I wish we had a C++ XML library!
	I hope cures bugs #1815533 and #1900480.

2008-02-25  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/msiformat.cpp: Finally fixed bond connections and
	single/double bonds. Still needs more testing.

	* src/formats/gausscubeformat.cpp: Try to skim to the end of the
	file after reading data.

2008-02-24  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldghemical.cpp: Small change for the new
	derivatives.

2008-02-24  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp: Output the number of possible rotamers when
	doing rotor search -- as a long unsigned int.
	Remove old derivatives in favor of BALL analogues.

	* include/openbabel/forcefield.h: Remove old derivatives in favor
	of BALL analogues.

	* src/forcefields/forcefieldmmff94.cpp: Ditto.
	
	* src/forcefielduff.cpp: More checks for real numbers, uncovered
	doing WeightedRotorSearch.

2008-02-24  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Added VectorAngleDerivative_BALL,
	VectorTorsionDerivative_BALL and VectorOOPDerivative_BALL.

	* src/forcefields/forcefieldmmff94.cpp: Use it. MMFF94 now has
	analytical gradients.

2008-02-23  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/rotamer.cpp (SetCurrentCoordinates): Allow -1 as a rotor
	setting -- implies do not change the dihedral angle.
	Some general code cleanups.

	* src/forcefield.cpp (WeightedRotorSearch): Fix some bugs -- check
	rotors without changing other dihedral angles and make sure to
	update the conformer structure after the search.

2008-02-22  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/atom.cpp (GetAngle): Return 0.0 for the angle if the vectors
	are too small. (The angle is ill-defined in these cases, so this
	is better than returning NaN.)

	* src/forcefield.cpp: Hunting down more divide-by-zero bugs.

	* src/forcefields/forcefieldghemical.cpp: Remove some rare
	divide-by-zero errors (e.g., when atoms are on top of each other).

	* src/forcefields/forcefielduff.cpp: Ditto.

2008-02-22 Chris Morley

	* src/mol.cpp(AssignSpinMultiplicity): Move the functionality
	recently removed from AddHydrogens() to here. Don't assign spin
	multiplicity to multi-atom molecules with no bonds.
	Molecules specified only by elemental formula from thermoformat,
	cmlformat and smilesformat seem to be handled ok.
	
	* src/formats/xml/cmlformat.cpp: handle <atomArray> occurring as
	a child of, formula> as well child of <molecule>.
	DoAtoms) Rewrite so that not confused when multiple sets of
	atom coordinates are present.
	
	* include/openbabel/forcefield.h: include float.h
	
	* windows-vc2005/babelconfig.h: add defines for IsNan and isfinite

	* src/descriptor.cpp: remove define for IsNan

	* test/files/FormulaTest.smi: correct the SMILES for carbene and
	add CH3D

2008-02-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp (WeightedRotorSearch): Check each individual
	rotor setting in isolation and use Boltzmann initial weightings.
	(*RotorSearch): Make sure to call Energy() evaluations without
	gradients.

	* src/rotamer.cpp (SetRotorToAngle): Remove unlikely (but
	possible) divide-by-zero error.

	* src/forcefields/forcefieldghemical.cpp: Fix divide-by-zero error
	in calculation of torsional term. Should be bullet-proof now.

	* src/formats/mdlformat.cpp: Fix rare crash when handling invalid
	alias records.

	* src/formats/msiformat.cpp: Remove debugging information and fix
	various bugs (e.g., dummy atoms).

2008-02-21  Marcus D. Hanwell  <marcus@cryos.org>

	* src/formats/gausscubeformat.cpp: Simplified the cube reading code,
	now more resilient to more loosely formatted cube data without the
	extra line ending at the end of each z data set.

2008-02-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp (LineSearch): Check gradients with isfinite()
	and for overly-large movements. Prevents any possible "explosions"
	or "disappearing atoms."

2008-02-18  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: When
	OBForceField::Setup was called and failed it returned false. But when 
	you did it again IsSetupNeeded() returned false and Setup() therefor
	returned true. This caused lots of crashes in avogadro's AutoOpt tool.
	OBForceField::_validSetup now checks to see if last Setup() failed, if
	so, a real Setup() is done (and will return false if failed).
	Get rid of compiler warnings: unused variable, changed function(bool
	gradients = true) into function(bool = true).
	Setup also calls UnsetSSSRPerceived() now.

	* include/openbabel/mol.h: Added OBMol::UnsetSSSRPerceived().
	Shouldn't this be called when we Add/Delete bonds.

	* src/forcefields/forcefieldmmff94.cpp: Some bug fixes related to atom
	typing of rings. Making and breaking rings in avogadro while MMFF94
	AutoOpt tool is running (in Avogadro) caused it to crash.

2008-02-17  Marcus D. Hanwell  <marcus@cryos.org>

	* src/formats/gausscubeformat.cpp: Rewrote the Gaussian cube format to
	use OpenBabel functions and data structures. Adding error checking and
	also reordered the grid data from the Gaussian order to the internal
	GridData order. Orbitals are now visible in Avogadro - success!

2008-02-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp: Removed check in AddHydrogens() to make sure hydrogens
	are added to molecules with no bonds. This check was probably put in
	to make sure you don't add hydrogens to a molecule comming from a QM
	program for which ConnectTheDots() was not called yet? 

2008-02-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/msiformat.cpp: Add new support for MSI/Accelrys
	Cerius II files. Still needs a bit of debugging, but works fine on
	single-molecule files.

	* src/formats/Makefile.*: Update for new format.

2008-02-13 Chris Morley
	
	* data/plugindefines.txt: comment out problematic entry
	
	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi:
	update this installer for the multiple DLL build
	
	Update other Windows build files.

2008-02-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/griddata.cpp, include/openbabel/griddata.h: Fix for
	documentation (and code) for GetOriginVector -- return the minimum
	x, y, and z coordinates from the grid.

2008-02-12 Chris Morley

	* src/formats/MCDLFormat.cpp: NEW FILE Converted from his Java code
	by Sergey Trepalin. There is a Java applet viewer and editor for
	this linear format at http://sourceforge.net/projects/mcdl.
	Some of the utility functions have been temporarily shoe-horned
	into this file so there is only one MCDL related file. They will be
	separated when further code for 2D layout from the applet
	becomes available.
	
	* windows-vc2005/OpenBabelOBF.sln: updated
	
2008-02-10  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/grid.cpp: Added extra check to Interpolate() to make sure no
	_val[i] is used when i >= _xdim*_ydim*_zdim, this fixes some craches
	in the Avogadro surface engine. I suspect that larger molecules have
	larger errors in their _xmin, _xmax, _ymin, ... values (error
	propagation) which causes the first check to pass, but still request 
	an invalid _val[i]

2008-02-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/Makefile.am: Make sure to link src/alias.cpp with
	mdlformat.

	* src/Makefile.am: Build alias.cpp with main libopenbabel.

	* src/formats/smilesformat.cpp: Reject SMILES molecules with 0
	atoms. Fixes bug on test suite.

	* test/files/smartsresults.txt: Update for recent SMARTS and atom
	typing changes.

2008-02-08 Chris Morley

	* src/alias.cpp: NEW FILE with AliasData::Expand(). Currently
	just a crude parsing, rather than an alias look up.
	
	* include/openbabel/alias.h: Add AliasData::Expand()
	
	* src/formats/mdlformat.cpp: Call AliasData::Expand() so that
	more A lines have chemical meaning. Probably puts writeinchi
	test back ok.
	
	Update Windows builds.

2008-02-05  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.*: New GetType(OBAtom *)
	function. This new function improves atom assignment times. This
	per atom method is also better suited for programs which allow
	interactive editing while running force field optimalization (e.g.
	Avogadro). This also allows to assign atom types to large
	molecules such as proteins.
	- Replaced old SetTypes() function with new one that makes use of the
	GetType(OBAtom*) function.
	- Added functions to calculate canonical parameter indices. (Not used
	yet)
	- Added "unsigned" where needed to get rid of compiler warnings.

	* data/mmffsup.par, data/mmffarom.par, data/mmffhdef.par,
	data/mmffsymb.par: Removed unneeded files.

	* data/Makefile.*: Removed unneeded files.

	* data/CMakeList.txt: Should MMFF94 and UFF parameter files be in
	here?

2008-02-02  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp: Bugfix for DeleteResidue()

2008-02-01 Noel O'Boyle <baoilleach@gmail.com>

	* scripts/python/examples/testpybel.py: Made test suite
	compatible with Python 2.3 (Pybel itself had no problems)

2008-01-31 Noel O'Boyle <baoilleach@gmail.com>

	* scripts/ruby/README: Updated as follows...
	(1) it's no longer necessary for the user to run ruby extconf.rb
	(2) added info on performing a local installation

2008-01-30 Joshua Ballanco <jballanc@gmail.com>

	* scripts/ruby/extconf.rb: Reworked the mkmf fix to be more
	generally applicable to *nix platforms.

2008-01-30  Geoffrey Hutchison  <babel@geoffhutchison.net>

	Fixes contributed by Liu Zhiguo via e-mail.
	* src/data.cpp (OBResidueData::AssignBonds): For pre-defined
	residues, do not check distances. (PDB files should be fairly
	clean.)
	(OBGlobalDataBase::Init): Make sure to check return value from
	OpenDatafile.

	* src/mol.cpp (operator +=): Make sure to preserve residue
	information when appending.
	(ConnectTheDots): Make sure to preserve existing bonds, e.g. from
	PDB files.

	* src/atom.cpp: (IsHBondAcceptor, IsHBondDonorH): Improvements for
	more accurate description of h-bonding. IsHBondDonorH now cleanly
	checks neighbors for IsHBondDonor rather than duplicating logic.

	* src/formats/mol2format.cpp: Don't attempt to re-perceive atom types.

2008-01-30  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/openbabel-java.i: Updated to make identical (in terms of
	includes and header files) to python wrapper. Added ignore statements
	for operators as there are just too many warnings about these.

2008-01-29  Joshua Ballanco <jballanc@gmail.com>

	* scripts/ruby/extconf.rb: Fixed an error that had Ruby 1.8.6
	using gcc to compile and link the C++ extension file. Also updated
	the method of finding the correct include directories.

2008-01-24  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/python/setup.py: Changed search method to find openbabel.so
	(may need testing on other platforms)
	* scripts/openbabel-perl.i: Updated to make identical (in terms of
	includes and header files) to python wrapper.

2008-01-24  Chris Morley
	
	* src/formats/inchiformat.cpp(WriteMolecule): remove #ifdef _WIN32
	from InChIKey code.

2008-01-24  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/Makefile.am,Makefile.in: Incorporated Rich Apodaca's fix
	for Ruby OpenBabel error message "undefined symbol: Init_openbabel"
	* scripts/openbabel-ruby.i: Updated to include same header files as
	openbabel-python, but commented out problematic obfingerprint.h. Also
	upper-cased the first letter of the templates to avoid warning
	messages, and then needed to rename template VectorData to
	VectorGenericData to avoid a conflict with another object of the same
	name in OpenBabel.

2008-01-22  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/ops.cpp, src/pointgroup.cpp, src/kekulize.cpp, src/mol.cpp,
	src/obutil.cpp, src/ring.cpp, src/atom.cpp,
	src/forcefields/forcefielduff.cpp,
	src/forcefields/forcefieldmmff94.cpp,
	src/forcefields/forcefieldghemical.cpp,
	src/formats/cansmilesformat.cpp: Fix GCC warnings, adding explicit
	braces for if/else statements, explicit () around logic
	statements, etc.

	* include/openbabel/ring.h (GetRootAtom): Return unsigned int for
	comparison with atom indexes.

	* include/openbabel/plugin.h: Remove unused parameter for warning
	reduction.

2008-01-22  Chris Morley

	* src/formats/mdlformat.cpp(WriteMolecule): CHG line output
	corrected.

2008-01-22  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/yasaraformat.cpp: replaced const char* by string.

2008-01-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/atom.h, src/atom.cpp: Handle SetType(string)
	as const as well.

	* src/obconversion.cpp: When looking for .gz extensions, make sure
	substrings go to the end of the string. This prevents problems on
	extensions like ".gzmat."

	* src/formats/gausszmatformat.cpp: New format. Supports
	reading/writing to Gaussian Z-matrix files. PR#1863673 and #1696776.

2008-01-21  Jean Brefort  <jean.brefort@normalesup.org>

	* src/math/spacegroup.cpp: fixed all g++ warnings.

2008-01-20  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/openbabel-perl,ruby,java.i: Merged in changes to
	openbabel-python.i.

2008-01-20  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/atom.h: replace char* by const char* where
	appropriate to get rid of the deprecated conversion from
	const char* to char* gcc message.
	* include/openbabel/chains.h: ditto.
	* include/openbabel/data.h: ditto.
	* include/openbabel/pointgroup.h: ditto.
	* src/atom.cpp: ditto.
	* src/chains.cpp: ditto.
	* src/data.cpp: ditto.
	* src/formats/PQSformat.cpp: ditto.
	* src/formats/chem3dformat.cpp: ditto.
	* src/formats/chemdrawcdx.cpp: ditto.
	* src/formats/crkformat.cpp: ditto.
	* src/formats/fastaformat.cpp: ditto.
	* src/formats/gromos96format.cpp: ditto.
	* src/formats/pdbformat.cpp: ditto. (don't let this format to
	modify etab).
	* src/formats/yasaraformat.cpp: ditto.
	* src/mol.cpp: ditto.
	* src/parsmart.cpp: ditto.
	* src/pointgroup.cpp: ditto.
	* src/tokenst.cpp: ditto.
	* test/roundtrip.cpp: ditto.

2008-01-20  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/cifformat.cpp: don't try to find the group when there
	is no symmetry related data in the data block.
	* src/generic.cpp: fixed a typo (bug).
	* src/math/spacegroup.cpp: return after throwing an error.

2008-01-19 Chris Morley

	* scripts/openbabel-python.i: include op.h
	* windows-vc2005/OBPython/openbabel.py: updated

	* windows-vc2005/Distribution/NSISScriptToCreateInstallerOBF.nsi:
	add installer script for  obf (multi DLL) build
	
	* windows-vc2005/OBPython/_openbabel.pyd,
	windows-vc2005/OBPython/OpenBabelDLL.dll: remove compiled files
	
	* src/plugin.cpp(ListAsVector):correct message when listing
	"plugins"
	
	* data/plugindefines.txt: remove some of the trivial examples
	
2008-01-19  Jean Brefort  <jean.brefort@normalesup.org>

	* src/math/spacegroup.cpp: accept white spaces in transforms
	descriptions in cif files. Fixes bug 1873908.

2008-01-17  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/python/pybel.py, scripts/python/examples/testpybel.py:
	Updated to use plugin descriptors. Changed to create a single instance
	of plugin descriptors and fingerprinters. Also, readfile now raises an
	IOError if the file does not exist.
	* scripts/python/examples/findcoverage.bat: Add .bat file to automate
	calculation of code coverage for pybel.

2008-01-16 Chris Morley

	* include/openbabel/obconversion.h(ReadObject),
	* include/openbabel/mol.h(CreateMolecule):
	These declarations were added by Jean, but do not seem to
	have definitions currently, which causes problems with SWIG.
	Comment them out for the time being.
	
	* include/openbabel/fingerprint.h: last commit was mistake;revert. 
	* scripts/openbabel-python.i: do not include groupcontrib.h
	* windows-vc2005/OpenBabelDLL/OpenBabelDLL.vcproj: updated
	for extra files etc.

2008-01-16  Noel O'Boyle <baoilleach@gmail.com>

	* include/openbabel/forcefield.h, plugin.h: Documentation fixes
	* src/bitvec.cpp: Documentation fixes

2008-01-16  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/openbabel-python.i: Updated to allow compilation

2008-01-15  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/base.cpp: Fix API documentation for return(1), as mentioned
	by Andrew Dalke. PR#1827795.

	* src/formats/cacheformat.cpp: Fix incorrect chemical/x-alchemy
	MIME type. PR#1822511.

	* src/formats/mol2format.cpp: Fix trailing newline
	issue. PR#1868929.

	* src/formats/chemdrawcdx.cpp: Return false when attempting to
	read past the end of the file. This solves PR#1856016.

	* include/openbabel/generic.h: Fix template issue with
	OBPairTemplate, PR#1830110.

	* src/mol.cpp (OpenBabel): Add patch from Noel PR#1840908 for
	inertial matrix speedup.

	* data/phmodel.txt, src/phmodel.cpp: Fixes from Stephen Constable,
	related to PR#1838943.

	* src/typer.cpp: Ditto. (Re-enables CorrectAromaticNitrogen to
	handle tryptophan.)

	* configure.in: Bump for 2.2.0b2 snapshot.

2008-01-11  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/Makefile.*: Add tokenst.h

2008-01-11  Michael Banck  <mbanck@gmx.net>

	* src/Makefile.am (SUBDIRS): Added descriptors and ops.
	(libopenbabel_la_SOURCES): Removed filters.cpp, gen3d.cpp,
	smartsdescriptors.cpp and groupcontrib.cpp.
	(libopenbabel_la_LIBADD [BUILD_SHARED]): Added ops/libops.la and
	descriptors/libdescriptors.la.
	(libopenbabel_la_LIBADD [!BUILD_SHARED]): Likewise.
	* src/Makefile.in: Regenerated.
	* src/descriptors/Makefile.am: New file.
	* src/descriptors/Makefile.in: Generated.
	* src/ops/Makefile.am: New file, skipping op2d.cpp for now.
	* src/ops/Makefile.in: Generated.
	* configure.in (AC_OUTPUT): Added src/descriptors/Makefile and
	src/ops/Makefile.
	* configure: Regenerated.

2008-01-11  Michael Banck  <mbanck@gmx.net>

	* include/openbabel/tokenst.h: Add newline at end of file.

2008-01-10 Chris Morley

	* src/tokenst.cpp, data.cpp, include/openbabel/base.h, data.h:
	Move OpenDataFile from data.cpp to tokenst.cpp. Move declarations
	of tokenize and Trim to a new header file tokenst.h, so that
	these utility functions can be use in modules which do not
	include the main chemistry API. Other similar utilities should
	probably be treated in the same way.
	
	* src/descriptors/cmpdfilter.cpp: NEW FILE. plugin to combine
	descriptors in --filter and similiar options.
	
	* src/ops: NEW DIRECTORY. Move src/gen3d.cpp, op2d.cpp to there.
	
	* src/ops/loader.cpp: NEW FILE for plugin to make new
	plugins from text file.
	
	* src/obconversion(LoadFormatFiles):hook for OBDefine.
	
	* include/openbabel/plugin.h: add MakeNewInstance and GetPlugin.
	In MAKE_PLUGIN check for empty ID before registering.

	* src/plugin.cpp(ListAsVector), include/openbabel/op.h(OpOptions):
	no listing if ID starts with _  Allows dummy instances.

	* src/filters.cpp, smartsfilters.cpp, groupcontrib.cpp: Moved to
	src/descriptors
	
	* include/openbabel/bitvec.h: modify Windows build macros
	
	* src/descriptor.cpp:remove an unnecessary zero check and minor
	doc changes

2008-01-09  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/rotor.h: Added Yongjin Xu's rotorKeyList class as
	OBRotorKeys, added documentation and NumKeys().

	* src/forcefield.cpp, include/openbabel/forcefield.h: Use the new
	OBRotorKeys class in SystematicRotorSearch, angle constaints work and
	renamed BondConstraint to DistanceConstraint.

2008-01-04  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/rotor.cpp: remove _fix.Clear() from OBRotorList::Clear()

2008-01-04  Michael Banck  <mbanck@gmx.net>

	* test/cml.sh: Use /bin/bash to run, not /bin/sh as "source" is a
	bashism.

2008-01-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/xyzformat.cpp: Accept non-standard XYZ files with an
	atom number rather than an element symbol in the first column.

2007-12-20  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/pdbformat.cpp: fix crash [#1846728].
	* src/math/spacegroup.cpp: add missing header.

2007-12-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/forcefield.h (HasAnalyticalGradients): New
	method to define if full analytical gradients are implemented for
	a force field. Allows code to choose analytical vs. numeric based
	on implementation. Defaults to false (i.e., implement analytical
	later).
	
	* src/forcefields/forcefieldghemical.h,
	src/forcefields/forcefielduff.h: Define that analytical gradients
	are implemented.

2007-12-18  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: Cleaned up
	header file and documentation. All private variables now start with
	"_". Added support for Molecular Dynamics.

	* src/ops.cpp: fix compiler error.

2007-12-17 Chris Morley

	Try to resynchronize.
	
	* src/obconversion.cpp, /include/openbabel/obconversion.h:
	Change return type of AddChemObject from bool to int. 
	This allows the modes with and without a queue of 2 to be
	distinguished. It is backward compatible and in fact has been
	this way previously. Consequential changes in GetChemObject() in
	obmolecformat.cpp, rxnformat.cpp, 
	
	* include/openbabel/forcefield.h(UpdateConformers, UpdateCoordinates):
	return values.
	
	* src/dock.cpp(GridDockNextPose): add return value.

	* src/atom.cpp(GetResidue): return a value
	
	* src/transform.cpp: filter mol if DoOps returns false. 

	* include/openbabel/op.h(DoOps) return false if Do() does,
	to aid filtering. Minor documentaion.
	
	* include/openbabel/plugin.h: Minor documentation.
	
	* include/openbabel/reaction.h: Add support for an Agent molecule.

	* src/gen3d.cpp: Add start and stop ErrorWrap so OBBuilder diagnostic
	code to cerr is demoted to obInfo messages.
	
	* src/oberror.cpp(StopErrorWrap):Set _inWrapStreamBuf to NULL.
	so can handle multiple molecules.
	
	* src/builder.cpp: Set dimension of molecule to 3 (CML needs this).
	Replace tabs.
	
	* src/formats/getinchi.cpp: remove OBCOMMON macro. Not needed in a format.
	
	* src/kekulize.cpp: initialize expand_ successful to supress
	compiler warning.

	* src/formats/xml/cmlformat.cpp: Minor documentation
	
	* src/formats/chemkinformat.cpp(WriteReactionLine): if molecule has
	no title use its formula.
	
	* src/formats/xml/xml.cpp(~XMLConversion):check that document has
	been terminated.
	
	Update Windows OBF build files incl some new projects making OBF files.


2007-12-15  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.cpp: Analytical gradients for all
	interactions except OOP.

2007-12-14  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.[h,cpp]: Solved problem with VDW
	interactions. H-Bond donor/acceptor reactions were not handled
	correctly.

2007-12-12  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* srd/mol.cpp: Bugfix for FindTorsion. Now checkes to make sure the
	wing atoms are not the same atom. This occurs in 3-membered rings.

	* src/forcefields/forcefieldmmff94.cpp: Improved torsion and OOP
	energies.

2007-12-11  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: Setup now checks
	if the molecule actually needs to be set up by calling IsSetupNeeded()
	itself.

2007-12-10  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/base.h: add missing headers, see debian bug #455170.
	* include/openbabel/data.h: ditto.
	* include/openbabel/lineend.h: ditto.
	* include/openbabel/mol.h: ditto.
	* include/openbabel/obconversion.h: ditto.
	* include/openbabel/obmolecformat.h: ditto.
	* include/openbabel/plugin.h: ditto.
	* include/openbabel/xml.h: ditto.
	* src/bitvec.cpp: ditto.
	* src/dlhandler_unix.cpp: ditto.
	* src/format.cpp: ditto.
	* src/math/spacegroup.cpp: ditto.
	* src/matrix.cpp: ditto.
	* src/residue.cpp: ditto.
	* src/tokenst.cpp: ditto.
	* tools/babel.cpp: ditto.

2007-12-07  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/dock.h, src/dock.cpp: Added docking class.

	* src/forcefield.cpp: Implemented X, Y, Z atom constraints.



2007-12-07  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp, include/openbabel/forcefield.h: replaced double _energy
	with vector<double> _energies.

	* src/forcefield.cpp, include/openbabel/forcefield.h: update for
	restraint code.

2007-12-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/xyzformat.cpp: Fix bogus warning about titles when
	reading past the end of the file.

	* data/element.*: Fix atom colors to match Jmol standard. (Changes
	in Fe, Co, Ni, Cu only.)

2007-12-06  Tim Vandermeersch <tim.vandermeersch@gmail.com>
	
	* src/forcefield.cpp, include/openbabel/forcefield.h: Added some log
	functions, documentation update and bond length constraints.

2007-12-05  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: OBForceField now
	defines Setup() itself. It calls the needed virtual setup functions
	which FF implementations can overwrite.
	Continue work on constraints implementation.

	* src/forcefields/*: Changes for new Setup system.
	
	* include/openbabel/atom.h: Removed old Ignore/Fixed functions.

2007-12-04  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: Updated support
	for constraints by added OBFFConstraints class.

2007-12-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/pointgroup.h, src/pointgroup.cpp: New class to
	wrap  S. Patchkovskii's brute-force 3D point group symmetry
	code. Still needs some updates from original C code, particularly
	to make it "less chatty."

	* tools/Makefile.am, tools/obsym.cpp: New tool to detect point
	group symmetry and eventually write newly "symmetrized" coordinates.

	* src/CMakeLists.txt, src/forcefields/Makefile.*: Update to remove
	MM2 forcefield from building.

2007-12-03  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: Added
	IsSetupNeeded to limit the number of calls to Setup, this improves
	performance for applications like avogadro (AutoOpt tool)

2007-12-02 Chris Morley

	* src/forcefield.cpp, include/openbabel/forcefield.h,
	forcefieldghemical.h, forcefieldmm2.h, forcefieldmmff94.h
	MakeNewInstance as pure virtual function to OBForceField
	for use in multithreaded environments.

2007-12-02  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: Added support
	to ignore and fix atoms. see doxygen documentation for more info.

2007-12-02  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp, include/openbabel/forcefield.h: Split 
	SystematicRotorSearch into ...Initialize and ...NextConformer. This 
	alows a progress bar to be displayed in avogadro.

	* src/forcefields/forcefieldghemical.cpp: Removed (commented out)
	special treatment of linear angles, wasn't workiung correctly, needs
	to be looked at...

2007-11-30  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/chains.cpp: Improve speed when clearing residue info in
	molecules with no residues.

	* include/openbabel/atom.h, src/atom.cpp: New method GetResidue()
	to optionally request no chain perception. Useful in
	builders/editors (e.g., Avogadro).

2007-11-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/Makefile.am, tools/Makefile.am: Fixes for building
	outside of the source tree.

	* test/iterators.cpp: Fix #include for OBRing. Now compiles cleanly.

2007-11-28  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/data.h, src/data.cpp: Added Allred-Rochow
	Electronegativities.

	* data/element.txt, data/element.h: idem.

	* src/forcefields/forcefieldmmff94.cpp: use it.

2007-11-28 Chris Morley

	* src/formats/smilesformat.cpp(ParseSimple): Add ForceImplH()
	to fix bug #1839589
	
	* src/mol.cpp(AssignSpinMultiplicities): Leave spinMultiplicity
	at zero (not hydrogen deficient) for atoms labelled as above.
	
	* include/openbabel/atom.h: newflag OB_ATOM_NOT_H_DEFICIENT
	with set and read functions the above.

2007-11-28  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: OBForceField::VectorTorsionDerivative() now
	returns 180 instead of 0. (was needed for MMFF94)

	* srd/forcefields/forcefieldghemical.cpp,
	src/forcefields/forcefielduff.cpp: Also changed 0 to 180 for torsions.
	Bug fix for OBForceFieldXXX::GetGradients(). (Compute() wasn't called)

	* src/forcefields/forcefieldmmff.*: More changes...

2007-11-27  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/formats/smilesformat.cpp: fixed compile error on gcc.

	* src/forcefields/forcefieldmmff94.*: Partial charges are now assigned
	correctly. 

2007-11-27 Chris Morley

	* src/formats/smilesformat.cpp: Replace ReadMolecule and add
	isNotSmiles(). Lines starting with non-SMILES characters are ignored.
	Input stream left at first non-SMILES char unless a whitespace.
	(WriteMolecule) Add options smilesonly and nonewline to ease
	rsmiformat. Not intended to be public.
	
	* src/formats/rsmiformat.cpp: New file for Reaction SMILES format

2007-11-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp (VectorOOPDerivative): Calculate forces, as
	per Tim's reference.

	* src/forcefields/forcefielduff.cpp: Use it.

	* tools/obminimize.cpp: Fix a bug to use conjugate gradients when
	-cg is specified. (Explosions seem to occur more often with CG for me.)

2007-11-27  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.*, data/mmffsymb.par: Formal
	charges are now assigned correctly.

2007-11-25  Patrick Spendrin, Christian Ehrlicher
	
	* */CMakeLists.txt: some improvements to get it running under win32

2007-11-25 Chris Morley

	* src/dlhandler_win32.cpp, generic.cpp,
	
	* include/openbabel/atomclass.h, alias.h:
	Including atomclass.h and alias.h into dlhandler_win32.cpp breaks
	code segregation (OBConversion and user interfaces do not know
	about the chemistry.) Include in generic.cpp instead and change
	the build macros used by 'native' MSVC8 build from OBCOMMON to OBAPI
	I hope this fits ok with CMake.
	
2007-11-24  Patrick Spendrin, Christian Ehrlicher
	
	* include/openbabel/atomclass.h: adding support for sstream
	
	* src/config.h.cmake: cleanup
	
	* src/dlhandler_win32.cpp: improvements for msvc
	
	* */CMakeLists.txt: improving CMake based buildsystem esp. for win32
	and mingw32 - it builds now again, though there will come more improvements
	next

2007-11-18  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldmmff94.*, data/mmffsymb.par: Atom typing 
	works!!
	
	* src/forcefield.cpp, include/openbabel/forcefield.h,
	tools/obminimize.cpp: Added DetectExplosion() to aid in debugging the
	problem with planar molecules.

	* src/typer.cpp, data/ringtyp.txt, include/openbabel/mol.h: Fixed some
	bugs and added more ringtypes.

	* src/ring.cpp, include/openbabel/ring.h: Added GetRootAtom(), returns
	the index of the root atom (e.g. O in furan, ...)

2007-11-20  Chris Morley

	* src/formats/xml/cmlformat.cpp: Now Has own WriteChemObject
	so OBReaction object can bypass OBMoleculeFormat functionality
	and be passed directly to WriteMolecule.
	WriteMolecule passes OBReaction objects to CMLReactFormat.
	Restore handling of WriteAromaticBonds which somehow got deleted. 
	
	* src/formats/xml/cmlreactformat.cpp: Changes to handling of
	options MolsNotStandalone and ReactionsNotStandalone.
	
	* src/formats/xml/xml.cpp(GetDerived): transfer IsLast flag to
	extended object when writing.
	
	* src/formats/thermoformat.cpp: Replace changes made for cmake
	by _MSC_VER as macro indicating Visual C++ compiler
	
	Update Windows VS OBF build files.

2007-11-19  Chris Morley

	* src/formats/xml/cmlformat.cpp: extra string temp variable so
	that it will compile on gcc
	
	* src/formats/xml/cmlreactformat.cpp: minor changesfrom compiler
	warnings
	
2007-11-18  Chris Morley

	* include/openbabel/alias.h: New File with OBGenericData derived
	class to hold aliases of placeholder atoms.
	
	* src/formats/mdlformat.cpp: When reading an alias block put the
	data into the AliasData class above, without trying to interpret it.
	Write alias block is the atom has unexpanded AliasData.
	
	* src/format/xml/cmlformat.cpp: had forgotten Atom4Refs
	whem doing mods for atomclasses.
	
	* src/GUI/optswx.cpp:added a test for >0 to a parameter of isspace()
	
	* include/openbabel/plugin.h: Moved CharPtrLess to be a free
	standing struct rather than embedded in OBPlugin. Less to go wrong
	with SWIG.
	

2007-11-18  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/builder.cpp: Added some documentation. Now uses OpenDataFile().

	* src/typer.cpp, include/openbabel/typer.h, data/ringtyp.txt: Added
	OBRingTyper class. Brief doxygen documentation included on use.

	* src/ring.cpp, include/openbabel/ring.h: Added GetType() and
	SetType() (see OBRingTyper)

	* include/openbabel/mol.h: Added SetRingTypesPerceived() and
	HasRingTypesPerceived() (see OBRingTyper) 

2007-11-16  Chris Morley

	* include/openbabel/atomclass.h: New file with OBAtomClassData
	class, derived from OBGenericData and that attaches to OBMol.
	
	* src/formats/smilesformat.cpp: Added capability to reads and 
	optionally write atom class e.g [CH3:1].
	
	* src/format/cmlformat.cpp: Read and write atom classes (embedded
	in atom ids, with care that they remain unique, even when atom
	classes ar not.
	
	* windows-vc2005/OpenBabelDLL/OpenBabelDLL.vcproj: updated to
	remove RDKit references.

2007-11-16  Michael Banck  <mbanck@gmx.net>

	Make libinchi.la a convenience library.

	* src/formats/inchi/Makefile.am (lib_LTLIBRARIES): Renamed to ...
	* (noinst_LTLIBRARIES): ... this.
	* src/formats/inchi/Makefile.in: Regenerated.

2007-11-16  Michael Banck  <mbanck@gmx.net>

	* src/formats/xml/Makefile.am (INCLUDES): Added
	-I$(top_builddir)/include.
	* src/formats/xml/Makefile.in: Regenerated.

2007-11-15  Chris Morley

	Update Windows build files.
	
	* src/formats/pngformat.cpp(TargetClassDescription): modify so 
	that options for OBMol appears in GUI.
	
2007-11-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/griddata.cpp, src/grid.cpp: Change to new SetLimits method
	for assigning axes, origin -- everything required by OBFloatGrid.

	* src/formats/gausscubeformat.cpp: Use it.

	* include/openbabel/Makefile.am: Make sure to install new headers
	griddata.h, op.h.

2007-11-13  Chris Morley

	* src/formats/pngformat.cpp: Remove class name in declaration
	as patch #1830826 from LI Daobing. I haven't yet found how to
	get a warning on this in Visual C++.

2007-11-12  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/Makefile.am: Add "ops" code introduced by Chris, including
	gen3d coordinate generation.

	* src/formats/chemkinformat.cpp
	(ChemKinFormat::ParseReactionLine): Added some compilation fixes
	for GCC.

	* src/formats/Makefile.* : Enable compilation of png, rxn, and
	chemkin formats.

2007-11-11  Chris Morley

	Added gen3D.cpp, a wrapper for OBBuilder to make plugin option.
	
2007-11-11  Chris Morley

	* src/formats/chemkinformat.cpp: Reading rewritten so that it
	is like other formats - separate ReadChemObject and
	ReadMolecule. Allows -f and -l options and, potentially,
	filtering of reactions.
	Many parsing changes on reading, incl allowing species names 
	containing spaces with simple input.
	On writing extra option to omit zero rate reactions, formatting
	changes and correct loss of first species in list bug.
	
	* src/formats/xml/cmlreactformat.cpp: Separate out code as
	WriteRateData.
	Add molecules to list even if to be immediately output, so that
	they can benefit from being combined with other inputs.
	If ID of a molecule is a filename, remove the path and extension.
	
2007-11-11  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/inchi/*.c, include/inchi/*.h: Import InChI v1.02b
	distribution code.

2007-11-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

        * src/Makefile.*: Updated for new files.

        * include/openbabel/base.h: New	data type for grid data.

	* include/openbabel/grid.h, src/grid.cpp: Some modifications to
	support new OBGridData class. Still needs documentation	and other
	updates. (This code is showing some bitrot.)

	* include/openbabel/griddata.h, src/gridddata.cpp: New class to
	link a OBFloatGrid as an OBGenericData	(e.g., to a molecule).

	* src/formats/gausscubeformat.cpp: New format from Molekel project
	to read coordinates and cube/grid data from Gaussian cube files.
	
	* src/formats/gromos96format.cpp: Fix typo caused by residue
	numbers as strings.

2007-11-08  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/builder.cpp: rotation works! you can now create fragment based
	structures such as: CCC(c1ccc(C(c2c(c3ccccc3)cccc2))cc1)


2007-11-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/*.cpp, include/*.h: Change to UNIX line endings for
	consistency.

2007-11-07  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/builder.cpp, include/openbabel/builder.h: OBBuilder class
	for fragment based structure generation.

	* data/fragments.txt: fragment library for OBBuilder class.

	* tools/obgen.cpp: modified to use OBBuilder

2007-11-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.cpp: Fix VDW gradients.

2007-11-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp (WeightedRotorSearch): Improved conformer
	searching. Still needs geometry optimization for each
	rotamer. (That seems to uncover a bug in OBMol/OBForceField.)

	* tools/obconformer.cpp: Switch to WeightedRotorSearch followed by
	minimization.

	* data/UFF.prm: Improved typing.

	* src/forcefields/*: Add delayed initialization. Only parse the
	parameter file when the force field is called by Setup on a
	particular molecule.

	* src/forcefields/forcefielduff.cpp: Bug fixes.

2007-11-04  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* CMakeLists.txt */CMakeLists.txt: CMake build files contributed
	via Saro Engels and Christian Ehrlicher and the KDE-Win project.

2007-11-04  Chris Morley

	* src/forcefields/forcefieldghemical.cpp(ParseParamFile):
	replaced 4 instances of reserve by resize (on ipar etc).
	Was previously crashing for me.
	
	* include/openbabel/base.h, generic.h: Moved the declaration of
	the OBGenericData base class from generic.h to base.h. This
	potentially reduces dependencies. Most of the derived classes are
	still declared in generic.h. New OBGenericData classes would be
	better with their own header files.
	
	* include/openbabel/atom.h: consequent extra #include.
	
	* src/generic.cpp: OBVibrationData wasn't copying properly. 
	Simplify so uses implicit copy constructor and assignment, which 
	are more reliable.
	
	* src/mol.cpp: remove calculation of _totalSpin from 
	AssignSpinMultiplicity. Done on demand in GetTotalSpinMultiplicity.
	
	* src/descriptor.cpp: minor edit in comment
	
2007-11-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.*: Calculates full UFF energies,
	including out-of-plane bending. Still need to finish all analytical
	gradients.

	* data/UFF.prm: Fixed atom typing rules.

2007-11-02  Michael Banck  <mbanck@gmx.net>

	* src/formats/inchi/inchi.sym: New file.

	* src/formats/inchi/Makefile.am (libinchi_la_LDFLAGS): Use inchi.sym
	to restrict the exported symbols via libtool's -export-symbols option.

	* src/formats/inchi/Makefile.in: Regenerated.

2007-11-02  Kevin Shepherd <kshepherd1@users.sourceforge.net>

	* src/formats/cifformat.cpp: Further to 1821894 this patch
	implements vincefn's suggestion i.e. "whenever reading a data name
	(tag),replace all '.' by '_'" and rolls back the previous
	changes.
	
2007-11-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefielduff.*: First pass at a UFF
	implementation. It compiles, but that's about it for now.

	* data/UFF.prm: Initial parameters taken from RDKit under BSD
	license.

	* include/openbabel/forcefield.h, src/forcefields/*: Switch to
	ipar and dpar as vectors of int and double, respectively.

2007-10-31  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/residue.h, src/residue.cpp: Switch residue
	numbers to be strings internally. Added GetNumString() to return
	the number as a string (needed for backwards compatibility).

	* src/data.cpp, src/mol.cpp: Use new residue string support. Fixes
	problems raised by David Osguthorpe.

	* src/formats/pdbformat.cpp, src/formats/*: Ditto.

	* include/openbabel/rotamer.h, src/rotamer.cpp
	(SetCurrentCoordinates): New method to set the current coordinate
	set, rather than creating new conformers. More memory-efficient
	with large conformer searching routines.

	* configure, Makefile.in, */Makefile.in: Rebuild with current
	autoconf, libtool, etc.

2007-10-28  Kevin Shepherd <kshepherd1@users.sourceforge.net>

	* src/formats/cifformat.cpp: Fix for Request ID 1821894.  This
	change allows more CIF files to be understood, allowing the
	_atom_site.XXXX varient of the naming.
	
2007-10-27  Kevin Shepherd <kshepherd1@users.sourceforge.net>

	* src/formats/alchemyformat.cpp: Altered the ReadMolecule function
	to be more flexible in handling comments and whitespace.
	This fixes Request ID 1821003, and can be tested with Test File
	Request ID 1820997.
	
2007-10-25  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/pdbformat.cpp: Fix some issues with multiple-chain
	proteins. This is likely a minor fix until David Ogusthorpe
	contributes his changes.

2007-10-24  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/torlib.[h,txt]: New torsional library data, improving conformer
        searching.

	* tools/obconformer.cpp: New tool to do real conformer searching,
	using new random and Monte Carlo searching mechanisms in OBForceField.
	
	* tools/Makefile.*: Add above.

	* include/openbabel/forcefield.h, src/forcefield.cpp: Add geometry
	optimization steps to SystematicRotorSearch and new method
	RandomRotorSearch.

2007-10-22  Chris Morley

	Implement exact fastsearch option.
	* src/transform.cpp:Add test for same number of heavy atoms if the
	internal exactmatch option set.

	* src/format/fastsearchformat.cpp: Split out ObtainTarget() to
	make code less cumbersome. Add -ae option implementation.
	
2007-10-18  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/Makefile.am: The dl Python module is not present on (many?)
	64-bit systems, so it falls back to the DLFCN module which hopefully
	*is* present. I would appreciate if someone could rerun the toolchain
	and check in Makefile.in.

2007-10-15  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/forcefield.h: New LineSearch() method to
	update a step over the entire molecule's coordinates at once. Much
	faster, since it drastically minimizes the number of energy
	evaluations.

	* src/forcefield.cpp: Implement above, plus switch SteepestDescent
	and ConjugateGradients to use it.

	* include/openbabel/mol.h, src/mol.cpp: Add SetCoordinates() call
	to set the entire coordinate system at once.

2007-10-15  Chris Morley
	
	* src/babel.cpp, src/nbabel.cpp: The last commit gave incorrect
	error messages. Correct this, add Read or Write only to output
	from Hxxx and make both Hxxx and H xxx acceptable.

2007-10-15  Chris Morley
	
	* src/babel.cpp, src/nbabel.cpp: Abort and error message when
	SetInAndOutFormats fails. Fixes bug #1813493
	
2007-10-14  Chris Morley

	* src/fingerprints/finger3.cpp, src/formats/fingerprintformat.cpp
	Change format for -xs format again: functional groups tab 
	separated. Suggested by Chris Swain.

2007-10-11  Chris Morley

	* src/format/mdlformat.cpp: Remove warning about incorrect title
	line which is sometimes output when it should not be, bug#1752435
	
	(ParseAliasText) ignore alias blocks with just "?" Suggestion by
	Rajarshi Guha
	
	* src/fingerprints/finger3.cpp, src/formats/fingerprintformat.cpp:
	Slight change in output formatting for -xs and -xu options
	
	* src/formats/xml/cmlformat.cpp: still trying to deallocate
	strings supplied by libxml2. Should be using free (not delete)
	but still not working with my compiler so still commented out.

2007-10-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

        * src/forcefield.cpp, src/forcefields/forcefieldghemical.cpp:
        Defensive programming patch contributed by Ross
        Braithwaite. Prevents divide by zero in determining torsional
        angles in planar rings.

        * include/openbabel/atom.h, src/forcefield.cpp: Add "fixed atoms."

2007-10-08  Chris Morley

	* src/formats/xml/cmlformat.cpp: removed delete statement which
	probably is responsible for bug #1792938. See 2007-08-19
	
2007-10-08  Chris Morley

	* src/formats/mdformat.cpp: output v2000 formal charge as M CHG
	statement rather than in the atom block, which is in correct when
	M RAD or M ISO apppear. Suggestion by p.mortenson bug #1796960

2007-10-05  Chris Morley

	* include/openbabel/forcefield.h: correct back to OBFPRT
	and add default definaition as nothing.

	* include/openbabel/groupcontrib.h: add back to OBDESC
	and add default definition as nothing.
	
	* src/forcefields/forcefieldmmff94.cpp: add initial value for 
	energy and comment out several unused variables to reduce compiler
	messages.
	
	* src/formats/getinchi.cpp: Now reads unquoted InChIs split with
	XML elements like <br />
	
	* src/formats/inchiformat.cpp: Make InChIKey output replace 
	normal InChI rather than adding to it. Still Windows only until
	1.02beta InChI source files added.
	
	* src/formats/smilesformat.cpp(ParseRingBond): ensured that atoms
	are added to OBChiralData::Atom4Refs in the order of the ring closure
	digits on the chiral atom rather than the atom index order. Partial
	fix for bug #1805910
	Added SetChiralityPerceived after reading. Avoids doing it again 
	in FindChiralCenters() which seems not to work sometimes, e.g. for
	CN1CCC[C@H]1c2cccnc2 and CP(O)(=O)C[C@H](O)CN

2007-10-03  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/groupcontrib.h: removed undefined OBDESC.
	* include/openbabel/op.h: removed OBOp:: from inside class
	definition.

2007-10-03  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/forcefield.h: fixed typos.

2007-09-26  Chris Morley

	* src/formats/inchiformat.cpp: forgot to change InChIKey option
	in code  to -xK.
	
	* include/zconf.h: replaced. Needed for Windows builds.

	Added Windows build files for obf (multiple DLL) build

	* windows-vc2005/babelconfig.h: replace USE_OBF by USING_DYNAMIC_LIBS

2007-09-25  Chris Morley

	Added files:
	include/openbabel/op.h: new OBOp class, plugin options
	src/ops.cpp: trivial OBOp class for centering
	src/op2d.cpp: class to add 2D coordinates using RDKit
	src/RDKitConv.cpp: conversion OBMol to RWMol
	
	* include/openbabel/descriptor.h: changeprefix macro from OBERROR
	to OBAPI.
	
	* src/descriptor.cpp(Display), src/groupcontrib.cpp(Display),
	src/smartsdescriptors:
	added form -L descriptors ID to give verbose description at runtime
	
	* include/openbabel dlhandler.h, forcefield.h, fingerprint .h,
	groupcontrib.h, xml.h, src/forcefields/*.h, src/formats/getinchi.cpp,
	canon.h: change prefix macros
	
	* include/openbabel/plugin.h(GetTypeMap): improve error return when
	there are no instances, but still a mess, but should not occur.
	
	* src/GUI/OBGUI.cpp(MakePluginsMenu): modified to use ListAs Vector
	rather than ListAs String.
	
	* src/obconversion.cpp: get rid of ill-considered USE_OBF 
	and continue with USING_DYNAMIC_LIBS.
	
	* src/transform.cpp(DoTransformations): add two hooks for OBOp
	classes
	
	* windows-vc2005/babelconfig.h: remove USE_OBF and add OBDESC
	
	* src/formats/inchiformat.cpp: change InChIKey option to -xK.
	(-xk was already used.)


2007-09-02  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/chemdrawcdx.cpp: fixed bond order for triple and
	aromatic bonds.

2007-09-20  Chris Morley

	* include/openbabel/generic.h: add new class OBRotationData
	
	* src/formats/gaussformat.cpp: (GaussianOutputFormat::ReadMolecule)
	read in vibrational and rotational data to OBGenericData classes
	
	* src/formats/xml/cmlformat.cpp:(WriteMolecule) if mol title is a
	filename, remove path and extension before outputing to id attribute
	Add WriteRotationData and WriteVibrationData (mainly for MESMER)
	
2007-09-15  Chris Morley

	* src/mol.cpp(GetTotalSpinMultiplicity): now returns correct value
	(1 for normal molecule). Improve documentation. Fixes bug
	#1793980.
	
	* include/openbabel/atom.h, mol.h: improve documentation to emphasize
	OBAtom::GetSpinMultiplicity returns 0 for normal atoms.
	
	* tools/nbabel.cpp: alternative commandline, with explicit -O option
	for output file, less flexible option placing.
	
2007-09-10  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp (Separate): More defensive programming to prevent
	crashing with incomplete OBChiralData.

	* src/formats/cansmilesformat.cpp: Add support for new OBPairData
	"canonical order" -- space terminated string of canonical atom
	labels.

	* tools/obfragment.cpp: New version which outputs XYZ files with
	atoms in canonical order matching the SMILES.

2007-09-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp: Small improvements to LineSearch and
	ConjugateGradientsTakeNSteps for performance improvement. In
	particular, reset the CG direction periodically and only print
	output every 10 steps.

	* src/forcefields/forcefieldghemical.cpp: Smarter VDW calculation
	-- minimize the number of multiplies. Not much of an improvement,
	unfortunately.

2007-09-04  Chris Morley

	* include/inchi_api.h, windows-vc2005/libinchi.dll,
	windows-vc2005/libinchi.lib: updated to v1.02 beta
	
	* src/formats/inchiformat.cpp: added option to output InChIKey.
	Windows only until the appropriate files for UNIX are installed.

2007-09-03  Chris Morley

	* include/zlib.h, iconv.h, zconf.h: Added.
	Needed for Windows build. I hope they do not interfere 
	with unix builds
	
	* src/formats/xml/cmlreactformat.cpp: Added
	
	* src/formats/pngformat.cpp: remove include to insizes.h
	
	Update Windows project files
	* windows-vc2005/OBComLn/OBComLn.vcproj
	* windows-vc2005/openbabel.sln
	* windows-vc2005/OpenBabelDLL/OpenBabelDLL.vcproj

2007-09-03  Chris Morley

	* src/formats/rxnformat.cpp: removed spurious first line of file
	which gave misleading comiler error messages. Make references to
	tr1 etc consistent with other reaction formats
	
	* include/openbabel/reaction.h: make #include "tr1/memory"
	conditional.
	
	* src/formats/pngformat.cpp: Make independent of compiler and
	platform, esp size of int. Add WriteMolecule to embed into a
	PNG file. Would be better in a program that also wrote PNG files!
	
2007-09-03  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* Merged in changes from 2.1.x branch.

2007-09-02  Chris Morley
	
	* src/formats/chemkinformat.cpp: removed warning and improved
	when writing with the simple option.

	* src/formats/freefracformat.cpp:no longer use TrimErrors which
	caused errors on Windows.

	* src/math/spacegroup.cpp: replace stdargs.h by more modern 
	cstdarg

	* src/mol.cpp(Separate): use code which does not crash when
	Atom4Refs from OBChiralData unaccountably has fewer than 4 
	elements.

2007-09-02  Jean Brefort  <jean.brefort@normalesup.org>

	* src/fingerprints/finger3.cpp: fixed compilation with g++.

2007-09-02  Jean Brefort  <jean.brefort@normalesup.org>

	* configure.in: applied patch from Klaus Heinz fixes #1786288.

2007-08-30  Chris Morley

	* data/SMARTS_InteLigand.txt: Replaced with slightly modified
	version. I think the existing file was not based on a version
	which had been modified to work within OB's SMARTS implementation.
	
	* include/openbabel/fingerprint.h and src/fingerprint.cpp: 
	added GetBit() and virtual DescribeBits()
	
	* src/fingerprints/finger3.cpp: added PatternFP::DescribeBits
	Added various Trim()s to remove CRs, which is why FP3 had not
	been working, (as Noel noticed).

	* src/formats/fingerprintformat.cpp: added options to output
	description of functional groups in a molecule (esp when using FP4)
	
	* src/math/spacegroup.cpp: included <stdarg.h>

2007-08-27  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/generic.h: make OBUnitCell use SpaceGroup.
	* include/openbabel/math/Makefile.am: add space groups.
	* include/openbabel/math/spacegroup.h: new SpaceGroup class.
	* include/openbabel/math/transform3d.h: new transform3d class (for
	use in space groups).
	* include/openbabel/math/vector3.h: add a new constructor and fix
	a const issue. 
	* src/formats/cifformat.cpp: use space groups.
	* src/generic.cpp: make OBUnitCell use SpaceGroup.
	* src/math/Makefile.am: add space groups.
	* src/math/spacegroup.cpp: new SpaceGroup class.
	* src/math/transform3d.cpp: new transform3d class.
	* src/math/vector3.cpp: fix a const issue.

2007-08-20  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/xml/Makefile.am: removed obsolete cmlreactlformat stuff.
	* src/obconversion.cpp: fix dynamic libraries use on unix.

2007-08-19  Chris Morley

	Add chemical kinetics formats. These used std::tr1::shared_ptr
	and if this is not provided as such, the USE_BOOST macro needs to be
	defined and the Boost library installed.
	
	* include/openbabel/reaction.h: modified
	* src/formats/chemkinformat.cpp: added
	* src/formats/rxnformat.cpp: modified
	* src/formats/xml/cmlreactlformat.cpp: deleted
	
	* src/formats/xml/cmlformat.cpp(WriteMolecule):Handle when 
	OBChiralData::Atom4Ref has <4 items.
	(ReadMolecule): in <property> be more flexible in where the
	title attribute can be.
	Failed attempt to delete C strings from libxml2 to solve memory
	leak bug. Still unresolved.

	* src/formats/thermoformat.cpp: add option to terminate on END,
	rather than end of file. 
	For Windows use 2 digit exponents in output.

2007-08-18  Chris Morley

	* src/formats/pngformat.cpp: add format for extracting  chemical
	structure data from PNG files.
	
2007-08-18  Chris Morley

	* src/format/copyformat: Copy whole input stream if a 
	length is not found.
	
	* src/formats/getinchi.cpp: test for negative chars to avoid
	isspace() failing.
	
	* include/openbabel/plugin.h: small documentation changes
	
	* src/GUI/optswx.cpp: remove some debugging code
	
	* src/obconversion.cpp: re-enable Compressed input for Windows. 
	Add macro to deactivate compressed output which still has 
	problems.
	Use USE_OBF rather than USING_DYNAMIC_LIBS which was ambiguous.
	Zero wInpos and wInlen in itialization list - needed for mod
	to copy format.
	ReportNumberConverted(): allow text from TargetClassDescription
	to have only a single line.
	
	* windows-vc2005/babelconfig.h: enable compression but
	deactivate compression on write. 
	Rationalize the macros 	controlling the build in Visual Studio.
	Now define SINGLE_DLL for current OpenBabelDLL build.
	For future multiDLL builds USE_OBF with macros, like OBCONV 
	appropriate for the DLL being built.

2007-08-18  Jean Brefort  <jean.brefort@normalesup.org>

	* data/Makefile.am: add space groups descriptions.
	* data/space-groups.txt: ditto.
	* data/space-groups.xsl: ditto.

2007-08-13  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/obconversion.h:b removed extra
	OBConversion:: which made compilation fail.

2007-08-10  Chris Morley

	* src/obconversion.h,.cpp: Added ALL to Option_Type enum.
	Added CopyOptions() and IsLastFile() and 
	ReportNumberConverted() functions.
	
	* src/GUI/OBGUI.cpp, tools/babel: use ReportNumberConverted
	instead of explicit code.

	* include/openbabel/obmolecformat.h: Added RegisterOptionParam
	for "append".
	
	* src/formats/obmolecformat.cpp(ReadChemObjectImpl): clear
	stream flags to prevent stalling when eof set in previous file.
	Remove some debugging code.

	* src/GUI/optswx.cpp: untabify

2007-08-04  Chris Morley

	* src/formats/mdlformat.cpp: Add ReadCollectionBlock(),
	which currently just issues a warning that COLLECTION blocks
	are not implemented. The rest of the molecule in the example
	in bug #1753217 is now read ok.
	
2007-08-04  Chris Morley

	* include/OB_BGL/ :Added interface with Boost Graph Library
	written by Gerde Menche.
	
	* include/openbabel/mol.h: modified EndAtoms() and EndBonds()
	to return after the atomas and bonds in _vatom and _vbond
	rather than the overallocated end of the vectors. Needed for
	the above.

2007-08-03  Jean Brefort  <jean.brefort@normalesup.org>

	* include/openbabel/format.h: Format::FormatsMIMEMap() must
	return a reference, otherwise, a new copy is used each time
	and no mime type is usable.

2007-07-25  Chris Morley

	* src/formats/mdlformat.cpp(MDLFormat::ReadMolecule):
	Added more tests to prevent ill-formed lines in M RAD, CHG and ISO
	lines from causing a crash. Added informative error message.
	Deficiency pointed out by Andrew Dalke.
	
	*src/descriptor.cpp, src/include/openbabel/descriptor.h:
	Add wildcard * facility and simplify - remove GenericDataCompare.
	
2007-07-06  Chris Morley

	* src/descriptor.cpp, src/include/openbabel/descriptor.h:
	Add MatchPairData() so that Property names with spaces can be
	searched for by replacing them with underscores in the filter,
	append or delete strings, as suggested by Noel.
	(GenericDataCompare): fix test for two numbers
	Added GetValues() to implement --append
	
	*src/transform.cpp: Extra option: --append (to mol title).
	Does what Joey Bedell wanted.

2007-07-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/Makefile.am, src/Makefile.in: Bump library version for 2.1.1
	release.

2007-07-05  Chris Morley

	* src/formats/inchiformat(WriteMolecule): downgraded the InChI
	message "Tetrahedral stereo info not available" to obInfo, 
	since it arises from the workings of the the opaque OB chirality
	system. Also added the molecule number for identification.
	
	* src/GUI/OBGUI.cpp, tool/babel.cpp: added &std::cout to the
	call to OBConversion::Write() for the APIInterface, because the
	previous NULL value was causing it to be ignored. This meant
	that ---errorlevel wasn't working,  as again found by Noel.
	
2007-07-05  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mdlformat.cpp (MDLFormat::ReadMolecule): Add
	additional error and warning messages, including a check if the
	atom/bond block doesn't work. Fixes crash reported by Joe Bedell,
	Sigma-Aldrich.

	* Makefile.am, Makefile.in: Skip INSTALL.Windows, deleted by
	Chris.

2007-07-04  Chris Morley

	* src/finger3.cpp: Trim firts line which decided format of
	patterns.txt. In Windows there was trailing \r which caused
	none of the patterns to be read, as found by Noel.
	
2007-07-04  Chris Morley

	* src/formats/smilesformat.cpp(CreateSmiString): call
	FindClosureBonds even when all atoms are chiral.
	(GetSmilesElement): only call GetChiralStereo when
	atom has is specified clockwise or anticlockwise, not just chiral.
	
2007-07-02  Noel O'Boyle <baoilleach@gmail.com>

	* include/oberrors.h: Fixed typo in Doxygen

2007-07-01  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* configure.in, configure, */Makefile.in: Updated with patch from
	Jean Brefort. Adds new --with-pkglibdir flag to facilitate
	packaging with versioned format directories.

2007-07-01  Chris Morley

	* src/obconversion.cpp(InstallStreamFilter): test for non-zero
	pInFormat to avoid crash with no input.
	
	* src/formats/gamessformat.cpp: Test for "$END" now works on $END$.
	Put size test first. Fixes bug #1738005 and probably #1745066.
	
	* INSTALL.Windows: deleted obsolete file
	
2007-06-30  Chris Morley

	* src/formats/smiles format.cpp(GetSmilesElement):do not always
	output atoms in 2D molecules in bracket form if the chirality
	is not specified (fix for bug #1738355)
	
	* src/GUI/OBGUI.cpp: small change to About text

2007-06-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/pdbformat.cpp: Fix for PR#1705895 -- check for
	string length before trying to read the 3rd character. Causes
	crash on Windows.

	* scripts/Makefile.*: Fix for change in Ruby build script.

	* src/formats/gaussformat.cpp (and others): Fix for
	PR#1737209. Return false for reading a molecule with no atoms. In
	these formats, empty molecules are invalid.

2007-06-25  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* tools/obenergy.cpp, tools/obminimize.cpp: Minor feature request
	1722878 to add hydrogens before running force field
	calculations for Chris Swain.

2007-06-24  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* NEWS: Update for upcoming 2.1.1 release.

	* src/formats/pdbformat.cpp (ReadMolecule): Add a new OBPairData
	for any record we don't currently parse. This way all data is
	preserved.

	* src/formats/mol2format.cpp: Fix PR#1739905. Add warning if
	elements cannot be interpreted as atom types correctly (e.g., this
	GaussView file). Instead, attempt to interpret as element names.

	* data/types.txt: Fix two HO typing errors, which masked this
	bug.

	* scripts/openbabel-ruby.i: Fix module declaration -- really
	OpenBabel.

	* tools/obminimize.cpp: Minor fix requested by Chris Swain --
	allow setting output format using -o flag.

	* tools/obfit.cpp: Add RMS output to standard error.

2007-06-23  Noel O'Boyle <baoilleach@gmail.com>
	
	* scripts/*.i (except Perl, which was already done): Added
	groupcontrib.h and updated wrapper code
	* scripts/python/Pybel stuff:
	Added calcdesc() method to Molecules for descriptor calculation 
	Added update() method to MoleculeData
	Convert to string before setting a value in MoleculeData
	Updated tests, and API docs

2007-06-15  Chris Morley
	
	* src/smartsdescriptors.cpp: Added SmartsDescriptor class to 
	allow filters based on SMARTStest (like Number of Hydrogen
	Bond Acceptors) to be defined in a single line.
	A few (SMARTS from JoelLib) are defined: HBA1 HBA2 HBD nF
	
	* src/filters.cpp: in SMARTS filter only look for single match.
	
	* src/formats/inchiformat.cpp: small change in Description()
	
2007-06-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* configure.in, configure, Makefile.*: Updates from the Cygwin
	ports project for better compatibility (e.g., shared format
	modules on Cygwin). Thanks to Yaakov of Cygwin ports and Noel.

2007-06-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/chemdrawcdx.cpp: Fix a Universal binary problem on
	Mac OS X. We cannot rely on an autoconf test since the compiler is
	run twice: for ppc and i386. Thanks to Mike Stump from Apple for
	help.

	* scripts/java/: Updated classes for vectors of rings and vectors
	of strings.

	* Makefile.am, Makefile.in: Update for Chris's removal of the
	windows directory below.

2007-06-05  Chris Morley

	* src/formats/smilesformat.cpp(PaseSmiles):ignore any char<0
	Caused crash in isspace() in Visual C++8. Fixes bug
	#1730132 for this compiler at least.

	* windows/: Delete. This should have gone before because we are
	no longer supporting VC++6.
	
	* src/GUI/OBGUI.cpp(OnGetInputFile): Delete  | wxHIDE_READONLY 
	so that compiles with v2.8.3 of wxWidgets.

2007-06-04  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/cansmilesformat.cpp (AddHydrogenToChiralCenters):
	Fix PR#1700301. Never attempt to create atoms while iterating
	through the molecule. Safer technique -- keep a list of atoms to
	add hydrogens, add in a separate step.
	(AtomIsChiral): Fix PR#1699418. When determining chiral
	information for canonical SMILES, make sure to check if the atom
	is 3D. Otherwise it will never have wedge/hash bond flags.

	* src/mol.cpp (DeleteHydrogens): Update to fix PR#1704551 with H-H
	bonds not deleted. 

	* src/formats/smilesformat.cpp: Add warning message for unmatched
	ring closures described below.

	* configure, configure.in: Bump to 2.1.1 version.

2007-06-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/smilesformat.cpp: Fix bug reported by Craig with
	un-matched ring closures. These should now always be rejected,
	since _rclose will not be empty.

	* test/files/invalid-smiles.txt: Add ring closure tests from
	Craig.

	* test/mol.cpp: Add test for H-H deletion bug reported by Donald,
	PR#1704551.
	
2007-06-01  Noel O'Boyle <baoilleach@gmail.com>

	Final changes for Windows release of OBPython 1.2

	* windows-vc2005/OBPython/setup.py: bumped version up to 1.2
	* scripts/python/pybelapi.py: updated API docs

2007-05-30  Chris Morley

	* include/openbabel/base.h(tokenize): Add \r to default
	delimiters in the two functions. Now Windows or old Mac files
	(esp data files) should be read properly. 
	Cures bug #1727333, I hope.
	
2007-05-30  Chris Morley

	* src/fingerprint.cpp(Tanimoto): return 0.0 if no bits set.
	Should cure bug #1728410.
	
2007-05-30  Chris Morley

	* include/openbabel/lineend.h: remove sync()call from destructor
	so that can delete in OBConversion's destructor after
	istreams have gone.
	
	* include/openbabel/obconversion.h, *src/obconversion.cpp
	Add InstallStreamFilter() and call from Read() and Convert().
	I hope this will cure the Windows Python bug, and is a neater
	method all round.
	 
2007-05-25  Jean Brefort  <jean.brefort@normalesup.org>

	* src/formats/xml/cdxmlformat.cpp: don't clear the molecule
	before writing. [#1725343]

2007-05-22  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* */Makefile.in: Regenerate UNIX build files.

	* src/plugin.cpp: Make sure to #include <iterator> to solve GCC
	compile problem. 

	* src/descriptor.cpp: Change _isnan to IsNan, as discussed on the
	list to solve GCC compile problem.

	* scripts/*: Updated to compile. May have removed functionality
	because of plugin changes.

	* tools/obminimize.cpp, tools/obgen.cpp, tools/obenergy.cpp:
	Switch to OBPlugin::List().

2007-05-17  Chris Morley

	* tools/obprop.cpp: mods to use new versions of logP etc.
	
	* include/openbabel/groupcontrib.h, src/goupcontrib.cpp:
	move declarations of OBGroupContib into header file and delete
	OBLogP etc which should not have been there but still compiled.
	
	* src/plugin.cpp(ListAsVector): Add support for only IDs.
	
	* include/openbabel/fingerprint.h:comment had become
	uncommented.
	
2007-05-16  Noel O'Boyle <baoilleach@gmail.com>

	* Added Chris's header changes to Makefile.am
	* Removed comments starting with //* as they confused SWIG as there
	was no matching */
	* python SWIG interface file: Included the new headers
	Note: the python bindings still don't compile.

2007-05-14  Chris Morley

	* src/obconversion.cpp(Read, Convert): Do not install a 
	FilteringInputStreambuf if stream already contains one. This
	solves my problem with multiple reads on the same input stream.
	 
2007-05-13  Chris Morley

	* src/obconversion.cpp(Read): Ensured that FilteringInputStreambuf
	is used. Previously it wasn't, which could cause errors
	except with unix reading unix files.
	 
2007-05-12  Noel O'Boyle <baoilleach@gmail.com>

	* SWIG interface files: Added template for vectors of strings
	* pybel.py: Added informats and outformats, dictionaries corresponding
	to the supported input and output formats

2007-05-11  Jean Brefort  <jean.brefort@normalesup.org>
	* include/openbabel/format.h: add missing new line (makes gcc happy).
	* include/openbabel/plugin.h: remove ClassName:: from method declaration.
	* src/formats/xml/cmlformat.cpp: ditto.

2007-05-10  Chris Morley

	* src/forcefields/forcefieldmmff94.cpp, .h: Mod for new plugin
	framework.
	Add return values to several functions, so that it would compile.

2007-05-10  Chris Morley

	Revision of plugin classes including OBFormat
	OBFormat, OBForcefield, OBFingerprint and the new
	OBDescriptor all derive from OBPlugin (not OBPluginiter)
	New files:
	include/openbabel/descriptor.h, include/openbabel/format.h
	include/openbabel/plugin.h, src/descriptor.cpp
	src/filters.cpp, src/format.cpp, src/plugin.cpp
	Removed file:
	include/openbabel/pluginiter.h
	Relocation of these and other files probably a good idea
	(incl new folder src/descriptors) but not done yet.
	class OBFormat moved out of obconversion.h, .cpp into
	its own files.

	* tools/babel.cpp: remove -F and add -L option

	* src/transform.cpp: reorganize to include new options
	--filter, --add, --delete

	* src/groupcontrib.cpp: remove OBLogP and similar classes;
	now descriptors which are instances of OBGroupContrib

	* src/formats/* : several forcefield and fingerprint files
	changed to fit new framework, obmolecformat.h to register
	new options.

	* src/formats/xml/cmlformat.cpp: if inchi is a property 
	write to <identifier> not <property> tag.

	* src/GUI/OBGUI.h, .cpp:display plugins in a menu item.

	* windows-vc2005: update Window build

2007-05-10  Noel O'Boyle <baoilleach@gmail.com>

	* pybel.py: Added support for unitcell, and deletion of OBPairData
	(need to update the tests and the API docs)

2007-05-08  Chris Morley

	* include/openbabel.h/base.h, src/base.cpp: corrected
	bug in DeleteData(OBGenericData*) which is the probable
	cause of bug #1715092. Added new function DeleteData(string)
	which makes it easier to use.
	Moved the declarations for Tokenize and Trim from mol.h to
	base.h so that they could be used more widely. Maybe there is
	an even better home.

2007-05-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/*.i: Added casting from OBGenericData to OBUnitCell.

2007-05-08  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/*.i: added a template for a vector of OBRing*
	which is required for OBMol.GetSSSR()

2007-05-08  Noel O'Boyle <baoilleach@gmail.com>

	* scripts/*.i: added a method to cast OBGenericData to
	OBPairData.
	
	* scripts/python/pybel.*: added dictionary-like support for
	accessing molecule data, and updated the tests and the API
	documentation.

2007-04-30  Chris Morley 

	* NSIS installer script: Add some extra data files, replaced
	*.* which was causing extra files to be copied, and deleted
	HKCU/SoftwareOpenBabelGUI/ on uninstall.
	As used in OpenBabel2.1.0_Windows_Installer.exe	

2007-04-26  Noel O'Boyle <baoilleach@gmail.com>

	* NSIS installer script: Updated to install the MS VC++
	run-time installer

2007-04-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* Merged 2.1.0 branch into trunk.

	* configure.in, configure: Bump to 2.2.0b1 version for trunk.
	(Not sure if we'll do 2.2 or 3.0, but we'll see.)

	* src/formats/inchi/strutil.c: Bug reported on the InChI mailing
	list.

	* src/formats/inchiformat.cpp: Bug caught during ChemSpotlight
	testing -- some files don't have chirality information (e.g., 3D
	files but with 0.0 coordinates throughout). Warn and give up.

2007-04-07  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* NEWS: Minor fixes for 2.1.0 final release.

2007-04-05  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* data/psa.txt: corrected smiles for 3-rings.

	* src/groupcontrib.cpp: call ConvertDativeBonds before assigning
	contributions, is needed for TPSA (e.g. [N](-*)(=*)=* ). Update to
	documentation.

	* include/openbabel/groupcontrib.h: documentation update.

2007-04-02  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/residue.h: Undo previous change. Rich Apodaca
	suggested some SWIG-fu instead.

	* scripts/ Update accordingly. Includes ruby changes, new README
	and examples.

2007-03-30  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/base.cpp: Additional "What's new" documentation for 2.1
	release.

	* include/openbabel/residue.h: Hide some residue names (e.g.,
	_1MG) from SWIG wrappers -- such constants are not valid symbols
	in some languages like Ruby.

	* scripts/ Update accordingly.

2007-03-29  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/: Updated interface wrappers, including new Java
	README. (Java is confirmed to work on Mac OS X.)

2007-03-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/obconversion.cpp: Make sure to always return from any
	exception. Otherwise we could crash running code.

	* src/formats/mdlformat.cpp: Avoid infinite loop in
	ParseAliasText.

	* src/formats/acrformat.cpp: Minor formatting change.

	* test/Makefile.am, test/Makefile.in, test/wrapper.sh: Add
	inchiwrite tests to suite.

	* test/inchiwrite.cpp, test/inchi.pl: Formatting to integrate into
	Perl "prove" test suite.

2007-03-26  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* tools/obprop.cpp (main): Fix PR#1688251 with while/for loop on
	CML files. Thanks to Tapani Kinnunen for the report.

	* src/formats/mol2format.cpp: Fix problem reported by Noel with
	"USER_CHARGES" appearing instead of Gasteiger.

	* src/data.cpp, src/groupcontrib.cpp: Fix doxygen warnings.

	* include/openbabel/groupcontrib.h: Documentation fixes.

	* NEWS: Minor fixes.

	* doc/*.1, doc/*.html: Documentation updates.

2007-03-24  Benoit Jacob <jacob@math.jussieu.fr>

	* include/openbabel/atom.h, src/atom.cpp: Change SetVector to
	const parameter.

2007-03-23  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* tools/obprop.cpp: Function string sequence(OBMol) was not returning
	any string.

2007-03-23  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* data/psa.txt, data/mr.txt, data/logp.txt: Small changes -- DOS
	to UNIX line endings. 

	* test/Makefile.am, test/Makefile.in: Make sure to add inchiwrite
	to compile list.

	* test/wrapper.sh: Add notes on passing arguments to "prove."

	* tools/obprop.cpp: Fix formatting problems - PR#1685879, reported
	by Tapani Kinnunen.

	* src/formats/mol2format.cpp: Add new -xl flag to output "ligand
	only" data (i.e., no residue info). Fixes PR#1683788.

	* src/formats/smilesformat.cpp: Fix PR#1680070 with output of
	chiral root (first) atoms. Really need to clean up BuildTree()
	since that if() statement is messy, but works for 2.1 release.

2007-03-23  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* data/psa.txt: Added ";heavy", fixes the logp_psa test.

2007-03-22  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp: When determining length, if two atoms are
	really close, add a small random separation (~0.1Ang). Fixed
	PR#1684479.

2007-03-22 Chris Morley

	* windows-vc2005: Simplified projects to OpenBabelDLL with driver
	programs for commandline, GUI, and Python interface.

	* include/openbabel/forcefield.h: So that the Python build
	in Windows will work, added a dummy function so that the 
	compiler will really make some functions of the templated class
	OBIter<OBForceField> which SWIG is expecting. The needs to be
	done properly, but needed to get it working for the 2.1 release. 
	
	* include/openbabel/obconversion.h and src/obconversion.cpp:
	added the patches supplied by Jerome Pansanel for providing a
	list of available formats.
	
2007-03-20 Chris Morley

	* src/formats/xml/cmlformat.cpp: Add code to write W and H in
	bondstereo. Ensure <bondStereo> is written in array form.
	
	Mods inDoAtoms to read the right set of atom coordinates.
	
	Add option to write bonds as aromatic.
	
2007-03-19  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/obconversion.cpp: Amend yesterday's change to address double
	free() bug, PR#1683541. Still don't like this, as it could leak
	the zip_istream we create.

	* src/parsmart.cpp: Fix PR#1683890 for SMARTS pattern 'x' with no
	number. Default is "at least one ring bond."

	* test/files/smartstest.txt, test/files/smartsresults.txt: Update
	for above. 'x' pattern and 'x0' pattern.

2007-03-19  Donald E. Curtis <dcurtis3@sourceforge.net>

	* src/mol.cpp: OBMol::DeleteAtom - Moved DeleteAtom to *after* the
	EndModify call.  At this point the atom is already removed from the _vatom
	vector.  OBMol::DeleteBond - Moved DeleteBond to *after* the EndModify
	call.  At this point the bond is already removed from the _vbond vector.

2007-03-18 Chris Morley

	* src/formats/mdlformat.cpp: Added support for atom aliases when
	reading. It's not much described in the main MDL specification,
	so this implementation is just adequate to handle the InChI
	samples, where for some reason, this antiquated feature is
	used in several molecules.
	
	* src/formats/inchiformat.cpp(ReadMolecule): Now reads implicit
	H isotopes.
	(WriteMolecule): rewrote option to not display routine warnings.
	
	* test/: Added inchiwrite.cpp, two NIST sample molecule sets and
	annotated results sets.
	
	* src/formats/getinchi.cpp: Added declaration of GetInChI().
	
	* src/canon.cpp (FixCisTransBonds): changed | to || in if statement
	
	* src/forcefield (GenerateCoordinates): initialize torang to 0,
	to avoid compiler warning. This variable doesn't seem to be
	doing much but please could somebody check this is ok.
	
2007-03-18  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp (Separate): Add support for copying, updating
	OBChiralData. Fixes PR#1680730.

	* src/obutil.cpp: Fix typo in yesterday's change.

	* test/logp_psa.cpp: Update to output predicted values, even if
	they match.

	* src/obconversion.cpp: Make sure to declare the new readbuf
	outside of the if() scope.

2007-03-17  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/molchrg.cpp: Add new OBPairData descriptor "PartialCharges"
	to express origin as Gasteiger charges.

	* src/formats/qchemformat.cpp, src/formats/mopacformat.cpp, 
	src/formats/gamessformat.cpp, src/formats/gaussformat.cpp: 
	Set PartialCharges descriptor to express origin as Mulliken
	charges.

	* src/formats/mol2format.cpp: Use above.

	* src/*: Strip out 0.0f and similar floating-point casts,
	extending yesterday's changes with forcefield.cpp. Defensive
	programming against similar floating-point issues.

2007-03-16  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* include/openbabel/atom.h, include/openbabel/mol.h: Fix
	PR#1626789 with large PDB files. Fixes regression to 2006-09-25
	changes supporting >2^16 atoms or bonds.
	
	* src/mol.cpp(EndModify): Ensure idx is unsigned (to match atom indexes).

	* include/openbabel/chains.h, src/chains.cpp: Make sure atomids is
	int, not short. Atom IDs can go up to a full unsigned int.

	* src/formats/chemdrawcdx.cpp: Some code cleanups, including use
	of obErrorLog.

	* src/forcefield.cpp: Fix PR#1680717. Seems to be an issue with
	floating-point roundoff. When 0.0f and similar tags were removed,
	works great.

2007-03-16  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/groupcontrib.cpp, include/openbabel/groupcontrib.h: General
	class to handle group contribution algorithms (LogP, TPSA, MR, ...).
	Also contins OBLogP, OBPSA and OBMR. Should these simple classes be
	bundled in a OBDescriptors class?

	* src/logp.cpp, src/psa.cpp, include/openbabel/logp.h,
	include/openbabel/psa.h: moved to groupcontrib.cpp/h

	* data/mr.txt: data for molecular refractivity.

	* test/logp_psa.cpp: forgot to commit.

2007-03-14  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/inchiformat.cpp, src/formats/cmlformat.cpp: Fix compile
	problems with GCC and last changes. (Return value from
	OBChiralData should be assigned to a full object.)

	* src/obconversion.cpp, src/obconversion.h: Tackle some gzip
	problems, including PR  #1617838. We need to be sure we don't try
	to gzip twice. Create a zip_istream pointer, then free it as
	needed.

	* scripts/*: Updated for recent library changes.

2007-03-13 Chris Morley
	
	* src/formats/inchiformat.cpp: Add bond stereo handling to
	ReadMolecule(). Correct 0D stereo in reading and writing.
	Remove the waring message about stereochemistry. Apart from
	a few special cases, e.g. allenes, 'either' parity, I think
	the InChI writing and reading is now ok., but still more 
	testing needed...
	TestFormat messages improved.
	
	* src/formats/xml/cmlformat.cpp: Correct handling of 0D
	atomParity on reading and writing.
	
	* src/GUI/optswx.cpp: Added documentation

2007-03-13  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefields/forcefieldghemical.cpp: Fix 1,4-scaling problem.

2007-03-13  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefields/forcefieldmmff94.cpp: Switch pow() to use
	doubles to prevent compile problems on older Linux/GCC systems.
	Switch to using OpenDatafile.

	* src/logp.cpp, src/psa.cpp: Switch to use OpenDatafile() call.

	* src/fingerprints/finger3.cpp: Likewise.

	* src/forcefields/forcefieldmm2.cpp,
	src/forcefields/forcefieldghemical.cpp: Likewise.

	* src/formats/xml/Makefile.am, src/formats/xml/Makefile.in: Fix
	problems with compiling XML formats on Mac OS X.

	* include/openbabel/Makefile.am: Make sure to include psa.h and
	logp.h in distribution.

	* src/data.cpp: Move comments to provide better documentation for
	OpenDatafile. Switch OBGlobalDatabase::Init to OpenDatafile.

	* include/openbabel/data.h: Add envvar argument to OpenDatafile.

	* config.sub, config.guess, configure, Makefile.*: Update with
	automake-1.10 and autoconf-2.61.

2007-03-13  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* tool/obminimize.cpp: added '-sd', '-cg', '-c criteria' options

	* doc/obminimize.1: update for added options (man pages for obenergy
	and obminimize are also on wiki now) 

2007-03-12  Geoffrey Hutchison  <babel@geoffhutchison.net>	

	* src/formats/mopacformat.cpp: Added patch #1676963
	for MOPAC 2007 output format. Thanks to 'dn2010.'
	(Daniil Bratashov). Solves PR#1654907.

	* src/formats/qchemformat.cpp: Added support for keywords.

	* src/formats/acrformat.cpp: New format, contributed by Daniel
	Mansfield.

	* src/formats/Makefile.am, src/formats/Makefile.in: Add acrformat.

	* src/formats/gaussformat.cpp: Add feature to write bonds,
	contributed by Daniel Mansfield.

	* src/formats/fchkformat.cpp: Add initial support from Maxim
	Fedorovsky. (Maxim's contribution also supported vibrational data
	using Eigen and matrix operations.)

	* include/openbabel/generic.h, src/generic.cpp: Include
	OBVibrationData class (even if the matrix operations to use it
	aren't in Open Babel yet).

	* tools/obprop.cpp: Additional properties, including canonical
	SMILES and InChI. Fixes request PR#1620842.

	* THANKS: Work on updates for 2.1 release.

	* NEWS: Likewise.

2007-03-11 Chris Morley
	
	* src/data/atomtyp.h: Aggressive simplification of 
	IMPVAL for oxygen and new value for Si. Read and test with
	/test/files/FormulaTest.smi. Solves bugs 1635901 and
	1474930
	
	* include/openbabel/forcefield.h: Remove unused 
	#ifndef isnan

2007-03-11 Chris Morley

	* src/formats/inchiformat.cpp: Moved handling of InChI
	options to new subroutine and it added options to 
	ReadMolecule().
	In WriteMolecule() removed deletion of OBChiralData and
	re-zeroed z coords, so that OBMol is unchanged.
	
	* src/GUI/OBGUI.cpp, OBGUI.h: Made default ostream a 
	stringstream which is written to textbox at end. Solves
	bugs 1596906 and (probably) 1669973.
	Added facility for copying output to input.
	
	* src/GUI/optswx.cpp,stdwx.cpp:Leave header files in src/GUI

2007-03-10  Tim Vandermeersch <tim.vandermeersch@gmail.com>
	
	* include/openbabel/psa.h, src/psa.cpp, src/Makefile.am,
	src/Makefile.in, data/psa.txt: Added OBPSA class.

	* tools/obprop.cpp: Added PSA property.

	* test/logp_psa.cpp: LogP and PSA test for 3 molecules.

2007-03-10 Chris Morley

	* src/formats/inchiformat.cpp(WriteMolecule): For 2D molecules
	use a modified CalculateChiralVolume() to add psueudo z
	coordinates, rather than using InChI's 2D bond stereo method.
	I think we are close to getting the InChI write stereochemistry
	right at last, but systematic checking needed.
	
	* include/openbabel/chiral.h, src/chiral.cpp
	(CalculateChiralVolume): add backwards-compatible extra 
	parameter to facilitate use of pseudo z coordinates.
	
	* src/formats/cansmilesformat.cpp(BuildCanonTree): two more
	instances of the bug corrected yesterday.

2007-03-10  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* configure, configure.in: Bump for 2.1.0b7 snapshot.

	* Doxyfile: Bump version for eventual 2.1.0 release.

	* src/*, src/formats/*: Add OBGenericData::SetOrigin calls to
	provide attribution to sources of data: file input, user input,
	perceived, etc.

	* tools/obfit.cpp: Likewise.

2007-03-09  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/logp.h, src/logp.cpp, src/Makefile.am,
	src/Makefile.in, data/LogP.txt:
	Added OBLogP class (see mailing list).

	* tools/obprop.cpp: Added LogP property.

2007-03-09 Chris Morley

	* src/formats/cansmilesformat.cpp(BuildCanonTree):The insert in 
	line 893 invalidates iterator ai. Add a line so that the subsequent
	test (outside the loop) does not crash my debug build but always
	is false - no push_back. Solves bug 1650790. I hope that Craig or
	somebody can check whether the cannonical SMILES output is still ok.

2007-03-09  Donald E. Curtis <dcurtis3@sourceforge.net>

	* include/obiter.h: added deconstructor functions.  Lack of these can
	cause problems when using the FOR_*_OF_* macros.

2007-03-08  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* forcefield.h/cpp: documentation update.

2007-03-08  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/smilesformat.cpp: Fix problem with "invented" stereo
	from 2D files -- make sure to check bond torsion ~0.0 and
	~180.0. Fixes PR#1663814.

	* doc/*.1: Initial cleanups of man pages, including new pages for
	obenergy, obminimize, and obrotamer.

	* Doxyfile-man: Update to point to new babel location.

	* src/chains.cpp: Fixing bug with chain perception related to
	PR#1626789, and 1577248. Setting visit flags skipped
	marking some atoms as members of residues.

	* test/residue.cpp: Add new tests for PR#1577248.

	* data/types.txt, data/types.h: Add Lp atom type for Sybyl based
	on PR#1672575.
	
2007-03-08  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/obutil.cpp: moved IsNan() to here. Hopefully this will eliminate
	the problem with non C99 compatible compilers.

	* src/forcefield.cpp: update documentation + small optimization
	changes.

	* include/openbabel/forcefield.h: update documentation (in progress).

	* tools/obenergy.cpp: Added man page.
	
	* tools/obminimize.cpp: Added man page.

2007-03-07 Chris Morley

	* src/for,ats/smilesformat.cpp(FixCisTransBonds): replace
	bitwise | by logical ||. 
	I guess if (v1 < 2 || v1 > 3 || v2 < 2 || v2 > 3) was meant.
	
	* include/openbabel/base.h(GetData(DataOrigin), base.cpp: 
	This was returning a reference to a local object. 
	Return a copy of it instead.
	
	* src/formats/inchiformat.cpp: Reformat Description().
	In WriteMolecule, modify bond stereo to work with new Up/Down
	usage.
	
	* src/formats/xml/cmlformat.cpp: For reading and writing,
	modify bond stereo to work with new Up/Down usage.
	Now writes bondStereo elements in array form.
	
2007-03-06  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* tools/obdoc.cpp: Update for wiki format to facilitate updates
	after 2.1 release. 

	* src/formats/pdbformat.cpp: Mark that chain/residue
	perception is not needed. Make sure that code anticipates atoms
	with no residue.

	* src/data.cpp (OBResidueData): Anticipate that some atoms will
	have no residue.

	* src/formats/mopacformat.cpp: Add keyword support, fix problem
	with writing molecules (i.e., molecule was cleared before
	cartesians written).
	
	* src/formats/smilesformat.cpp, src/formats/mol2format.cpp, 
	src/formats/xml/cmlformat.cpp, src/formats/carformat.cpp,
	src/formats/cifformat.cpp, src/formats/fastaformat.cpp,
	src/formats/gaussformat.cpp, src/formats/gamessformat.cpp,
	src/formats/alchemyformat.cpp, src/formats/cansmilesformat.cpp:
	Clean up descriptions and indentation.

2007-02-28  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/forcefield.cpp, src/forcefield.h: Cut out some compiler
	warnings from	GCC. Remove is14(), already available through
	OBAtom::IsOneFour.

	* src/forcefields/forcefieldghemical.cpp: Make sure to return from
	all functions.

	* src/dlhandler_unix.cpp: Use global loading. May improve script
	language interface on Linux.

	* include/openbabel/base.h, src/base.cpp: Support for filtering
	OBGenericData based on the source.

	* include/openbabel/generic.h, src/generic.cpp: Likewise.

	* test/files/smartsresults.txt: Fix results based on Craig's
	SMARTS changes today.

2007-02-28  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Replaced isnan() by OBIsNan(). 

2007-02-28  Craig James <cjames@emolecules.com>

	* src/formats/smilesformat.cpp: Fixed PR#1663854 "Canonical SMILES
	gives incorrect cis/trans" in cansmilesformat.cpp, also fixed the
	same problem in smilesformat.cpp.

	* Disabled SMARTS parsing of cis/trans '/' and '\', these are
	temporarily treated as ordinary single bonds, due to severe bug
	in SMARTS matching.  See PR#1663730, this is a temporary workaround.

2007-02-27  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/mol2format.cpp: Fix PR#1666406 with mis-typed Sybyl
	atom types.

	* data/types.txt, data/types.h: Likewise.

2007-02-26  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/formats/inchiformat.cpp: Fix compile problems on GCC.

	* src/mol.cpp: Fix PR#(PR#1665519) with AddHydrogens when no
	conformers are available.

	* Doxyfile: Remove babelconfig and config from header list.

	* src/patty.cpp: Mark as deprecated.

	* src/fingerprint.cpp, src/mol.cpp, src/typer.cpp
	src/parsmart.cpp, : Documentation updates.

	* include/obmolecformat.cpp, src/formats/obmolecformat.cpp,
	include/openbabel/xml.h, include/openbabel/typer.h,
	include/openbabel/parsmart.h, include/openbabel/rand.h, 
	include/openbabel/mol.h: Likewise.

2007-02-26 Chris Morley

	* src/formats/inchiformat.cpp(WriteMolecule): Mods to 0D and 2D
	stereochemistry; more to be done, work in progress.
	Added Option to use InChI options.
	
	* src/formats/mdlformat.cpp(ReadMolecule):Use the content of
	any "NAME"(case independent) property as OBMol title if there
	is not already one.
	
	* src/format/xml/cmlformat.cpp, xml.cpp(GetContent): Add Trim()
	after several cases of xmlTextReaderConstValue to remove any \n
	
	* src/obconversion.cpp(Convert): Add test for pInFormat to avoid
	crash with erroneous input.
	
	* src/mol.cpp(Separate): Copy dimension to each fragment.

2007-02-26  Donald E. Curtis <dcurtis3@sourceforge.net>

	* src/mol.cpp: OBMol::AddBond() / OBMol::DeleteBond() 
	Bond indexing starts at one.  Had to undo the change made by Tim and
	correct the fix on 2007-01-07 as a result of the bulk resizing.

2007-02-25  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/ring.cpp (FindRings): Don't return early if all atoms are
	visited. Some atoms may be in multiple rings and will be visited
	more than once on a graph traversal.

2007-02-25  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/mol.cpp: OBMol::DeleteBond()
	_vbond.erase(_vbond.begin() + bond->GetIdx());
	Since _vbond indices start at 0 and bond->Getdidx() indices start at
	1, the line is replaced by:
	_vbond.erase(_vbond.begin() + bond->GetIdx() - 1);

2007-02-25  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* include/openbabel/forcefield.h: comment out Description() (comply
	with new pluginiter).

	* obmm, obenergy, obminimize, obgen: comment out the use of
	Description().

2007-02-25 Chris Morley

	* windows-vc2005/OpenBabelDLL: Updated OpenBabelDLL.vcproj.
	Temporarily added OpenBabelDLL.dll and OpenBabelDLL.lib
	(without forcefield)
	
	* include/openbabel/kinetics.h, lineend.h, pluginiter.h:
	documentation changes.
	
2007-02-25  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/ring.cpp: Added a check in FindRings to make sure the depth is
	not larger than the number of atoms we have. (see mailing list)

2007-02-24  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Added ConjugateGradientsInitialize() and
	ConjugateGradientsTakeNSteps(). ConjugateGradients() still exists and
	uses these two new function.
	Idem for SteepestDescent.

2007-02-24  Tim Vandermeersch <tim.vandermeersch@gmail.com>
	
	* src/mol.cpp: changes OBMol::NewBond, fixes PR#1666785. AddBond() was
	resizing the _vbond vector and NewBond() used push_back to add items.
	This created a gap bewteen the bonds added by NewBond() and AddBond().
	The FOR_BONDS_OF_MOL iterator expects all bonds to be at the begin of
	the vector. Note: this also fixes the initial problem with the
	OBAngleData and OBTorsionData.

	* test/addhydrogens.cpp: added/deleted... (was used for debugging)

	* src/forcefield.cpp: changes "*logos << ..." to OBFFLog(...)

	* src/forcefields/forcefieldghemical.cpp: changes "*logos << ..." to 
	OBFFLog(...)

2007-02-23  Tim Vandermeersch <tim.vandermeersch@gmail.com>
	
	* data/ghemical.prm: Final update. All molecules from the validation
	ste are given correct atom types and charges.

	* src/forcefields/forcefieldghemical.cpp: Calculated energies comply
	with those from ghemical except for 1,4-scaling. Ring atoms are not
	always scaled in ghemical, not sure why.

	* src/forcefield.cpp: Added OBFFLog, fixes PR#1664279. (tested, but
	needs to replace all "*logos << ..." lines)
	Moved IsInSameRing from OBForceFieldMMFF94 to OBForceField.
	Test molecule from PR#1665765 minimizes correctly, but added cutoff
	accuracy to make sure.

	* tools/obmm.cpp: Added commands for DelHydrogens, GenerateCoordinates,
	SystematicRotorSearch and NumConformers.

	* include/openbabel/forcefield.cpp: Added a definition for isnan.
	(should be replaced with a better method in the math class??)

2007-02-22  Donald E. Curtis <dcurtis3@sourceforge.net>

	* src/mol.cpp: Added SetParent call to NewBond function.  Should resolve
	segfault issues related to bug 1665519.

2007-02-21  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* src/mol.cpp (NewBond): Fix PR#1665649. Make sure to set the
	parent of a newly-created bond.

	* test/mol.cpp: Add test for above.

	* src/formats/Makefile.am, src/formats/Makefile.in: Fix linking
	problems on Linux discovered by Craig.

2007-02-20  Geoffrey Hutchison  <babel@geoffhutchison.net>

	* scripts/*.i, scripts/*: Add access to OBForceField classes and methods.

	* tools/obprop.cpp: Remove "test" methods, introduced sometime
	since the last release.

	* tools/obmm.cpp: Make sure to set the OBForceField log to prevent
	crashes (e.g., PR#1664279).

	* Doxyfile: Bump version number to 2.1.0b6 for new snapshot.

	* configure.in, configure: Bump to 2.1.0b6 for new snapshot.

	* src/forcefield.cpp, tools/obrotamer.cpp: Update to use
	std::vector instead of arrays.

	* src/rotamer.h, src/rotamer.cpp: Update documentation to use
	std::vector. Fixes compile problems on Windows.
	AddRotamer(std::vector) New method for above.

	* src/base.cpp: Documentation updates.

	* src/canon.cpp, src/forcefield.cpp: Likewise.

	* include/openbabel/ring.h, generic.h, pluginiter.h, canon.h,
	forcefield.h, lineend.h: Likewise.

	* src/all.h, src/formats/all.h, src/Makefile.am, src/Makefile.in,
	src/formats/Makefile.am, src/formats/Makefile.in: Update to allow
	using precompiled headers again.

	* src/canon.cpp, src/formats/cansmilesformat.cpp: Fix crash caused
	by linking problem. CanonicalLabels() moved to the Open Babel namespace.

2007-02-20  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: UpdateCoordinates now 'knows' about conformers
	and selects the correct one before returning.

	* tools/obminimize.cpp: Implemented (was copy of obmm).

2007-02-18  Tim Vandermeersch <tim.vandermeersch@gmail.com>

	* src/forcefield.cpp: Added vector analysis methods 
